(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*                                                                             *)
(*         This file has been automatically generated by FeynRules.            *)
(*                                                                             *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)


FR$ModelInformation={
  ModelName->"Standard Model",
  Authors -> {"T Corbett"},
  Version -> "1.0",
  Date -> "",
  Institutions -> {"Niels Bohr Institute"},
  Emails -> {"corbett.t.s@gmail.com"},
  URLs -> ""};

FR$ClassesTranslation={A -> V[1], ABG -> V[2], Z -> V[3], ZBG -> V[4], W -> V[5], WBG -> V[6], G -> V[7], GBG -> V[8], ghA -> U[1], ghZ -> U[2], ghWp -> U[3], ghWm -> U[4], ghG -> U[5], ve -> F[1], vm -> F[2], vt -> F[3], e -> F[4], mu -> F[5], ta -> F[6], u -> F[7], c -> F[8], t -> F[9], d -> F[10], s -> F[11], b -> F[12], H -> S[1], HBG -> S[2], G0 -> S[3], G0BG -> S[4], GP -> S[5], GPBG -> S[6]};

FR$InteractionOrderPerturbativeExpansion={{QCD, 0}, {QED, 0}, {NP, 0}};

FR$GoldstoneList={S[3], S[4], S[5], S[6]};

(*     Declared indices    *)

IndexRange[ Index[Gluon] ] = NoUnfold[ Range[ 8 ] ]

IndexRange[ Index[SU2W] ] = Range[ 3 ]

IndexRange[ Index[Generation] ] = Range[ 3 ]

IndexRange[ Index[Colour] ] = NoUnfold[ Range[ 3 ] ]

IndexRange[ Index[SU2D] ] = Range[ 2 ]

(*     Declared particles    *)

M$ClassesDescription = {
V[1] == {
    SelfConjugate -> True,
    PropagatorType -> Sine,
    PropagatorArrow -> None,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "A" },

V[2] == {
    SelfConjugate -> True,
    PropagatorType -> Sine,
    PropagatorArrow -> None,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "ABG" },

V[3] == {
    SelfConjugate -> True,
    PropagatorType -> Sine,
    PropagatorArrow -> None,
    Mass -> MZbar,
    Indices -> {},
    PropagatorLabel -> "Z" },

V[4] == {
    SelfConjugate -> True,
    PropagatorType -> Sine,
    PropagatorArrow -> None,
    Mass -> MZbar,
    Indices -> {},
    PropagatorLabel -> "ZBG" },

V[5] == {
    SelfConjugate -> False,
    QuantumNumbers -> {Q},
    PropagatorType -> Sine,
    PropagatorArrow -> Forward,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "W" },

V[6] == {
    SelfConjugate -> False,
    QuantumNumbers -> {Q},
    PropagatorType -> Sine,
    PropagatorArrow -> Forward,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "WBG" },

V[7] == {
    SelfConjugate -> True,
    PropagatorType -> Cycles,
    PropagatorArrow -> None,
    Mass -> 0,
    Indices -> {Index[Gluon]},
    PropagatorLabel -> "G" },

V[8] == {
    SelfConjugate -> True,
    PropagatorType -> Cycles,
    PropagatorArrow -> None,
    Mass -> 0,
    Indices -> {Index[Gluon]},
    PropagatorLabel -> "GBG" },

U[1] == {
    SelfConjugate -> False,
    QuantumNumbers -> {GhostNumber},
    PropagatorType -> GhostDash,
    PropagatorArrow -> Forward,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "ghA" },

U[2] == {
    SelfConjugate -> False,
    QuantumNumbers -> {GhostNumber},
    PropagatorType -> GhostDash,
    PropagatorArrow -> Forward,
    Mass -> MZbar,
    Indices -> {},
    PropagatorLabel -> "ghZ" },

U[3] == {
    SelfConjugate -> False,
    QuantumNumbers -> {GhostNumber, Q},
    PropagatorType -> GhostDash,
    PropagatorArrow -> Forward,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "ghWp" },

U[4] == {
    SelfConjugate -> False,
    QuantumNumbers -> {GhostNumber, -Q},
    PropagatorType -> GhostDash,
    PropagatorArrow -> Forward,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "ghWm" },

U[5] == {
    SelfConjugate -> False,
    QuantumNumbers -> {GhostNumber},
    PropagatorType -> GhostDash,
    PropagatorArrow -> Forward,
    Mass -> 0,
    Indices -> {Index[Gluon]},
    PropagatorLabel -> "ghG" },

F[1] == {
    SelfConjugate -> False,
    QuantumNumbers -> {LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "ve" },

F[2] == {
    SelfConjugate -> False,
    QuantumNumbers -> {LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "vm" },

F[3] == {
    SelfConjugate -> False,
    QuantumNumbers -> {LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> 0,
    Indices -> {},
    PropagatorLabel -> "vt" },

F[4] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q, LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MEbar,
    Indices -> {},
    PropagatorLabel -> "e" },

F[5] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q, LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MMUbar,
    Indices -> {},
    PropagatorLabel -> "mu" },

F[6] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q, LeptonNumber},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MTAbar,
    Indices -> {},
    PropagatorLabel -> "ta" },

F[7] == {
    SelfConjugate -> False,
    QuantumNumbers -> {(2*Q)/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MUbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "u" },

F[8] == {
    SelfConjugate -> False,
    QuantumNumbers -> {(2*Q)/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MCbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "c" },

F[9] == {
    SelfConjugate -> False,
    QuantumNumbers -> {(2*Q)/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MTbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "t" },

F[10] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MDbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "d" },

F[11] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MSbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "s" },

F[12] == {
    SelfConjugate -> False,
    QuantumNumbers -> {-Q/3},
    PropagatorType -> Straight,
    PropagatorArrow -> Forward,
    Mass -> MBbar,
    Indices -> {Index[Colour]},
    PropagatorLabel -> "b" },

S[1] == {
    SelfConjugate -> True,
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MHbar,
    Indices -> {},
    PropagatorLabel -> "H" },

S[2] == {
    SelfConjugate -> True,
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MHbar,
    Indices -> {},
    PropagatorLabel -> "HBG" },

S[3] == {
    SelfConjugate -> True,
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MZbar,
    Indices -> {},
    PropagatorLabel -> "G0" },

S[4] == {
    SelfConjugate -> True,
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MZbar,
    Indices -> {},
    PropagatorLabel -> "G0BG" },

S[5] == {
    SelfConjugate -> False,
    QuantumNumbers -> {Q},
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "GP" },

S[6] == {
    SelfConjugate -> False,
    QuantumNumbers -> {Q},
    PropagatorType -> ScalarDash,
    PropagatorArrow -> None,
    Mass -> MWbar,
    Indices -> {},
    PropagatorLabel -> "GPBG" }
}


(*        Definitions       *)

GaugeXi[ V[1] ] = xiBG;
GaugeXi[ V[2] ] = xiBG;
GaugeXi[ V[3] ] = xiBG;
GaugeXi[ V[4] ] = xiBG;
GaugeXi[ V[5] ] = xiBG;
GaugeXi[ V[6] ] = xiBG;
GaugeXi[ V[7] ] = xiGBG;
GaugeXi[ V[8] ] = xiGBG;
GaugeXi[ U[1] ] = xiBG;
GaugeXi[ U[2] ] = xiBG;
GaugeXi[ U[3] ] = xiBG;
GaugeXi[ U[4] ] = xiBG;
GaugeXi[ U[5] ] = xiGBG;
GaugeXi[ S[1] ] = 1;
GaugeXi[ S[2] ] = 1;
GaugeXi[ S[3] ] = xiBG;
GaugeXi[ S[4] ] = xiBG;
GaugeXi[ S[5] ] = xiBG;
GaugeXi[ S[6] ] = xiBG;

MZbar[ ___ ] := MZbar;
MWbar[ ___ ] := MWbar;
MEbar[ ___ ] := MEbar;
MMUbar[ ___ ] := MMUbar;
MTAbar[ ___ ] := MTAbar;
MUbar[ ___ ] := MUbar;
MCbar[ ___ ] := MCbar;
MTbar[ ___ ] := MTbar;
MDbar[ ___ ] := MDbar;
MSbar[ ___ ] := MSbar;
MBbar[ ___ ] := MBbar;
MHbar[ ___ ] := MHbar;


TheLabel[ V[7, {__}] ] := TheLabel[V[7]];
TheLabel[ V[8, {__}] ] := TheLabel[V[8]];
TheLabel[ U[5, {__}] ] := TheLabel[U[5]];
TheLabel[ F[7, {__}] ] := TheLabel[F[7]];
TheLabel[ F[8, {__}] ] := TheLabel[F[8]];
TheLabel[ F[9, {__}] ] := TheLabel[F[9]];
TheLabel[ F[10, {__}] ] := TheLabel[F[10]];
TheLabel[ F[11, {__}] ] := TheLabel[F[11]];
TheLabel[ F[12, {__}] ] := TheLabel[F[12]];


(*      Couplings (calculated by FeynRules)      *)

M$CouplingMatrices = {

C[ S[3] , S[3] , S[3] , S[3] ] == {{(3*I)*(3*cH*vev^2 + 2*lam*(-1 + cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[3] , S[4] ] == {{(3*I)*(3*cH*vev^2 + 2*lam*(-1 + cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[4] , S[4] ] == {{I*gc3*(12*lam*(-1 + cHD*vev^2) + vev^2*(18*cH - (2*cHB*g1^2 + 2*g2*(cHWB*g1 + cHW*g2) + cHD*(g1^2 + g2^2))*xiBG)), 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}, {(2*I)*(4*cHbox - cHD)*gc3, 0}},

C[ S[3] , S[4] , S[4] , S[4] ] == {{(3*I)*(3*cH*vev^2 + 2*lam*(-1 + cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[4] , S[4] , S[4] , S[4] ] == {{(3*I)*(3*cH*vev^2 + 2*lam*(-1 + cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[5] , -S[5] ] == {{(2*I)*gc6*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc6, 0}, {I*(4*cHbox - cHD)*gc6, 0}, {I*(4*cHbox - cHD)*gc6, 0}, {I*(4*cHbox - cHD)*gc6, 0}, {0, 0}},

C[ S[3] , S[4] , S[5] , -S[5] ] == {{(2*I)*gc7*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc7, 0}, {I*(4*cHbox - cHD)*gc7, 0}, {I*(4*cHbox - cHD)*gc7, 0}, {I*(4*cHbox - cHD)*gc7, 0}, {0, 0}},

C[ S[4] , S[4] , S[5] , -S[5] ] == {{I*gc8*(12*cH*vev^2 + 4*lam*(-2 + cHD*vev^2) + g2^2*(-2 + cHD*vev^2 - 8*cHW*vev^2)*xiBG), 0}, {0, 0}, {(2*I)*(4*cHbox - cHD)*gc8, 0}, {(2*I)*(4*cHbox - cHD)*gc8, 0}, {(2*I)*(4*cHbox - cHD)*gc8, 0}, {(2*I)*(4*cHbox - cHD)*gc8, 0}, {0, 0}},

C[ S[5] , S[5] , -S[5] , -S[5] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}},

C[ S[3] , S[3] , -S[5] , S[6] ] == {{(2*I)*gc10*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc10, 0}, {I*(4*cHbox - cHD)*gc10, 0}, {I*(4*cHbox - cHD)*gc10, 0}, {I*(4*cHbox - cHD)*gc10, 0}, {0, 0}},

C[ S[3] , S[4] , -S[5] , S[6] ] == {{I*gc11*(24*cH*vev^2 + 8*lam*(-2 + cHD*vev^2) + g2^2*(2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG), 0}, {0, 0}, {(4*I)*(4*cHbox - cHD)*gc11, 0}, {(4*I)*(4*cHbox - cHD)*gc11, 0}, {(4*I)*(4*cHbox - cHD)*gc11, 0}, {(4*I)*(4*cHbox - cHD)*gc11, 0}, {0, 0}},

C[ S[4] , S[4] , -S[5] , S[6] ] == {{(2*I)*gc12*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc12, 0}, {I*(4*cHbox - cHD)*gc12, 0}, {I*(4*cHbox - cHD)*gc12, 0}, {I*(4*cHbox - cHD)*gc12, 0}, {0, 0}},

C[ S[5] , -S[5] , -S[5] , S[6] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}},

C[ -S[5] , -S[5] , S[6] , S[6] ] == {{I*gc14*(-8*lam + 12*cH*vev^2 + (2*cHWB*g1*g2*vev^2 + g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(1 + cHD*vev^2 + 2*cHW*vev^2))*xiBG), 0}, {(8*I)*cHbox*gc14, 0}, {(2*I)*(2*cHbox - cHD)*gc14, 0}, {(2*I)*(2*cHbox - cHD)*gc14, 0}, {(2*I)*(2*cHbox - cHD)*gc14, 0}, {(2*I)*(2*cHbox - cHD)*gc14, 0}, {(8*I)*cHbox*gc14, 0}},

C[ S[3] , S[3] , S[5] , -S[6] ] == {{(2*I)*gc15*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc15, 0}, {I*(4*cHbox - cHD)*gc15, 0}, {I*(4*cHbox - cHD)*gc15, 0}, {I*(4*cHbox - cHD)*gc15, 0}, {0, 0}},

C[ S[3] , S[4] , S[5] , -S[6] ] == {{I*gc16*(24*cH*vev^2 + 8*lam*(-2 + cHD*vev^2) + g2^2*(2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG), 0}, {0, 0}, {(4*I)*(4*cHbox - cHD)*gc16, 0}, {(4*I)*(4*cHbox - cHD)*gc16, 0}, {(4*I)*(4*cHbox - cHD)*gc16, 0}, {(4*I)*(4*cHbox - cHD)*gc16, 0}, {0, 0}},

C[ S[4] , S[4] , S[5] , -S[6] ] == {{(2*I)*gc17*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc17, 0}, {I*(4*cHbox - cHD)*gc17, 0}, {I*(4*cHbox - cHD)*gc17, 0}, {I*(4*cHbox - cHD)*gc17, 0}, {0, 0}},

C[ S[5] , S[5] , -S[5] , -S[6] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}},

C[ S[3] , S[3] , S[6] , -S[6] ] == {{I*gc19*(12*cH*vev^2 + 4*lam*(-2 + cHD*vev^2) - (2*(2*cHB + cHD)*g1^2*vev^2 + 4*cHWB*g1*g2*vev^2 + g2^2*(2 + cHD*vev^2 + 8*cHW*vev^2))*xiBG), 0}, {0, 0}, {(2*I)*(4*cHbox - cHD)*gc19, 0}, {(2*I)*(4*cHbox - cHD)*gc19, 0}, {(2*I)*(4*cHbox - cHD)*gc19, 0}, {(2*I)*(4*cHbox - cHD)*gc19, 0}, {0, 0}},

C[ S[3] , S[4] , S[6] , -S[6] ] == {{(2*I)*gc20*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc20, 0}, {I*(4*cHbox - cHD)*gc20, 0}, {I*(4*cHbox - cHD)*gc20, 0}, {I*(4*cHbox - cHD)*gc20, 0}, {0, 0}},

C[ S[4] , S[4] , S[6] , -S[6] ] == {{(2*I)*gc21*(3*cH*vev^2 + lam*(-2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc21, 0}, {I*(4*cHbox - cHD)*gc21, 0}, {I*(4*cHbox - cHD)*gc21, 0}, {I*(4*cHbox - cHD)*gc21, 0}, {0, 0}},

C[ S[5] , -S[5] , S[6] , -S[6] ] == {{(-I)*gc22*(16*lam - 24*cH*vev^2 + (2*cHWB*g1*g2*vev^2 + g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(1 + cHD*vev^2 + 6*cHW*vev^2))*xiBG), 0}, {(4*I)*(2*cHbox - cHD)*gc22, 0}, {(16*I)*cHbox*gc22, 0}, {(4*I)*(2*cHbox - cHD)*gc22, 0}, {(4*I)*(2*cHbox - cHD)*gc22, 0}, {(16*I)*cHbox*gc22, 0}, {(4*I)*(2*cHbox - cHD)*gc22, 0}},

C[ -S[5] , S[6] , S[6] , -S[6] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}},

C[ S[5] , S[5] , -S[6] , -S[6] ] == {{I*gc24*(-8*lam + 12*cH*vev^2 + (2*cHWB*g1*g2*vev^2 + g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(1 + cHD*vev^2 + 2*cHW*vev^2))*xiBG), 0}, {(8*I)*cHbox*gc24, 0}, {(2*I)*(2*cHbox - cHD)*gc24, 0}, {(2*I)*(2*cHbox - cHD)*gc24, 0}, {(2*I)*(2*cHbox - cHD)*gc24, 0}, {(2*I)*(2*cHbox - cHD)*gc24, 0}, {(8*I)*cHbox*gc24, 0}},

C[ S[5] , S[6] , -S[6] , -S[6] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}},

C[ S[6] , S[6] , -S[6] , -S[6] ] == {{(2*I)*(-2*lam + 3*cH*vev^2), 0}, {(4*I)*cHbox, 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {I*(2*cHbox - cHD), 0}, {(4*I)*cHbox, 0}},

C[ S[3] , S[3] , S[1] , S[1] ] == {{(-I)*gc27*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc27, 0}, {(-2*I)*cHbox*gc27, 0}, {(-2*I)*cHbox*gc27, 0}, {(-2*I)*cHbox*gc27, 0}, {(-2*I)*cHbox*gc27, 0}, {I*cHD*gc27, 0}},

C[ S[3] , S[4] , S[1] , S[1] ] == {{(-I)*gc28*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc28, 0}, {(-2*I)*cHbox*gc28, 0}, {(-2*I)*cHbox*gc28, 0}, {(-2*I)*cHbox*gc28, 0}, {(-2*I)*cHbox*gc28, 0}, {I*cHD*gc28, 0}},

C[ S[4] , S[4] , S[1] , S[1] ] == {{(-I)*gc29*(18*cH*vev^2 + lam*(-4 - 8*cHbox*vev^2 + 4*cHD*vev^2) - (2*cHWB*g1*g2*vev^2 + g1^2*(1 + 2*cHB*vev^2 + 2*cHbox*vev^2) + g2^2*(1 + 2*cHbox*vev^2 + 2*cHW*vev^2))*xiBG), 0}, {(2*I)*cHD*gc29, 0}, {(-4*I)*cHbox*gc29, 0}, {(-4*I)*cHbox*gc29, 0}, {(-4*I)*cHbox*gc29, 0}, {(-4*I)*cHbox*gc29, 0}, {(2*I)*cHD*gc29, 0}},

C[ S[5] , -S[5] , S[1] , S[1] ] == {{(2*I)*gc30*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc30, 0}, {I*(4*cHbox - cHD)*gc30, 0}, {I*(4*cHbox - cHD)*gc30, 0}, {I*(4*cHbox - cHD)*gc30, 0}, {0, 0}},

C[ -S[5] , S[6] , S[1] , S[1] ] == {{(2*I)*gc31*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc31, 0}, {I*(4*cHbox - cHD)*gc31, 0}, {I*(4*cHbox - cHD)*gc31, 0}, {I*(4*cHbox - cHD)*gc31, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , S[1] ] == {{(2*I)*gc32*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc32, 0}, {I*(4*cHbox - cHD)*gc32, 0}, {I*(4*cHbox - cHD)*gc32, 0}, {I*(4*cHbox - cHD)*gc32, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , S[1] ] == {{I*gc33*(36*cH*vev^2 - 4*lam*(2 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(-2 - 4*cHbox*vev^2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG), 0}, {0, 0}, {(2*I)*(4*cHbox - cHD)*gc33, 0}, {(2*I)*(4*cHbox - cHD)*gc33, 0}, {(2*I)*(4*cHbox - cHD)*gc33, 0}, {(2*I)*(4*cHbox - cHD)*gc33, 0}, {0, 0}},

C[ S[1] , S[1] , S[1] , S[1] ] == {{(3*I)*(15*cH*vev^2 + lam*(-2 - 8*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[1] , S[2] ] == {{(-I)*gc35*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc35, 0}, {(-2*I)*cHbox*gc35, 0}, {(-2*I)*cHbox*gc35, 0}, {(-2*I)*cHbox*gc35, 0}, {(-2*I)*cHbox*gc35, 0}, {I*cHD*gc35, 0}},

C[ S[3] , S[4] , S[1] , S[2] ] == {{(-I)*gc36*(36*cH*vev^2 - 8*lam*(1 + 2*cHbox*vev^2 - cHD*vev^2) + (6*cHWB*g1*g2*vev^2 + g1^2*(1 + 6*cHB*vev^2 + 2*cHbox*vev^2 + 2*cHD*vev^2) + g2^2*(1 + 2*cHbox*vev^2 + 2*cHD*vev^2 + 6*cHW*vev^2))*xiBG), 0}, {(4*I)*cHD*gc36, 0}, {(-8*I)*cHbox*gc36, 0}, {(-8*I)*cHbox*gc36, 0}, {(-8*I)*cHbox*gc36, 0}, {(-8*I)*cHbox*gc36, 0}, {(4*I)*cHD*gc36, 0}},

C[ S[4] , S[4] , S[1] , S[2] ] == {{(-I)*gc37*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc37, 0}, {(-2*I)*cHbox*gc37, 0}, {(-2*I)*cHbox*gc37, 0}, {(-2*I)*cHbox*gc37, 0}, {(-2*I)*cHbox*gc37, 0}, {I*cHD*gc37, 0}},

C[ S[5] , -S[5] , S[1] , S[2] ] == {{(2*I)*gc38*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc38, 0}, {I*(4*cHbox - cHD)*gc38, 0}, {I*(4*cHbox - cHD)*gc38, 0}, {I*(4*cHbox - cHD)*gc38, 0}, {0, 0}},

C[ -S[5] , S[6] , S[1] , S[2] ] == {{I*gc39*(72*cH*vev^2 - 8*lam*(2 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 12*cHW*vev^2)*xiBG), 0}, {0, 0}, {(4*I)*(4*cHbox - cHD)*gc39, 0}, {(4*I)*(4*cHbox - cHD)*gc39, 0}, {(4*I)*(4*cHbox - cHD)*gc39, 0}, {(4*I)*(4*cHbox - cHD)*gc39, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , S[2] ] == {{I*gc40*(72*cH*vev^2 - 8*lam*(2 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 12*cHW*vev^2)*xiBG), 0}, {0, 0}, {(4*I)*(4*cHbox - cHD)*gc40, 0}, {(4*I)*(4*cHbox - cHD)*gc40, 0}, {(4*I)*(4*cHbox - cHD)*gc40, 0}, {(4*I)*(4*cHbox - cHD)*gc40, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , S[2] ] == {{(2*I)*gc41*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc41, 0}, {I*(4*cHbox - cHD)*gc41, 0}, {I*(4*cHbox - cHD)*gc41, 0}, {I*(4*cHbox - cHD)*gc41, 0}, {0, 0}},

C[ S[1] , S[1] , S[1] , S[2] ] == {{(3*I)*(15*cH*vev^2 + lam*(-2 - 8*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[2] , S[2] ] == {{(-I)*gc43*(18*cH*vev^2 + lam*(-4 - 8*cHbox*vev^2 + 4*cHD*vev^2) - (12*cHWB*g1*g2*vev^2 + g1^2*(1 + 12*cHB*vev^2 + 2*cHbox*vev^2 + 5*cHD*vev^2) + g2^2*(1 + 2*cHbox*vev^2 + 5*cHD*vev^2 + 12*cHW*vev^2))*xiBG), 0}, {(2*I)*cHD*gc43, 0}, {(-4*I)*cHbox*gc43, 0}, {(-4*I)*cHbox*gc43, 0}, {(-4*I)*cHbox*gc43, 0}, {(-4*I)*cHbox*gc43, 0}, {(2*I)*cHD*gc43, 0}},

C[ S[3] , S[4] , S[2] , S[2] ] == {{(-I)*gc44*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc44, 0}, {(-2*I)*cHbox*gc44, 0}, {(-2*I)*cHbox*gc44, 0}, {(-2*I)*cHbox*gc44, 0}, {(-2*I)*cHbox*gc44, 0}, {I*cHD*gc44, 0}},

C[ S[4] , S[4] , S[2] , S[2] ] == {{(-I)*gc45*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*cHD*gc45, 0}, {(-2*I)*cHbox*gc45, 0}, {(-2*I)*cHbox*gc45, 0}, {(-2*I)*cHbox*gc45, 0}, {(-2*I)*cHbox*gc45, 0}, {I*cHD*gc45, 0}},

C[ S[5] , -S[5] , S[2] , S[2] ] == {{I*gc46*(36*cH*vev^2 - 4*lam*(2 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(-2 - 4*cHbox*vev^2 + cHD*vev^2 - 24*cHW*vev^2)*xiBG), 0}, {0, 0}, {(2*I)*(4*cHbox - cHD)*gc46, 0}, {(2*I)*(4*cHbox - cHD)*gc46, 0}, {(2*I)*(4*cHbox - cHD)*gc46, 0}, {(2*I)*(4*cHbox - cHD)*gc46, 0}, {0, 0}},

C[ -S[5] , S[6] , S[2] , S[2] ] == {{(2*I)*gc47*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc47, 0}, {I*(4*cHbox - cHD)*gc47, 0}, {I*(4*cHbox - cHD)*gc47, 0}, {I*(4*cHbox - cHD)*gc47, 0}, {0, 0}},

C[ S[5] , -S[6] , S[2] , S[2] ] == {{(2*I)*gc48*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc48, 0}, {I*(4*cHbox - cHD)*gc48, 0}, {I*(4*cHbox - cHD)*gc48, 0}, {I*(4*cHbox - cHD)*gc48, 0}, {0, 0}},

C[ S[6] , -S[6] , S[2] , S[2] ] == {{(2*I)*gc49*(9*cH*vev^2 + lam*(-2 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc49, 0}, {I*(4*cHbox - cHD)*gc49, 0}, {I*(4*cHbox - cHD)*gc49, 0}, {I*(4*cHbox - cHD)*gc49, 0}, {0, 0}},

C[ S[1] , S[1] , S[2] , S[2] ] == {{(3*I)*(15*cH*vev^2 + lam*(-2 - 8*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[1] , S[2] , S[2] , S[2] ] == {{(3*I)*(15*cH*vev^2 + lam*(-2 - 8*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[2] , S[2] , S[2] , S[2] ] == {{(3*I)*(15*cH*vev^2 + lam*(-2 - 8*cHbox*vev^2 + 2*cHD*vev^2)), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}, {I*(4*cHbox - cHD), 0}},

C[ S[3] , S[3] , S[1] ] == {{I*gc53*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(-2*I)*cHD*gc53, 0}, {(4*I)*cHbox*gc53, 0}, {(4*I)*cHbox*gc53, 0}},

C[ S[3] , S[4] , S[1] ] == {{I*gc54*(48*cH*vev^2 - 8*lam*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2) + (8*cHWB*g1*g2*vev^2 + g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2) + g2^2*(4 + 4*cHbox*vev^2 + cHD*vev^2 + 8*cHW*vev^2))*xiBG), 0}, {(-16*I)*cHD*gc54, 0}, {(32*I)*cHbox*gc54, 0}, {(32*I)*cHbox*gc54, 0}},

C[ S[4] , S[4] , S[1] ] == {{I*gc55*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(-2*I)*cHD*gc55, 0}, {(4*I)*cHbox*gc55, 0}, {(4*I)*cHbox*gc55, 0}},

C[ S[5] , -S[5] , S[1] ] == {{I*gc56*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc56, 0}, {I*(4*cHbox - cHD)*gc56, 0}},

C[ -S[5] , S[6] , S[1] ] == {{I*gc57*(48*cH*vev^2 - 8*lam*(4 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG), 0}, {0, 0}, {(8*I)*(4*cHbox - cHD)*gc57, 0}, {(8*I)*(4*cHbox - cHD)*gc57, 0}},

C[ S[5] , -S[6] , S[1] ] == {{I*gc58*(48*cH*vev^2 - 8*lam*(4 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG), 0}, {0, 0}, {(8*I)*(4*cHbox - cHD)*gc58, 0}, {(8*I)*(4*cHbox - cHD)*gc58, 0}},

C[ S[6] , -S[6] , S[1] ] == {{I*gc59*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc59, 0}, {I*(4*cHbox - cHD)*gc59, 0}},

C[ S[1] , S[1] , S[1] ] == {{(3*I)*gc60*(10*cH*vev^2 + lam*(-4 - 12*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(2*I)*(4*cHbox - cHD)*gc60, 0}, {(2*I)*(4*cHbox - cHD)*gc60, 0}, {(2*I)*(4*cHbox - cHD)*gc60, 0}},

C[ S[3] , S[3] , S[2] ] == {{(-I)*gc61*(-24*cH*vev^2 + 4*lam*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2) + (16*cHWB*g1*g2*vev^2 + g1^2*(4 + 16*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + g2^2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 16*cHW*vev^2))*xiBG), 0}, {(-8*I)*cHD*gc61, 0}, {(16*I)*cHbox*gc61, 0}, {(16*I)*cHbox*gc61, 0}},

C[ S[3] , S[4] , S[2] ] == {{I*gc62*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(-2*I)*cHD*gc62, 0}, {(4*I)*cHbox*gc62, 0}, {(4*I)*cHbox*gc62, 0}},

C[ S[4] , S[4] , S[2] ] == {{I*gc63*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(-2*I)*cHD*gc63, 0}, {(4*I)*cHbox*gc63, 0}, {(4*I)*cHbox*gc63, 0}},

C[ S[5] , -S[5] , S[2] ] == {{I*gc64*(24*cH*vev^2 - 4*lam*(4 + 4*cHbox*vev^2 - cHD*vev^2) + g2^2*(-4 - 4*cHbox*vev^2 + cHD*vev^2 - 16*cHW*vev^2)*xiBG), 0}, {0, 0}, {(4*I)*(4*cHbox - cHD)*gc64, 0}, {(4*I)*(4*cHbox - cHD)*gc64, 0}},

C[ -S[5] , S[6] , S[2] ] == {{I*gc65*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc65, 0}, {I*(4*cHbox - cHD)*gc65, 0}},

C[ S[5] , -S[6] , S[2] ] == {{I*gc66*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc66, 0}, {I*(4*cHbox - cHD)*gc66, 0}},

C[ S[6] , -S[6] , S[2] ] == {{I*gc67*(6*cH*vev^2 + lam*(-4 - 4*cHbox*vev^2 + cHD*vev^2)), 0}, {0, 0}, {I*(4*cHbox - cHD)*gc67, 0}, {I*(4*cHbox - cHD)*gc67, 0}},

C[ S[1] , S[1] , S[2] ] == {{(3*I)*gc68*(10*cH*vev^2 + lam*(-4 - 12*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(2*I)*(4*cHbox - cHD)*gc68, 0}, {(2*I)*(4*cHbox - cHD)*gc68, 0}, {(2*I)*(4*cHbox - cHD)*gc68, 0}},

C[ S[1] , S[2] , S[2] ] == {{(3*I)*gc69*(10*cH*vev^2 + lam*(-4 - 12*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(2*I)*(4*cHbox - cHD)*gc69, 0}, {(2*I)*(4*cHbox - cHD)*gc69, 0}, {(2*I)*(4*cHbox - cHD)*gc69, 0}},

C[ S[2] , S[2] , S[2] ] == {{(3*I)*gc70*(10*cH*vev^2 + lam*(-4 - 12*cHbox*vev^2 + 3*cHD*vev^2)), 0}, {(2*I)*(4*cHbox - cHD)*gc70, 0}, {(2*I)*(4*cHbox - cHD)*gc70, 0}, {(2*I)*(4*cHbox - cHD)*gc70, 0}},

C[ S[4] , -S[5] , S[6] , S[1] ] == {{-(gc71*(4*cHWB*g1*g2*vev^2 + 2*cHD*g2^2*vev^2 + g1^2*(2 + 4*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2))*xiBG), 0}, {4*cHD*gc71, 0}, {-4*cHD*gc71, 0}, {0, 0}, {0, 0}, {-4*cHD*gc71, 0}, {4*cHD*gc71, 0}},

C[ S[4] , S[5] , -S[6] , S[1] ] == {{-(gc72*(4*cHWB*g1*g2*vev^2 + 2*cHD*g2^2*vev^2 + g1^2*(2 + 4*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2))*xiBG), 0}, {4*cHD*gc72, 0}, {-4*cHD*gc72, 0}, {0, 0}, {0, 0}, {-4*cHD*gc72, 0}, {4*cHD*gc72, 0}},

C[ S[3] , -S[5] , S[6] , S[2] ] == {{gc73*(12*cHWB*g1*g2*vev^2 + 6*cHD*g2^2*vev^2 + g1^2*(2 + 12*cHB*vev^2 + 2*cHbox*vev^2 + 5*cHD*vev^2))*xiBG, 0}, {4*cHD*gc73, 0}, {-4*cHD*gc73, 0}, {0, 0}, {0, 0}, {-4*cHD*gc73, 0}, {4*cHD*gc73, 0}},

C[ S[3] , S[5] , -S[6] , S[2] ] == {{gc74*(12*cHWB*g1*g2*vev^2 + 6*cHD*g2^2*vev^2 + g1^2*(2 + 12*cHB*vev^2 + 2*cHbox*vev^2 + 5*cHD*vev^2))*xiBG, 0}, {4*cHD*gc74, 0}, {-4*cHD*gc74, 0}, {0, 0}, {0, 0}, {-4*cHD*gc74, 0}, {4*cHD*gc74, 0}},

C[ S[3] , -S[5] , S[6] ] == {{-(gc75*(8*cHWB*g1*g2*vev^2 + 4*cHD*g2^2*vev^2 + g1^2*(4 + 8*cHB*vev^2 + 3*cHD*vev^2))*xiBG), 0}, {-8*cHD*gc75, 0}, {8*cHD*gc75, 0}, {0, 0}},

C[ S[3] , S[5] , -S[6] ] == {{-(gc76*(8*cHWB*g1*g2*vev^2 + 4*cHD*g2^2*vev^2 + g1^2*(4 + 8*cHB*vev^2 + 3*cHD*vev^2))*xiBG), 0}, {-8*cHD*gc76, 0}, {8*cHD*gc76, 0}, {0, 0}},

C[ S[3] , S[3] , V[1] , V[1] ] == {{(-16*I)*gc77*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc77*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc77*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[1] , V[1] ] == {{(-16*I)*gc78*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc78*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc78*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[1] , V[1] ] == {{(-16*I)*gc79*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(-I)*gc79*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc79*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(16*I)*gc79*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}},

C[ S[5] , -S[5] , V[1] , V[1] ] == {{(-8*I)*gc80*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc80*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc80*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[1] , V[1] ] == {{(-8*I)*gc81*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc81*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc81*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[1] , V[1] ] == {{(-8*I)*gc82*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc82*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc82*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[1] , V[1] ] == {{(-8*I)*gc83*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar))*xiBG, 0}, {(-I)*gc83*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2))*xiBG, 0}, {(8*I)*gc83*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar))*xiBG, 0}, {(8*I)*gc83*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}},

C[ S[1] , S[1] , V[1] , V[1] ] == {{(-16*I)*gc84*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc84*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc84*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[1] , V[1] ] == {{(-16*I)*gc85*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc85*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc85*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[1] , V[1] ] == {{(-16*I)*gc86*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(-I)*gc86*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc86*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(16*I)*gc86*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}},

C[ S[1] , V[1] , V[1] ] == {{(-32*I)*gc87*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc87*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc87*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , V[1] , V[1] ] == {{(-32*I)*gc88*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(-I)*gc88*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG, 0}, {(32*I)*gc88*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar))*xiBG, 0}, {(32*I)*gc88*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}},

C[ S[3] , S[3] , V[1] , V[2] ] == {{(-16*I)*gc89*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc89*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc89*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[1] , V[2] ] == {{(-16*I)*gc90*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc90*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc90*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[1] , V[2] ] == {{(-16*I)*gc91*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc91*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc91*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[1] , V[2] ] == {{(-8*I)*gc92*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc92*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc92*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[1] , V[2] ] == {{(-8*I)*gc93*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc93*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc93*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[1] , V[2] ] == {{(-8*I)*gc94*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc94*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc94*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[1] , V[2] ] == {{(-8*I)*gc95*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc95*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc95*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[1] , V[1] , V[2] ] == {{(-16*I)*gc96*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc96*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc96*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[1] , V[2] ] == {{(-16*I)*gc97*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc97*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc97*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[1] , V[2] ] == {{(-16*I)*gc98*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc98*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc98*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , V[1] , V[2] ] == {{(-32*I)*gc99*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc99*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc99*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , V[1] , V[2] ] == {{(-32*I)*gc100*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc100*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc100*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[3] , S[3] , V[2] , V[2] ] == {{(-16*I)*gc101*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc101*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc101*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[2] , V[2] ] == {{(-16*I)*gc102*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc102*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc102*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[2] , V[2] ] == {{(-16*I)*gc103*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc103*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc103*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[2] , V[2] ] == {{(-8*I)*gc104*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc104*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc104*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[2] , V[2] ] == {{(-8*I)*gc105*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc105*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc105*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[2] , V[2] ] == {{(-8*I)*gc106*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc106*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc106*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[2] , V[2] ] == {{(-8*I)*gc107*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {(-I)*gc107*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc107*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[1] , V[2] , V[2] ] == {{(-16*I)*gc108*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc108*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc108*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[2] , V[2] ] == {{(-16*I)*gc109*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc109*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc109*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[2] , V[2] ] == {{(-16*I)*gc110*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc110*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc110*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , V[2] , V[2] ] == {{(-32*I)*gc111*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc111*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc111*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[2] , V[2] , V[2] ] == {{(-32*I)*gc112*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {(-I)*gc112*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc112*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[3] , S[1] , V[1] ] == {{gc113*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc113*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[2] , V[1] ] == {{gc114*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc114*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {gc114*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}},

C[ S[3] , S[3] , S[3] , V[1] ] == {{gc115, 0}, {gc115, 0}, {gc115, 0}, {0, 0}},

C[ S[3] , S[3] , S[4] , V[1] ] == {{gc116, 0}, {gc116, 0}, {gc116, 0}, {0, 0}},

C[ S[3] , S[4] , S[4] , V[1] ] == {{gc117, 0}, {gc117, 0}, {gc117, 0}, {gc117, 0}},

C[ S[3] , S[5] , -S[5] , V[1] ] == {{gc118, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[6] , V[1] ] == {{gc119, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -S[6] , V[1] ] == {{gc120, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -S[6] , V[1] ] == {{gc121, 0}, {0, 0}, {0, 0}, {gc121, 0}},

C[ S[3] , S[1] , S[1] , V[1] ] == {{-3*gc122, 0}, {gc122, 0}, {gc122, 0}, {0, 0}},

C[ S[3] , S[1] , S[2] , V[1] ] == {{-3*gc123, 0}, {gc123, 0}, {gc123, 0}, {0, 0}},

C[ S[3] , S[2] , S[2] , V[1] ] == {{3*gc124, 0}, {-gc124, 0}, {-gc124, 0}, {3*gc124, 0}},

C[ S[3] , S[1] , V[2] ] == {{gc125*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc125*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[2] , V[2] ] == {{gc126*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc126*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[3] , S[3] , V[2] ] == {{gc127, 0}, {gc127, 0}, {gc127, 0}, {0, 0}},

C[ S[3] , S[3] , S[4] , V[2] ] == {{gc128, 0}, {gc128, 0}, {gc128, 0}, {0, 0}},

C[ S[3] , S[4] , S[4] , V[2] ] == {{gc129, 0}, {gc129, 0}, {gc129, 0}, {0, 0}},

C[ S[3] , S[5] , -S[5] , V[2] ] == {{gc130, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[6] , V[2] ] == {{gc131, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -S[6] , V[2] ] == {{gc132, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -S[6] , V[2] ] == {{gc133, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[1] , S[1] , V[2] ] == {{-3*gc134, 0}, {gc134, 0}, {gc134, 0}, {0, 0}},

C[ S[3] , S[1] , S[2] , V[2] ] == {{-3*gc135, 0}, {gc135, 0}, {gc135, 0}, {0, 0}},

C[ S[3] , S[2] , S[2] , V[2] ] == {{-3*gc136, 0}, {gc136, 0}, {gc136, 0}, {0, 0}},

C[ S[4] , S[1] , V[1] ] == {{gc137*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc137*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {gc137*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}},

C[ S[4] , S[2] , V[1] ] == {{gc138*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc138*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[4] , S[4] , V[1] ] == {{gc139, 0}, {gc139, 0}, {gc139, 0}, {0, 0}},

C[ S[4] , S[5] , -S[5] , V[1] ] == {{gc140, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[6] , V[1] ] == {{gc141, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , -S[6] , V[1] ] == {{gc142, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -S[6] , V[1] ] == {{gc143, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[1] , S[1] , V[1] ] == {{-3*gc144, 0}, {gc144, 0}, {gc144, 0}, {0, 0}},

C[ S[4] , S[1] , S[2] , V[1] ] == {{-3*gc145, 0}, {gc145, 0}, {gc145, 0}, {gc145, 0}},

C[ S[4] , S[2] , S[2] , V[1] ] == {{-3*gc146, 0}, {gc146, 0}, {gc146, 0}, {0, 0}},

C[ S[4] , S[1] , V[2] ] == {{gc147*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc147*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[2] , V[2] ] == {{gc148*(cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2) - 2*g2*swbar*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {gc148*(-(cHWB*cwbar*g2*vev^2) + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHbox*vev^2) + 2*g2*swbar*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[4] , S[4] , V[2] ] == {{gc149, 0}, {gc149, 0}, {gc149, 0}, {0, 0}},

C[ S[4] , S[5] , -S[5] , V[2] ] == {{gc150, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[6] , V[2] ] == {{gc151, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , -S[6] , V[2] ] == {{gc152, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -S[6] , V[2] ] == {{gc153, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[1] , S[1] , V[2] ] == {{-3*gc154, 0}, {gc154, 0}, {gc154, 0}, {0, 0}},

C[ S[4] , S[1] , S[2] , V[2] ] == {{-3*gc155, 0}, {gc155, 0}, {gc155, 0}, {0, 0}},

C[ S[4] , S[2] , S[2] , V[2] ] == {{-3*gc156, 0}, {gc156, 0}, {gc156, 0}, {0, 0}},

C[ S[5] , -S[5] , V[1] ] == {{(-I)*gc157, 0}, {I*gc157, 0}, {0, 0}},

C[ S[5] , -S[6] , V[1] ] == {{I*gc158, 0}, {(-I)*gc158, 0}, {I*gc158, 0}},

C[ S[5] , -S[5] , S[1] , V[1] ] == {{(-I)*gc159, 0}, {I*gc159, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , V[1] ] == {{(-I)*gc160, 0}, {I*gc160, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[5] , S[2] , V[1] ] == {{(-I)*gc161, 0}, {I*gc161, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[2] , V[1] ] == {{I*gc162, 0}, {(-I)*gc162, 0}, {0, 0}, {I*gc162, 0}},

C[ S[5] , -S[5] , V[2] ] == {{(-I)*gc163, 0}, {I*gc163, 0}, {0, 0}},

C[ S[5] , -S[6] , V[2] ] == {{(-I)*gc164, 0}, {I*gc164, 0}, {0, 0}},

C[ S[5] , -S[5] , S[1] , V[2] ] == {{(-I)*gc165, 0}, {I*gc165, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , V[2] ] == {{(-I)*gc166, 0}, {I*gc166, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[5] , S[2] , V[2] ] == {{(-I)*gc167, 0}, {I*gc167, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[2] , V[2] ] == {{(-I)*gc168, 0}, {I*gc168, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -S[5] , S[1] ] == {{0, 0}, {gc169, 0}, {-gc169, 0}, {0, 0}, {0, 0}, {-gc169, 0}, {gc169, 0}},

C[ S[3] , S[5] , -S[6] , S[1] ] == {{0, 0}, {gc170, 0}, {-gc170, 0}, {0, 0}, {0, 0}, {-gc170, 0}, {gc170, 0}},

C[ S[3] , S[5] , -S[5] , S[2] ] == {{0, 0}, {gc171, 0}, {-gc171, 0}, {0, 0}, {0, 0}, {-gc171, 0}, {gc171, 0}},

C[ S[3] , S[5] , -S[5] ] == {{0, 0}, {-gc172, 0}, {gc172, 0}, {0, 0}},

C[ S[4] , S[5] , -S[5] , S[1] ] == {{0, 0}, {gc173, 0}, {-gc173, 0}, {0, 0}, {0, 0}, {-gc173, 0}, {gc173, 0}},

C[ S[4] , S[5] , -S[5] , S[2] ] == {{0, 0}, {gc174, 0}, {-gc174, 0}, {0, 0}, {0, 0}, {-gc174, 0}, {gc174, 0}},

C[ S[4] , S[5] , -S[6] , S[2] ] == {{0, 0}, {gc175, 0}, {-gc175, 0}, {0, 0}, {0, 0}, {-gc175, 0}, {gc175, 0}},

C[ S[4] , S[5] , -S[5] ] == {{0, 0}, {-gc176, 0}, {gc176, 0}, {0, 0}},

C[ S[4] , S[5] , -S[6] ] == {{0, 0}, {-gc177, 0}, {gc177, 0}, {0, 0}},

C[ -S[5] , S[6] , V[1] ] == {{I*gc178, 0}, {(-I)*gc178, 0}, {I*gc178, 0}},

C[ -S[5] , S[6] , S[1] , V[1] ] == {{(-I)*gc179, 0}, {I*gc179, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , S[2] , V[1] ] == {{I*gc180, 0}, {(-I)*gc180, 0}, {0, 0}, {I*gc180, 0}},

C[ -S[5] , S[6] , V[2] ] == {{(-I)*gc181, 0}, {I*gc181, 0}, {0, 0}},

C[ -S[5] , S[6] , S[1] , V[2] ] == {{(-I)*gc182, 0}, {I*gc182, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , S[2] , V[2] ] == {{(-I)*gc183, 0}, {I*gc183, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[6] , S[1] ] == {{0, 0}, {gc184, 0}, {-gc184, 0}, {0, 0}, {0, 0}, {-gc184, 0}, {gc184, 0}},

C[ S[4] , -S[5] , S[6] , S[2] ] == {{0, 0}, {gc185, 0}, {-gc185, 0}, {0, 0}, {0, 0}, {-gc185, 0}, {gc185, 0}},

C[ S[4] , -S[5] , S[6] ] == {{0, 0}, {-gc186, 0}, {gc186, 0}, {0, 0}},

C[ S[6] , -S[6] , V[1] ] == {{(-I)*gc187, 0}, {I*gc187, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , V[1] ] == {{(-I)*gc188, 0}, {I*gc188, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , S[2] , V[1] ] == {{(-I)*gc189, 0}, {I*gc189, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , V[2] ] == {{(-I)*gc190, 0}, {I*gc190, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , V[2] ] == {{(-I)*gc191, 0}, {I*gc191, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , S[2] , V[2] ] == {{(-I)*gc192, 0}, {I*gc192, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -S[6] , S[1] ] == {{0, 0}, {gc193, 0}, {-gc193, 0}, {0, 0}, {0, 0}, {-gc193, 0}, {gc193, 0}},

C[ S[3] , S[6] , -S[6] , S[2] ] == {{0, 0}, {gc194, 0}, {-gc194, 0}, {0, 0}, {0, 0}, {-gc194, 0}, {gc194, 0}},

C[ S[3] , S[6] , -S[6] ] == {{0, 0}, {-gc195, 0}, {gc195, 0}, {0, 0}},

C[ S[4] , S[6] , -S[6] , S[1] ] == {{0, 0}, {gc196, 0}, {-gc196, 0}, {0, 0}, {0, 0}, {-gc196, 0}, {gc196, 0}},

C[ S[4] , S[6] , -S[6] , S[2] ] == {{0, 0}, {gc197, 0}, {-gc197, 0}, {0, 0}, {0, 0}, {-gc197, 0}, {gc197, 0}},

C[ S[4] , S[6] , -S[6] ] == {{0, 0}, {-gc198, 0}, {gc198, 0}, {0, 0}},

C[ S[3] , S[3] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc199*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc199*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[3] , S[4] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc200*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc200*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[4] , S[4] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc201*xiGBG*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc201*xiGBG*IndexDelta[e1x2, e2x2], 0}, {I*gc201*IndexDelta[e1x2, e2x2], 0}},

C[ S[5] , -S[5] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc202*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc202*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -S[5] , S[6] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc203*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc203*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[5] , -S[6] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc204*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc204*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[6] , -S[6] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc205*xiGBG*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc205*xiGBG*IndexDelta[e1x2, e2x2], 0}, {I*gc205*IndexDelta[e1x2, e2x2], 0}},

C[ S[1] , S[1] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc206*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc206*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , S[2] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc207*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc207*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , S[2] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc208*xiGBG*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc208*xiGBG*IndexDelta[e1x2, e2x2], 0}, {I*gc208*IndexDelta[e1x2, e2x2], 0}},

C[ S[1] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc209*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc209*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , V[7, {e1x2}] , V[7, {e2x2}] ] == {{(-I)*gc210*xiGBG*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc210*xiGBG*IndexDelta[e1x2, e2x2], 0}, {I*gc210*IndexDelta[e1x2, e2x2], 0}},

C[ S[3] , S[3] , V[7, {e1x2}] , V[8, {e4x2}] ] == {{(-I)*gc211*IndexDelta[e1x2, e4x2], 0}, {0, 0}, {I*gc211*IndexDelta[e1x2, e4x2], 0}, {0, 0}},

C[ S[3] , S[4] , V[7, {e1x2}] , V[8, {e4x2}] ] == {{(-I)*gc212*IndexDelta[e1x2, e4x2], 0}, {0, 0}, {I*gc212*IndexDelta[e1x2, e4x2], 0}, {0, 0}},

C[ S[4] , S[4] , V[7, {e1x2}] , V[8, {e4x2}] ] == {{(-I)*gc213*IndexDelta[e1x2, e4x2], 0}, {0, 0}, {I*gc213*IndexDelta[e1x2, e4x2], 0}, {0, 0}},

C[ S[5] , -S[5] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc214*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc214*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -S[5] , S[6] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc215*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc215*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[5] , -S[6] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc216*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc216*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[6] , -S[6] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc217*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc217*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , S[1] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc218*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc218*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , S[2] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc219*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc219*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , S[2] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc220*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc220*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc221*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc221*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , V[7, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc222*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc222*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[3] , S[3] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-I)*gc223*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {I*gc223*IndexDelta[e3x2, e4x2], 0}, {0, 0}},

C[ S[3] , S[4] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-I)*gc224*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {I*gc224*IndexDelta[e3x2, e4x2], 0}, {0, 0}},

C[ S[4] , S[4] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-I)*gc225*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {I*gc225*IndexDelta[e3x2, e4x2], 0}, {0, 0}},

C[ S[5] , -S[5] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc226*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc226*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -S[5] , S[6] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc227*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc227*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[5] , -S[6] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc228*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc228*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[6] , -S[6] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc229*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc229*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , S[1] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc230*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc230*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , S[2] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc231*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc231*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , S[2] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc232*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc232*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[1] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc233*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc233*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[2] , V[8, {e1x2}] , V[8, {e2x2}] ] == {{(-I)*gc234*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc234*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ S[4] , -S[5] , V[5] ] == {{gc235*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc235*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {gc235*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}},

C[ S[3] , -S[6] , V[5] ] == {{gc236*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc236*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {gc236*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}},

C[ -S[6] , S[1] , V[5] ] == {{(-I)*gc237, 0}, {I*gc237, 0}, {I*gc237, 0}},

C[ -S[5] , S[2] , V[5] ] == {{I*gc238, 0}, {(-I)*gc238, 0}, {I*gc238, 0}},

C[ S[3] , S[4] , -S[6] , V[5] ] == {{I*gc239, 0}, {I*gc239, 0}, {0, 0}, {I*gc239, 0}},

C[ -S[5] , S[6] , -S[6] , V[5] ] == {{I*gc240, 0}, {(-2*I)*gc240, 0}, {I*gc240, 0}, {I*gc240, 0}},

C[ S[5] , -S[6] , -S[6] , V[5] ] == {{(2*I)*gc241, 0}, {(-I)*gc241, 0}, {(-I)*gc241, 0}, {(2*I)*gc241, 0}},

C[ S[4] , -S[6] , S[1] , V[5] ] == {{-2*gc242, 0}, {0, 0}, {gc242, 0}, {gc242, 0}},

C[ S[3] , -S[6] , S[2] , V[5] ] == {{2*gc243, 0}, {0, 0}, {-gc243, 0}, {2*gc243, 0}},

C[ S[4] , -S[6] , V[1] , V[5] ] == {{-16*cHWB*cwbar*gc244*xiBG, 0}, {g2*gc244*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*cwbar*gc244*xiBG, 0}, {16*cHWB*cwbar*gc244, 0}},

C[ -S[6] , S[2] , V[1] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc245*xiBG, 0}, {(-I)*g2*gc245*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc245*xiBG, 0}, {(16*I)*cHWB*cwbar*gc245, 0}},

C[ -S[6] , V[1] , V[5] ] == {{(-8*I)*cHWB*cwbar*gc246*xiBG, 0}, {(-I)*g2*gc246*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc246*xiBG, 0}, {(8*I)*cHWB*cwbar*gc246, 0}},

C[ S[3] , -S[5] , V[1] , V[5] ] == {{-16*cHWB*cwbar*gc247, 0}, {g2*gc247*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc247, 0}, {0, 0}},

C[ S[4] , -S[5] , V[1] , V[5] ] == {{-16*cHWB*cwbar*gc248, 0}, {g2*gc248*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc248, 0}, {0, 0}},

C[ S[3] , -S[6] , V[1] , V[5] ] == {{-16*cHWB*cwbar*gc249, 0}, {g2*gc249*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc249, 0}, {0, 0}},

C[ -S[5] , S[1] , V[1] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc250, 0}, {(-I)*g2*gc250*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc250, 0}, {0, 0}},

C[ -S[6] , S[1] , V[1] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc251, 0}, {(-I)*g2*gc251*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc251, 0}, {0, 0}},

C[ -S[5] , S[2] , V[1] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc252, 0}, {(-I)*g2*gc252*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc252, 0}, {0, 0}},

C[ -S[5] , V[1] , V[5] ] == {{(-8*I)*cHWB*cwbar*gc253, 0}, {(-I)*g2*gc253*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc253, 0}, {0, 0}},

C[ S[3] , -S[5] , V[2] , V[5] ] == {{-16*cHWB*cwbar*gc254, 0}, {g2*gc254*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc254, 0}, {0, 0}},

C[ S[4] , -S[5] , V[2] , V[5] ] == {{-16*cHWB*cwbar*gc255, 0}, {g2*gc255*(-2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc255, 0}, {0, 0}},

C[ S[3] , -S[6] , V[2] , V[5] ] == {{-16*cHWB*cwbar*gc256, 0}, {g2*gc256*(2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc256, 0}, {0, 0}},

C[ S[4] , -S[6] , V[2] , V[5] ] == {{-16*cHWB*cwbar*gc257, 0}, {g2*gc257*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc257, 0}, {0, 0}},

C[ -S[5] , S[1] , V[2] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc258, 0}, {(-I)*g2*gc258*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc258, 0}, {0, 0}},

C[ -S[6] , S[1] , V[2] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc259, 0}, {(-I)*g2*gc259*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc259, 0}, {0, 0}},

C[ -S[5] , S[2] , V[2] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc260, 0}, {(-I)*g2*gc260*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc260, 0}, {0, 0}},

C[ -S[6] , S[2] , V[2] , V[5] ] == {{(-16*I)*cHWB*cwbar*gc261, 0}, {(-I)*g2*gc261*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc261, 0}, {0, 0}},

C[ -S[5] , V[2] , V[5] ] == {{(-8*I)*cHWB*cwbar*gc262, 0}, {(-I)*g2*gc262*(cwbar*(cHWB*g2*vev^2 + g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*cHWB*cwbar*gc262, 0}, {0, 0}},

C[ -S[6] , V[2] , V[5] ] == {{(-8*I)*cHWB*cwbar*gc263, 0}, {(-I)*g2*gc263*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc263, 0}, {0, 0}},

C[ S[4] , S[5] , -V[5] ] == {{gc264*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc264*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {gc264*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}},

C[ S[3] , S[6] , -V[5] ] == {{gc265*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc265*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {gc265*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}},

C[ S[6] , S[1] , -V[5] ] == {{(-I)*gc266, 0}, {I*gc266, 0}, {I*gc266, 0}},

C[ S[5] , S[2] , -V[5] ] == {{I*gc267, 0}, {(-I)*gc267, 0}, {I*gc267, 0}},

C[ S[3] , S[4] , S[6] , -V[5] ] == {{I*gc268, 0}, {I*gc268, 0}, {0, 0}, {I*gc268, 0}},

C[ -S[5] , S[6] , S[6] , -V[5] ] == {{(2*I)*gc269, 0}, {(-I)*gc269, 0}, {(-I)*gc269, 0}, {(2*I)*gc269, 0}},

C[ S[5] , S[6] , -S[6] , -V[5] ] == {{I*gc270, 0}, {I*gc270, 0}, {(-2*I)*gc270, 0}, {I*gc270, 0}},

C[ S[4] , S[6] , S[1] , -V[5] ] == {{-2*gc271, 0}, {0, 0}, {gc271, 0}, {gc271, 0}},

C[ S[3] , S[6] , S[2] , -V[5] ] == {{2*gc272, 0}, {0, 0}, {-gc272, 0}, {2*gc272, 0}},

C[ S[4] , S[6] , V[1] , -V[5] ] == {{-16*cHWB*cwbar*gc273*xiBG, 0}, {-(g2*gc273*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG), 0}, {16*cHWB*cwbar*gc273*xiBG, 0}, {16*cHWB*cwbar*gc273, 0}},

C[ S[6] , S[2] , V[1] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc274*xiBG, 0}, {(-I)*g2*gc274*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc274*xiBG, 0}, {(16*I)*cHWB*cwbar*gc274, 0}},

C[ S[6] , V[1] , -V[5] ] == {{(-8*I)*cHWB*cwbar*gc275*xiBG, 0}, {(-I)*g2*gc275*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc275*xiBG, 0}, {(8*I)*cHWB*cwbar*gc275, 0}},

C[ S[4] , S[4] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc276*xiBG, 0}, {I*g2^2*gc276*(-2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc276*xiBG, 0}, {(16*I)*cHW*gc276, 0}},

C[ S[6] , -S[6] , V[5] , -V[5] ] == {{(-8*I)*cHW*gc277*xiBG, 0}, {(-I)*g2^2*gc277*(1 + cHD*vev^2 + 2*cHW*vev^2)*xiBG, 0}, {(8*I)*cHW*gc277*xiBG, 0}, {(8*I)*cHW*gc277, 0}},

C[ S[2] , S[2] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc278*xiBG, 0}, {(-I)*g2^2*gc278*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc278*xiBG, 0}, {(16*I)*cHW*gc278, 0}},

C[ S[2] , V[5] , -V[5] ] == {{(-32*I)*cHW*gc279*xiBG, 0}, {(-I)*g2^2*gc279*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG, 0}, {(32*I)*cHW*gc279*xiBG, 0}, {(32*I)*cHW*gc279, 0}},

C[ S[3] , S[5] , V[1] , -V[5] ] == {{-16*cHWB*cwbar*gc280, 0}, {-(g2*gc280*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc280, 0}, {0, 0}},

C[ S[4] , S[5] , V[1] , -V[5] ] == {{-16*cHWB*cwbar*gc281, 0}, {-(g2*gc281*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc281, 0}, {0, 0}},

C[ S[3] , S[6] , V[1] , -V[5] ] == {{-16*cHWB*cwbar*gc282, 0}, {-(g2*gc282*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc282, 0}, {0, 0}},

C[ S[5] , S[1] , V[1] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc283, 0}, {(-I)*g2*gc283*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc283, 0}, {0, 0}},

C[ S[6] , S[1] , V[1] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc284, 0}, {(-I)*g2*gc284*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc284, 0}, {0, 0}},

C[ S[5] , S[2] , V[1] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc285, 0}, {(-I)*g2*gc285*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc285, 0}, {0, 0}},

C[ S[5] , V[1] , -V[5] ] == {{(-8*I)*cHWB*cwbar*gc286, 0}, {(-I)*g2*gc286*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc286, 0}, {0, 0}},

C[ S[3] , S[5] , V[2] , -V[5] ] == {{-16*cHWB*cwbar*gc287, 0}, {-(g2*gc287*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc287, 0}, {0, 0}},

C[ S[4] , S[5] , V[2] , -V[5] ] == {{-16*cHWB*cwbar*gc288, 0}, {-(g2*gc288*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc288, 0}, {0, 0}},

C[ S[3] , S[6] , V[2] , -V[5] ] == {{-16*cHWB*cwbar*gc289, 0}, {-(g2*gc289*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc289, 0}, {0, 0}},

C[ S[4] , S[6] , V[2] , -V[5] ] == {{-16*cHWB*cwbar*gc290, 0}, {-(g2*gc290*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc290, 0}, {0, 0}},

C[ S[5] , S[1] , V[2] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc291, 0}, {(-I)*g2*gc291*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc291, 0}, {0, 0}},

C[ S[6] , S[1] , V[2] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc292, 0}, {(-I)*g2*gc292*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc292, 0}, {0, 0}},

C[ S[5] , S[2] , V[2] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc293, 0}, {(-I)*g2*gc293*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc293, 0}, {0, 0}},

C[ S[6] , S[2] , V[2] , -V[5] ] == {{(-16*I)*cHWB*cwbar*gc294, 0}, {(-I)*g2*gc294*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc294, 0}, {0, 0}},

C[ S[5] , V[2] , -V[5] ] == {{(-8*I)*cHWB*cwbar*gc295, 0}, {(-I)*g2*gc295*(cwbar*(cHWB*g2*vev^2 + g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*cHWB*cwbar*gc295, 0}, {0, 0}},

C[ S[6] , V[2] , -V[5] ] == {{(-8*I)*cHWB*cwbar*gc296, 0}, {(-I)*g2*gc296*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc296, 0}, {0, 0}},

C[ S[3] , S[3] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc297, 0}, {I*g2^2*gc297*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc297, 0}, {0, 0}},

C[ S[3] , S[4] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc298, 0}, {I*g2^2*gc298*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc298, 0}, {0, 0}},

C[ S[5] , -S[5] , V[5] , -V[5] ] == {{(-8*I)*cHW*gc299, 0}, {(-I)*g2^2*gc299*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc299, 0}, {0, 0}},

C[ -S[5] , S[6] , V[5] , -V[5] ] == {{(-8*I)*cHW*gc300, 0}, {(-I)*g2^2*gc300*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc300, 0}, {0, 0}},

C[ S[5] , -S[6] , V[5] , -V[5] ] == {{(-8*I)*cHW*gc301, 0}, {(-I)*g2^2*gc301*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc301, 0}, {0, 0}},

C[ S[1] , S[1] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc302, 0}, {(-I)*g2^2*gc302*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc302, 0}, {0, 0}},

C[ S[1] , S[2] , V[5] , -V[5] ] == {{(-16*I)*cHW*gc303, 0}, {(-I)*g2^2*gc303*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc303, 0}, {0, 0}},

C[ S[1] , V[5] , -V[5] ] == {{(-32*I)*cHW*gc304, 0}, {(-I)*g2^2*gc304*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc304, 0}, {0, 0}},

C[ V[1] , V[5] , -V[5] ] == {{(-12*I)*cW*gc305*swbar, 0}, {(12*I)*cW*gc305*swbar, 0}, {I*g2*gc305*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc305*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc305*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc305*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc305*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc305*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*gc305*swbar, 0}, {(12*I)*cW*gc305*swbar, 0}, {(12*I)*cW*gc305*swbar, 0}, {(-12*I)*cW*gc305*swbar, 0}, {(-12*I)*cW*gc305*swbar, 0}, {(12*I)*cW*gc305*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[5] , -V[5] ] == {{(-12*I)*cW*gc306*swbar*xiBG, 0}, {(12*I)*cW*gc306*swbar*xiBG, 0}, {I*g2*gc306*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc306*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc306*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc306*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc306*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc306*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-12*I)*cW*gc306*swbar*xiBG, 0}, {(12*I)*cW*gc306*swbar*xiBG, 0}, {(12*I)*cW*gc306*swbar*xiBG, 0}, {(-12*I)*cW*gc306*swbar*xiBG, 0}, {(-12*I)*cW*gc306*swbar*xiBG, 0}, {(12*I)*cW*gc306*swbar*xiBG, 0}, {I*g2*gc306*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc306*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , -S[5] , V[1] , V[6] ] == {{-16*cHWB*cwbar*gc307, 0}, {g2*gc307*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc307, 0}, {0, 0}},

C[ S[4] , -S[5] , V[1] , V[6] ] == {{-16*cHWB*cwbar*gc308, 0}, {g2*gc308*(2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 + g2*swbar*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc308, 0}, {0, 0}},

C[ S[3] , -S[6] , V[1] , V[6] ] == {{-16*cHWB*cwbar*gc309, 0}, {-(g2*gc309*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 5*cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc309, 0}, {0, 0}},

C[ S[4] , -S[6] , V[1] , V[6] ] == {{-16*cHWB*cwbar*gc310, 0}, {g2*gc310*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc310, 0}, {0, 0}},

C[ -S[5] , S[1] , V[1] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc311, 0}, {(-I)*g2*gc311*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc311, 0}, {0, 0}},

C[ -S[6] , S[1] , V[1] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc312, 0}, {(-I)*g2*gc312*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc312, 0}, {0, 0}},

C[ -S[5] , S[2] , V[1] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc313, 0}, {(-I)*g2*gc313*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc313, 0}, {0, 0}},

C[ -S[6] , S[2] , V[1] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc314, 0}, {(-I)*g2*gc314*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc314, 0}, {0, 0}},

C[ -S[5] , V[1] , V[6] ] == {{(-8*I)*cHWB*cwbar*gc315, 0}, {I*g2*gc315*(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + g2*swbar*(-2 + cHD*vev^2 - 4*cHW*vev^2) - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc315, 0}, {0, 0}},

C[ -S[6] , V[1] , V[6] ] == {{(-8*I)*cHWB*cwbar*gc316, 0}, {(-I)*g2*gc316*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc316, 0}, {0, 0}},

C[ S[3] , -S[5] , V[2] , V[6] ] == {{-16*cHWB*cwbar*gc317, 0}, {g2*gc317*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc317, 0}, {0, 0}},

C[ S[4] , -S[5] , V[2] , V[6] ] == {{-16*cHWB*cwbar*gc318, 0}, {g2*gc318*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc318, 0}, {0, 0}},

C[ S[3] , -S[6] , V[2] , V[6] ] == {{-16*cHWB*cwbar*gc319, 0}, {g2*gc319*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc319, 0}, {0, 0}},

C[ S[4] , -S[6] , V[2] , V[6] ] == {{-16*cHWB*cwbar*gc320, 0}, {g2*gc320*(2*(cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {16*cHWB*cwbar*gc320, 0}, {0, 0}},

C[ -S[5] , S[1] , V[2] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc321, 0}, {(-I)*g2*gc321*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc321, 0}, {0, 0}},

C[ -S[6] , S[1] , V[2] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc322, 0}, {(-I)*g2*gc322*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc322, 0}, {0, 0}},

C[ -S[5] , S[2] , V[2] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc323, 0}, {(-I)*g2*gc323*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc323, 0}, {0, 0}},

C[ -S[6] , S[2] , V[2] , V[6] ] == {{(-16*I)*cHWB*cwbar*gc324, 0}, {(-I)*g2*gc324*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc324, 0}, {0, 0}},

C[ -S[5] , V[2] , V[6] ] == {{(-8*I)*cHWB*cwbar*gc325, 0}, {(-I)*g2*gc325*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc325, 0}, {0, 0}},

C[ -S[6] , V[2] , V[6] ] == {{(-8*I)*cHWB*cwbar*gc326, 0}, {(-I)*g2*gc326*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc326, 0}, {0, 0}},

C[ S[3] , S[3] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc327, 0}, {I*g2^2*gc327*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc327, 0}, {0, 0}},

C[ S[3] , S[4] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc328, 0}, {I*g2^2*gc328*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc328, 0}, {0, 0}},

C[ S[4] , S[4] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc329, 0}, {I*g2^2*gc329*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc329, 0}, {0, 0}},

C[ S[5] , -S[5] , -V[5] , V[6] ] == {{(-8*I)*cHW*gc330, 0}, {(-I)*g2^2*gc330*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc330, 0}, {0, 0}},

C[ -S[5] , S[6] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc331, 0}, {(-3*I)*cHD*g2^2*gc331*vev^2, 0}, {(16*I)*cHW*gc331, 0}, {0, 0}},

C[ S[5] , -S[6] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc332, 0}, {(-I)*g2^2*gc332*(4 + cHD*vev^2 + 8*cHW*vev^2), 0}, {(16*I)*cHW*gc332, 0}, {0, 0}},

C[ S[6] , -S[6] , -V[5] , V[6] ] == {{(-8*I)*cHW*gc333, 0}, {(-I)*g2^2*gc333*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc333, 0}, {0, 0}},

C[ S[1] , S[1] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc334, 0}, {(-I)*g2^2*gc334*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc334, 0}, {0, 0}},

C[ S[1] , S[2] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc335, 0}, {(-I)*g2^2*gc335*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc335, 0}, {0, 0}},

C[ S[2] , S[2] , -V[5] , V[6] ] == {{(-16*I)*cHW*gc336, 0}, {(-I)*g2^2*gc336*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc336, 0}, {0, 0}},

C[ S[1] , -V[5] , V[6] ] == {{(-32*I)*cHW*gc337, 0}, {(-I)*g2^2*gc337*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc337, 0}, {0, 0}},

C[ S[2] , -V[5] , V[6] ] == {{(-32*I)*cHW*gc338, 0}, {(-I)*g2^2*gc338*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc338, 0}, {0, 0}},

C[ V[1] , -V[5] , V[6] ] == {{(-12*I)*cW*gc339*swbar*xiBG, 0}, {(12*I)*cW*gc339*swbar*xiBG, 0}, {I*g2*gc339*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc339*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc339*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc339*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc339*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc339*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-12*I)*cW*gc339*swbar*xiBG, 0}, {(12*I)*cW*gc339*swbar*xiBG, 0}, {(12*I)*cW*gc339*swbar*xiBG, 0}, {(-12*I)*cW*gc339*swbar*xiBG, 0}, {(-12*I)*cW*gc339*swbar*xiBG, 0}, {(12*I)*cW*gc339*swbar*xiBG, 0}, {0, 0}, {I*g2*gc339*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc339*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}},

C[ V[2] , -V[5] , V[6] ] == {{(-12*I)*cW*gc340*swbar, 0}, {(12*I)*cW*gc340*swbar, 0}, {I*g2*gc340*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc340*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc340*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc340*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc340*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc340*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*gc340*swbar, 0}, {(12*I)*cW*gc340*swbar, 0}, {(12*I)*cW*gc340*swbar, 0}, {(-12*I)*cW*gc340*swbar, 0}, {(-12*I)*cW*gc340*swbar, 0}, {(12*I)*cW*gc340*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , V[1] , -V[6] ] == {{-16*cHWB*cwbar*gc341, 0}, {-(g2*gc341*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc341, 0}, {0, 0}},

C[ S[4] , S[5] , V[1] , -V[6] ] == {{-16*cHWB*cwbar*gc342, 0}, {-(g2*gc342*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 - 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc342, 0}, {0, 0}},

C[ S[3] , S[6] , V[1] , -V[6] ] == {{-16*cHWB*cwbar*gc343, 0}, {-(g2*gc343*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 5*cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc343, 0}, {0, 0}},

C[ S[4] , S[6] , V[1] , -V[6] ] == {{-16*cHWB*cwbar*gc344, 0}, {-(g2*gc344*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc344, 0}, {0, 0}},

C[ S[5] , S[1] , V[1] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc345, 0}, {(-I)*g2*gc345*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc345, 0}, {0, 0}},

C[ S[6] , S[1] , V[1] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc346, 0}, {(-I)*g2*gc346*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc346, 0}, {0, 0}},

C[ S[5] , S[2] , V[1] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc347, 0}, {(-I)*g2*gc347*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc347, 0}, {0, 0}},

C[ S[6] , S[2] , V[1] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc348, 0}, {(-I)*g2*gc348*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc348, 0}, {0, 0}},

C[ S[5] , V[1] , -V[6] ] == {{(-8*I)*cHWB*cwbar*gc349, 0}, {I*g2*gc349*(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + g2*swbar*(-2 + cHD*vev^2 - 4*cHW*vev^2) - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc349, 0}, {0, 0}},

C[ S[6] , V[1] , -V[6] ] == {{(-8*I)*cHWB*cwbar*gc350, 0}, {(-I)*g2*gc350*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc350, 0}, {0, 0}},

C[ S[3] , S[5] , V[2] , -V[6] ] == {{-16*cHWB*cwbar*gc351, 0}, {-(g2*gc351*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc351, 0}, {0, 0}},

C[ S[4] , S[5] , V[2] , -V[6] ] == {{-16*cHWB*cwbar*gc352, 0}, {-(g2*gc352*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc352, 0}, {0, 0}},

C[ S[3] , S[6] , V[2] , -V[6] ] == {{-16*cHWB*cwbar*gc353, 0}, {-(g2*gc353*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc353, 0}, {0, 0}},

C[ S[4] , S[6] , V[2] , -V[6] ] == {{-16*cHWB*cwbar*gc354, 0}, {-(g2*gc354*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*cwbar*gc354, 0}, {0, 0}},

C[ S[5] , S[1] , V[2] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc355, 0}, {(-I)*g2*gc355*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc355, 0}, {0, 0}},

C[ S[6] , S[1] , V[2] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc356, 0}, {(-I)*g2*gc356*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc356, 0}, {0, 0}},

C[ S[5] , S[2] , V[2] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc357, 0}, {(-I)*g2*gc357*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc357, 0}, {0, 0}},

C[ S[6] , S[2] , V[2] , -V[6] ] == {{(-16*I)*cHWB*cwbar*gc358, 0}, {(-I)*g2*gc358*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*cwbar*gc358, 0}, {0, 0}},

C[ S[5] , V[2] , -V[6] ] == {{(-8*I)*cHWB*cwbar*gc359, 0}, {(-I)*g2*gc359*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc359, 0}, {0, 0}},

C[ S[6] , V[2] , -V[6] ] == {{(-8*I)*cHWB*cwbar*gc360, 0}, {(-I)*g2*gc360*(-((cHWB*g1 + cHD*g2)*swbar*vev^2) + cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*cwbar*gc360, 0}, {0, 0}},

C[ S[3] , S[3] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc361, 0}, {I*g2^2*gc361*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc361, 0}, {0, 0}},

C[ S[3] , S[4] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc362, 0}, {I*g2^2*gc362*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc362, 0}, {0, 0}},

C[ S[4] , S[4] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc363, 0}, {I*g2^2*gc363*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc363, 0}, {0, 0}},

C[ S[5] , -S[5] , V[5] , -V[6] ] == {{(-8*I)*cHW*gc364, 0}, {(-I)*g2^2*gc364*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc364, 0}, {0, 0}},

C[ -S[5] , S[6] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc365, 0}, {(-I)*g2^2*gc365*(4 + cHD*vev^2 + 8*cHW*vev^2), 0}, {(16*I)*cHW*gc365, 0}, {0, 0}},

C[ S[5] , -S[6] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc366, 0}, {(-3*I)*cHD*g2^2*gc366*vev^2, 0}, {(16*I)*cHW*gc366, 0}, {0, 0}},

C[ S[6] , -S[6] , V[5] , -V[6] ] == {{(-8*I)*cHW*gc367, 0}, {(-I)*g2^2*gc367*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc367, 0}, {0, 0}},

C[ S[1] , S[1] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc368, 0}, {(-I)*g2^2*gc368*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc368, 0}, {0, 0}},

C[ S[1] , S[2] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc369, 0}, {(-I)*g2^2*gc369*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc369, 0}, {0, 0}},

C[ S[2] , S[2] , V[5] , -V[6] ] == {{(-16*I)*cHW*gc370, 0}, {(-I)*g2^2*gc370*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc370, 0}, {0, 0}},

C[ S[1] , V[5] , -V[6] ] == {{(-32*I)*cHW*gc371, 0}, {(-I)*g2^2*gc371*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc371, 0}, {0, 0}},

C[ S[2] , V[5] , -V[6] ] == {{(-32*I)*cHW*gc372, 0}, {(-I)*g2^2*gc372*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc372, 0}, {0, 0}},

C[ V[1] , V[5] , -V[6] ] == {{(-12*I)*cW*gc373*swbar*xiBG, 0}, {(12*I)*cW*gc373*swbar*xiBG, 0}, {I*g2*gc373*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc373*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc373*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc373*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc373*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc373*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2))*xiBG, 0}, {(-12*I)*cW*gc373*swbar*xiBG, 0}, {(12*I)*cW*gc373*swbar*xiBG, 0}, {(12*I)*cW*gc373*swbar*xiBG, 0}, {(-12*I)*cW*gc373*swbar*xiBG, 0}, {(-12*I)*cW*gc373*swbar*xiBG, 0}, {(12*I)*cW*gc373*swbar*xiBG, 0}, {0, 0}, {I*g2*gc373*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc373*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}},

C[ V[2] , V[5] , -V[6] ] == {{(-12*I)*cW*gc374*swbar, 0}, {(12*I)*cW*gc374*swbar, 0}, {I*g2*gc374*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc374*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc374*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc374*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc374*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc374*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*gc374*swbar, 0}, {(12*I)*cW*gc374*swbar, 0}, {(12*I)*cW*gc374*swbar, 0}, {(-12*I)*cW*gc374*swbar, 0}, {(-12*I)*cW*gc374*swbar, 0}, {(12*I)*cW*gc374*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc375, 0}, {I*g2^2*gc375*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc375, 0}, {0, 0}},

C[ S[3] , S[4] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc376, 0}, {I*g2^2*gc376*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc376, 0}, {0, 0}},

C[ S[4] , S[4] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc377, 0}, {I*g2^2*gc377*(-2 + cHD*vev^2 - 4*cHW*vev^2), 0}, {(16*I)*cHW*gc377, 0}, {0, 0}},

C[ S[5] , -S[5] , V[6] , -V[6] ] == {{(-8*I)*cHW*gc378, 0}, {(-I)*g2^2*gc378*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc378, 0}, {0, 0}},

C[ -S[5] , S[6] , V[6] , -V[6] ] == {{(-8*I)*cHW*gc379, 0}, {(-I)*g2^2*gc379*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc379, 0}, {0, 0}},

C[ S[5] , -S[6] , V[6] , -V[6] ] == {{(-8*I)*cHW*gc380, 0}, {(-I)*g2^2*gc380*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc380, 0}, {0, 0}},

C[ S[6] , -S[6] , V[6] , -V[6] ] == {{(-8*I)*cHW*gc381, 0}, {(-I)*g2^2*gc381*(1 + cHD*vev^2 + 2*cHW*vev^2), 0}, {(8*I)*cHW*gc381, 0}, {0, 0}},

C[ S[1] , S[1] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc382, 0}, {(-I)*g2^2*gc382*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc382, 0}, {0, 0}},

C[ S[1] , S[2] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc383, 0}, {(-I)*g2^2*gc383*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc383, 0}, {0, 0}},

C[ S[2] , S[2] , V[6] , -V[6] ] == {{(-16*I)*cHW*gc384, 0}, {(-I)*g2^2*gc384*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2), 0}, {(16*I)*cHW*gc384, 0}, {0, 0}},

C[ S[1] , V[6] , -V[6] ] == {{(-32*I)*cHW*gc385, 0}, {(-I)*g2^2*gc385*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc385, 0}, {0, 0}},

C[ S[2] , V[6] , -V[6] ] == {{(-32*I)*cHW*gc386, 0}, {(-I)*g2^2*gc386*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2), 0}, {(32*I)*cHW*gc386, 0}, {0, 0}},

C[ V[1] , V[6] , -V[6] ] == {{(-12*I)*cW*gc387*swbar, 0}, {(12*I)*cW*gc387*swbar, 0}, {I*g2*gc387*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc387*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc387*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc387*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc387*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc387*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*gc387*swbar, 0}, {(12*I)*cW*gc387*swbar, 0}, {(12*I)*cW*gc387*swbar, 0}, {(-12*I)*cW*gc387*swbar, 0}, {(-12*I)*cW*gc387*swbar, 0}, {(12*I)*cW*gc387*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[6] , -V[6] ] == {{(-12*I)*cW*gc388*swbar, 0}, {(12*I)*cW*gc388*swbar, 0}, {I*g2*gc388*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc388*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc388*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc388*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc388*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)), 0}, {I*g2*gc388*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*gc388*swbar, 0}, {(12*I)*cW*gc388*swbar, 0}, {(12*I)*cW*gc388*swbar, 0}, {(-12*I)*cW*gc388*swbar, 0}, {(-12*I)*cW*gc388*swbar, 0}, {(12*I)*cW*gc388*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , V[3] ] == {{I*gc389, 0}, {(-I)*gc389, 0}, {I*gc389, 0}},

C[ S[5] , -S[6] , V[3] ] == {{I*gc390, 0}, {(-I)*gc390, 0}, {I*gc390, 0}},

C[ S[4] , S[1] , V[3] ] == {{gc391*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc391*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {gc391*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}},

C[ S[3] , S[2] , V[3] ] == {{gc392*swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2)) + cwbar*gc392*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}, {-(gc392*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2))), 0}, {gc392*swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2)) + cwbar*gc392*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)), 0}},

C[ S[3] , S[4] , S[4] , V[3] ] == {{gc393, 0}, {gc393, 0}, {gc393, 0}, {gc393, 0}},

C[ S[3] , S[6] , -S[6] , V[3] ] == {{gc394, 0}, {0, 0}, {0, 0}, {gc394, 0}},

C[ -S[5] , S[6] , S[2] , V[3] ] == {{I*gc395, 0}, {(-I)*gc395, 0}, {0, 0}, {I*gc395, 0}},

C[ S[5] , -S[6] , S[2] , V[3] ] == {{I*gc396, 0}, {(-I)*gc396, 0}, {0, 0}, {I*gc396, 0}},

C[ S[4] , S[1] , S[2] , V[3] ] == {{-3*gc397, 0}, {gc397, 0}, {gc397, 0}, {gc397, 0}},

C[ S[3] , S[2] , S[2] , V[3] ] == {{3*gc398, 0}, {-gc398, 0}, {-gc398, 0}, {3*gc398, 0}},

C[ S[4] , S[4] , V[1] , V[3] ] == {{(-8*I)*gc399*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(-I)*gc399*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc399*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(8*I)*gc399*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}},

C[ S[6] , -S[6] , V[1] , V[3] ] == {{(-8*I)*gc400*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2))*xiBG, 0}, {I*gc400*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)))*xiBG, 0}, {(8*I)*gc400*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2))*xiBG, 0}, {(8*I)*gc400*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}},

C[ S[2] , S[2] , V[1] , V[3] ] == {{(-8*I)*gc401*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(-I)*gc401*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc401*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(8*I)*gc401*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}},

C[ S[2] , V[1] , V[3] ] == {{(-16*I)*gc402*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(-I)*gc402*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)))*xiBG, 0}, {(16*I)*gc402*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2))*xiBG, 0}, {(16*I)*gc402*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}},

C[ S[4] , -S[6] , V[5] , V[3] ] == {{-16*cHWB*gc403*swbar*xiBG, 0}, {-(g2*gc403*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG), 0}, {16*cHWB*gc403*swbar*xiBG, 0}, {16*cHWB*gc403*swbar, 0}},

C[ -S[6] , S[2] , V[5] , V[3] ] == {{(-16*I)*cHWB*gc404*swbar*xiBG, 0}, {(-I)*g2*gc404*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc404*swbar*xiBG, 0}, {(16*I)*cHWB*gc404*swbar, 0}},

C[ -S[6] , V[5] , V[3] ] == {{(-8*I)*cHWB*gc405*swbar*xiBG, 0}, {(-I)*g2*gc405*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc405*swbar*xiBG, 0}, {(8*I)*cHWB*gc405*swbar, 0}},

C[ S[4] , S[6] , -V[5] , V[3] ] == {{-16*cHWB*gc406*swbar*xiBG, 0}, {-(g2*gc406*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG), 0}, {16*cHWB*gc406*swbar*xiBG, 0}, {16*cHWB*gc406*swbar, 0}},

C[ S[6] , S[2] , -V[5] , V[3] ] == {{(-16*I)*cHWB*gc407*swbar*xiBG, 0}, {(-I)*g2*gc407*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc407*swbar*xiBG, 0}, {(16*I)*cHWB*gc407*swbar, 0}},

C[ S[6] , -V[5] , V[3] ] == {{(-8*I)*cHWB*gc408*swbar*xiBG, 0}, {(-I)*g2*gc408*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc408*swbar*xiBG, 0}, {(8*I)*cHWB*gc408*swbar, 0}},

C[ S[3] , S[3] , V[1] , V[3] ] == {{(-8*I)*gc409*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc409*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc409*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[4] , V[1] , V[3] ] == {{(-8*I)*gc410*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc410*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc410*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[1] , V[3] ] == {{(-8*I)*gc411*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc411*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc411*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[1] , V[3] ] == {{(-8*I)*gc412*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc412*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc412*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[1] , V[3] ] == {{(-8*I)*gc413*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc413*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc413*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[1] , V[1] , V[3] ] == {{(-8*I)*gc414*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc414*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc414*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , V[1] , V[3] ] == {{(-8*I)*gc415*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc415*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc415*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , V[1] , V[3] ] == {{(-16*I)*gc416*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc416*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc416*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[3] , V[2] , V[3] ] == {{(-8*I)*gc417*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc417*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc417*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[4] , V[2] , V[3] ] == {{(-8*I)*gc418*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc418*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc418*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[4] , S[4] , V[2] , V[3] ] == {{(-8*I)*gc419*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc419*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc419*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[2] , V[3] ] == {{(-8*I)*gc420*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc420*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc420*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[2] , V[3] ] == {{(-8*I)*gc421*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc421*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc421*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[2] , V[3] ] == {{(-8*I)*gc422*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc422*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc422*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[2] , V[3] ] == {{(-8*I)*gc423*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc423*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc423*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[1] , V[2] , V[3] ] == {{(-8*I)*gc424*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc424*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc424*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , V[2] , V[3] ] == {{(-8*I)*gc425*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc425*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc425*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , S[2] , V[2] , V[3] ] == {{(-8*I)*gc426*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc426*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc426*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , V[2] , V[3] ] == {{(-16*I)*gc427*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc427*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc427*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , V[2] , V[3] ] == {{(-16*I)*gc428*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc428*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc428*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , -S[5] , V[5] , V[3] ] == {{-16*cHWB*gc429*swbar, 0}, {-(g2*gc429*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc429*swbar, 0}, {0, 0}},

C[ S[4] , -S[5] , V[5] , V[3] ] == {{-16*cHWB*gc430*swbar, 0}, {-(g2*gc430*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc430*swbar, 0}, {0, 0}},

C[ S[3] , -S[6] , V[5] , V[3] ] == {{-16*cHWB*gc431*swbar, 0}, {-(g2*gc431*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc431*swbar, 0}, {0, 0}},

C[ -S[5] , S[1] , V[5] , V[3] ] == {{(-16*I)*cHWB*gc432*swbar, 0}, {(-I)*g2*gc432*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc432*swbar, 0}, {0, 0}},

C[ -S[6] , S[1] , V[5] , V[3] ] == {{(-16*I)*cHWB*gc433*swbar, 0}, {(-I)*g2*gc433*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc433*swbar, 0}, {0, 0}},

C[ -S[5] , S[2] , V[5] , V[3] ] == {{(-16*I)*cHWB*gc434*swbar, 0}, {(-I)*g2*gc434*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc434*swbar, 0}, {0, 0}},

C[ -S[5] , V[5] , V[3] ] == {{(-8*I)*cHWB*gc435*swbar, 0}, {(-I)*g2*gc435*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc435*swbar, 0}, {0, 0}},

C[ S[3] , S[5] , -V[5] , V[3] ] == {{-16*cHWB*gc436*swbar, 0}, {-(g2*gc436*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc436*swbar, 0}, {0, 0}},

C[ S[4] , S[5] , -V[5] , V[3] ] == {{-16*cHWB*gc437*swbar, 0}, {-(g2*gc437*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc437*swbar, 0}, {0, 0}},

C[ S[3] , S[6] , -V[5] , V[3] ] == {{-16*cHWB*gc438*swbar, 0}, {-(g2*gc438*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc438*swbar, 0}, {0, 0}},

C[ S[5] , S[1] , -V[5] , V[3] ] == {{(-16*I)*cHWB*gc439*swbar, 0}, {(-I)*g2*gc439*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc439*swbar, 0}, {0, 0}},

C[ S[6] , S[1] , -V[5] , V[3] ] == {{(-16*I)*cHWB*gc440*swbar, 0}, {(-I)*g2*gc440*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc440*swbar, 0}, {0, 0}},

C[ S[5] , S[2] , -V[5] , V[3] ] == {{(-16*I)*cHWB*gc441*swbar, 0}, {(-I)*g2*gc441*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc441*swbar, 0}, {0, 0}},

C[ S[5] , -V[5] , V[3] ] == {{(-8*I)*cHWB*gc442*swbar, 0}, {(-I)*g2*gc442*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc442*swbar, 0}, {0, 0}},

C[ V[5] , -V[5] , V[3] ] == {{(-12*I)*cW*cwbar*gc443, 0}, {(12*I)*cW*cwbar*gc443, 0}, {I*g2*gc443*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc443*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc443*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc443*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc443*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc443*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*cwbar*gc443, 0}, {(12*I)*cW*cwbar*gc443, 0}, {(12*I)*cW*cwbar*gc443, 0}, {(-12*I)*cW*cwbar*gc443, 0}, {(-12*I)*cW*cwbar*gc443, 0}, {(12*I)*cW*cwbar*gc443, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , V[6] , V[3] ] == {{-16*cHWB*gc444*swbar, 0}, {-(g2*gc444*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc444*swbar, 0}, {0, 0}},

C[ S[4] , -S[5] , V[6] , V[3] ] == {{-16*cHWB*gc445*swbar, 0}, {-(g2*gc445*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc445*swbar, 0}, {0, 0}},

C[ S[3] , -S[6] , V[6] , V[3] ] == {{-16*cHWB*gc446*swbar, 0}, {-(g2*gc446*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 5*cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*gc446*swbar, 0}, {0, 0}},

C[ S[4] , -S[6] , V[6] , V[3] ] == {{-16*cHWB*gc447*swbar, 0}, {-(g2*gc447*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc447*swbar, 0}, {0, 0}},

C[ -S[5] , S[1] , V[6] , V[3] ] == {{(-16*I)*cHWB*gc448*swbar, 0}, {(-I)*g2*gc448*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc448*swbar, 0}, {0, 0}},

C[ -S[6] , S[1] , V[6] , V[3] ] == {{(-16*I)*cHWB*gc449*swbar, 0}, {(-I)*g2*gc449*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc449*swbar, 0}, {0, 0}},

C[ -S[5] , S[2] , V[6] , V[3] ] == {{(-16*I)*cHWB*gc450*swbar, 0}, {I*g2*gc450*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 - g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc450*swbar, 0}, {0, 0}},

C[ -S[6] , S[2] , V[6] , V[3] ] == {{(-16*I)*cHWB*gc451*swbar, 0}, {(-I)*g2*gc451*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc451*swbar, 0}, {0, 0}},

C[ -S[5] , V[6] , V[3] ] == {{(-8*I)*cHWB*gc452*swbar, 0}, {(-I)*g2*gc452*(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + cwbar*g2*(-2 + cHD*vev^2 - 4*cHW*vev^2) + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc452*swbar, 0}, {0, 0}},

C[ -S[6] , V[6] , V[3] ] == {{(-8*I)*cHWB*gc453*swbar, 0}, {(-I)*g2*gc453*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc453*swbar, 0}, {0, 0}},

C[ -V[5] , V[6] , V[3] ] == {{(12*I)*cW*cwbar*gc454*xiBG, 0}, {(-12*I)*cW*cwbar*gc454*xiBG, 0}, {(-I)*g2*gc454*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc454*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc454*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc454*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc454*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc454*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(12*I)*cW*cwbar*gc454*xiBG, 0}, {(-12*I)*cW*cwbar*gc454*xiBG, 0}, {(-12*I)*cW*cwbar*gc454*xiBG, 0}, {(12*I)*cW*cwbar*gc454*xiBG, 0}, {(12*I)*cW*cwbar*gc454*xiBG, 0}, {(-12*I)*cW*cwbar*gc454*xiBG, 0}, {I*g2*gc454*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {0, 0}, {I*g2*gc454*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}},

C[ S[3] , S[5] , -V[6] , V[3] ] == {{-16*cHWB*gc455*swbar, 0}, {-(g2*gc455*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc455*swbar, 0}, {0, 0}},

C[ S[4] , S[5] , -V[6] , V[3] ] == {{-16*cHWB*gc456*swbar, 0}, {-(g2*gc456*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc456*swbar, 0}, {0, 0}},

C[ S[3] , S[6] , -V[6] , V[3] ] == {{-16*cHWB*gc457*swbar, 0}, {-(g2*gc457*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 5*cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*gc457*swbar, 0}, {0, 0}},

C[ S[4] , S[6] , -V[6] , V[3] ] == {{-16*cHWB*gc458*swbar, 0}, {-(g2*gc458*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc458*swbar, 0}, {0, 0}},

C[ S[5] , S[1] , -V[6] , V[3] ] == {{(-16*I)*cHWB*gc459*swbar, 0}, {(-I)*g2*gc459*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc459*swbar, 0}, {0, 0}},

C[ S[6] , S[1] , -V[6] , V[3] ] == {{(-16*I)*cHWB*gc460*swbar, 0}, {(-I)*g2*gc460*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc460*swbar, 0}, {0, 0}},

C[ S[5] , S[2] , -V[6] , V[3] ] == {{(-16*I)*cHWB*gc461*swbar, 0}, {I*g2*gc461*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 - g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc461*swbar, 0}, {0, 0}},

C[ S[6] , S[2] , -V[6] , V[3] ] == {{(-16*I)*cHWB*gc462*swbar, 0}, {(-I)*g2*gc462*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc462*swbar, 0}, {0, 0}},

C[ S[5] , -V[6] , V[3] ] == {{(-8*I)*cHWB*gc463*swbar, 0}, {(-I)*g2*gc463*(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + cwbar*g2*(-2 + cHD*vev^2 - 4*cHW*vev^2) + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc463*swbar, 0}, {0, 0}},

C[ S[6] , -V[6] , V[3] ] == {{(-8*I)*cHWB*gc464*swbar, 0}, {(-I)*g2*gc464*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc464*swbar, 0}, {0, 0}},

C[ V[5] , -V[6] , V[3] ] == {{(12*I)*cW*cwbar*gc465*xiBG, 0}, {(-12*I)*cW*cwbar*gc465*xiBG, 0}, {(-I)*g2*gc465*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc465*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc465*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc465*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc465*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc465*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(12*I)*cW*cwbar*gc465*xiBG, 0}, {(-12*I)*cW*cwbar*gc465*xiBG, 0}, {(-12*I)*cW*cwbar*gc465*xiBG, 0}, {(12*I)*cW*cwbar*gc465*xiBG, 0}, {(12*I)*cW*cwbar*gc465*xiBG, 0}, {(-12*I)*cW*cwbar*gc465*xiBG, 0}, {I*g2*gc465*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {0, 0}, {I*g2*gc465*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}},

C[ V[6] , -V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc466, 0}, {(12*I)*cW*cwbar*gc466, 0}, {I*g2*gc466*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc466*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc466*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc466*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc466*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc466*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*cwbar*gc466, 0}, {(12*I)*cW*cwbar*gc466, 0}, {(12*I)*cW*cwbar*gc466, 0}, {(-12*I)*cW*cwbar*gc466, 0}, {(-12*I)*cW*cwbar*gc466, 0}, {(12*I)*cW*cwbar*gc466, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , V[3] , V[3] ] == {{(-16*I)*gc467*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc467*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc467*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[3] , V[3] ] == {{(-16*I)*gc468*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc468*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc468*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[3] , V[3] ] == {{(-16*I)*gc469*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(-I)*gc469*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc469*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(16*I)*gc469*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}},

C[ S[5] , -S[5] , V[3] , V[3] ] == {{(-8*I)*gc470*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc470*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc470*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[3] , V[3] ] == {{(-8*I)*gc471*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc471*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc471*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[3] , V[3] ] == {{(-8*I)*gc472*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc472*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc472*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[3] , V[3] ] == {{(-8*I)*gc473*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar))*xiBG, 0}, {I*gc473*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2))*xiBG, 0}, {(8*I)*gc473*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar))*xiBG, 0}, {(8*I)*gc473*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}},

C[ S[1] , S[1] , V[3] , V[3] ] == {{(-16*I)*gc474*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc474*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc474*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[3] , V[3] ] == {{(-16*I)*gc475*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc475*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc475*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[3] , V[3] ] == {{(-16*I)*gc476*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(-I)*gc476*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc476*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(16*I)*gc476*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}},

C[ S[1] , V[3] , V[3] ] == {{(-32*I)*gc477*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc477*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc477*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , V[3] , V[3] ] == {{(-32*I)*gc478*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(-I)*gc478*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG, 0}, {(32*I)*gc478*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar))*xiBG, 0}, {(32*I)*gc478*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}},

C[ S[3] , S[3] , V[1] , V[4] ] == {{(-8*I)*gc479*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc479*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc479*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[4] , V[1] , V[4] ] == {{(-8*I)*gc480*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc480*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc480*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[4] , S[4] , V[1] , V[4] ] == {{(-8*I)*gc481*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc481*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc481*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[1] , V[4] ] == {{(-8*I)*gc482*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc482*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc482*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[1] , V[4] ] == {{(-8*I)*gc483*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc483*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc483*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[1] , V[4] ] == {{(-8*I)*gc484*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc484*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc484*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[1] , V[4] ] == {{(-8*I)*gc485*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc485*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc485*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[1] , V[1] , V[4] ] == {{(-8*I)*gc486*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc486*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc486*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , V[1] , V[4] ] == {{(-8*I)*gc487*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc487*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc487*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , S[2] , V[1] , V[4] ] == {{(-8*I)*gc488*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc488*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc488*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , V[1] , V[4] ] == {{(-16*I)*gc489*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc489*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc489*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , V[1] , V[4] ] == {{(-16*I)*gc490*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc490*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc490*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[3] , V[2] , V[4] ] == {{(-8*I)*gc491*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc491*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc491*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , S[4] , V[2] , V[4] ] == {{(-8*I)*gc492*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc492*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc492*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[4] , S[4] , V[2] , V[4] ] == {{(-8*I)*gc493*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc493*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc493*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[2] , V[4] ] == {{(-8*I)*gc494*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc494*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc494*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[2] , V[4] ] == {{(-8*I)*gc495*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc495*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc495*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[2] , V[4] ] == {{(-8*I)*gc496*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc496*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc496*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[2] , V[4] ] == {{(-8*I)*gc497*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {I*gc497*(-2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + cwbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2))), 0}, {(8*I)*gc497*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[1] , V[2] , V[4] ] == {{(-8*I)*gc498*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc498*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc498*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , V[2] , V[4] ] == {{(-8*I)*gc499*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc499*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc499*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , S[2] , V[2] , V[4] ] == {{(-8*I)*gc500*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc500*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))), 0}, {(8*I)*gc500*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , V[2] , V[4] ] == {{(-16*I)*gc501*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc501*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc501*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[2] , V[2] , V[4] ] == {{(-16*I)*gc502*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {(-I)*gc502*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))), 0}, {(16*I)*gc502*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[3] , -S[5] , V[5] , V[4] ] == {{-16*cHWB*gc503*swbar, 0}, {-(g2*gc503*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc503*swbar, 0}, {0, 0}},

C[ S[4] , -S[5] , V[5] , V[4] ] == {{-16*cHWB*gc504*swbar, 0}, {-(g2*gc504*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*gc504*swbar, 0}, {0, 0}},

C[ S[3] , -S[6] , V[5] , V[4] ] == {{-16*cHWB*gc505*swbar, 0}, {-(g2*gc505*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*gc505*swbar, 0}, {0, 0}},

C[ S[4] , -S[6] , V[5] , V[4] ] == {{-16*cHWB*gc506*swbar, 0}, {-(g2*gc506*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc506*swbar, 0}, {0, 0}},

C[ -S[5] , S[1] , V[5] , V[4] ] == {{(-16*I)*cHWB*gc507*swbar, 0}, {(-I)*g2*gc507*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc507*swbar, 0}, {0, 0}},

C[ -S[6] , S[1] , V[5] , V[4] ] == {{(-16*I)*cHWB*gc508*swbar, 0}, {I*g2*gc508*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 - g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc508*swbar, 0}, {0, 0}},

C[ -S[5] , S[2] , V[5] , V[4] ] == {{(-16*I)*cHWB*gc509*swbar, 0}, {(-I)*g2*gc509*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc509*swbar, 0}, {0, 0}},

C[ -S[6] , S[2] , V[5] , V[4] ] == {{(-16*I)*cHWB*gc510*swbar, 0}, {(-I)*g2*gc510*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc510*swbar, 0}, {0, 0}},

C[ -S[5] , V[5] , V[4] ] == {{(-8*I)*cHWB*gc511*swbar, 0}, {(-I)*g2*gc511*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(8*I)*cHWB*gc511*swbar, 0}, {0, 0}},

C[ -S[6] , V[5] , V[4] ] == {{(-8*I)*cHWB*gc512*swbar, 0}, {(-I)*g2*gc512*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc512*swbar, 0}, {0, 0}},

C[ S[3] , S[5] , -V[5] , V[4] ] == {{-16*cHWB*gc513*swbar, 0}, {-(g2*gc513*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc513*swbar, 0}, {0, 0}},

C[ S[4] , S[5] , -V[5] , V[4] ] == {{-16*cHWB*gc514*swbar, 0}, {-(g2*gc514*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2))), 0}, {16*cHWB*gc514*swbar, 0}, {0, 0}},

C[ S[3] , S[6] , -V[5] , V[4] ] == {{-16*cHWB*gc515*swbar, 0}, {g2*gc515*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 - g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2)), 0}, {16*cHWB*gc515*swbar, 0}, {0, 0}},

C[ S[4] , S[6] , -V[5] , V[4] ] == {{-16*cHWB*gc516*swbar, 0}, {-(g2*gc516*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc516*swbar, 0}, {0, 0}},

C[ S[5] , S[1] , -V[5] , V[4] ] == {{(-16*I)*cHWB*gc517*swbar, 0}, {(-I)*g2*gc517*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc517*swbar, 0}, {0, 0}},

C[ S[6] , S[1] , -V[5] , V[4] ] == {{(-16*I)*cHWB*gc518*swbar, 0}, {I*g2*gc518*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 - g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 - 7*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc518*swbar, 0}, {0, 0}},

C[ S[5] , S[2] , -V[5] , V[4] ] == {{(-16*I)*cHWB*gc519*swbar, 0}, {(-I)*g2*gc519*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(16*I)*cHWB*gc519*swbar, 0}, {0, 0}},

C[ S[6] , S[2] , -V[5] , V[4] ] == {{(-16*I)*cHWB*gc520*swbar, 0}, {(-I)*g2*gc520*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc520*swbar, 0}, {0, 0}},

C[ S[5] , -V[5] , V[4] ] == {{(-8*I)*cHWB*gc521*swbar, 0}, {(-I)*g2*gc521*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(8*I)*cHWB*gc521*swbar, 0}, {0, 0}},

C[ S[6] , -V[5] , V[4] ] == {{(-8*I)*cHWB*gc522*swbar, 0}, {(-I)*g2*gc522*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc522*swbar, 0}, {0, 0}},

C[ V[5] , -V[5] , V[4] ] == {{(-12*I)*cW*cwbar*gc523*xiBG, 0}, {(12*I)*cW*cwbar*gc523*xiBG, 0}, {I*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-I)*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc523*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {I*g2*gc523*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc523*xiBG, 0}, {(12*I)*cW*cwbar*gc523*xiBG, 0}, {(12*I)*cW*cwbar*gc523*xiBG, 0}, {(-12*I)*cW*cwbar*gc523*xiBG, 0}, {(-12*I)*cW*cwbar*gc523*xiBG, 0}, {(12*I)*cW*cwbar*gc523*xiBG, 0}, {0, 0}, {(-I)*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc523*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}},

C[ S[3] , -S[5] , V[6] , V[4] ] == {{-16*cHWB*gc524*swbar, 0}, {-(g2*gc524*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc524*swbar, 0}, {0, 0}},

C[ S[4] , -S[5] , V[6] , V[4] ] == {{-16*cHWB*gc525*swbar, 0}, {-(g2*gc525*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc525*swbar, 0}, {0, 0}},

C[ S[3] , -S[6] , V[6] , V[4] ] == {{-16*cHWB*gc526*swbar, 0}, {-(g2*gc526*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc526*swbar, 0}, {0, 0}},

C[ S[4] , -S[6] , V[6] , V[4] ] == {{-16*cHWB*gc527*swbar, 0}, {-(g2*gc527*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc527*swbar, 0}, {0, 0}},

C[ -S[5] , S[1] , V[6] , V[4] ] == {{(-16*I)*cHWB*gc528*swbar, 0}, {(-I)*g2*gc528*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc528*swbar, 0}, {0, 0}},

C[ -S[6] , S[1] , V[6] , V[4] ] == {{(-16*I)*cHWB*gc529*swbar, 0}, {(-I)*g2*gc529*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc529*swbar, 0}, {0, 0}},

C[ -S[5] , S[2] , V[6] , V[4] ] == {{(-16*I)*cHWB*gc530*swbar, 0}, {(-I)*g2*gc530*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc530*swbar, 0}, {0, 0}},

C[ -S[6] , S[2] , V[6] , V[4] ] == {{(-16*I)*cHWB*gc531*swbar, 0}, {(-I)*g2*gc531*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc531*swbar, 0}, {0, 0}},

C[ -S[5] , V[6] , V[4] ] == {{(-8*I)*cHWB*gc532*swbar, 0}, {(-I)*g2*gc532*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc532*swbar, 0}, {0, 0}},

C[ -S[6] , V[6] , V[4] ] == {{(-8*I)*cHWB*gc533*swbar, 0}, {(-I)*g2*gc533*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc533*swbar, 0}, {0, 0}},

C[ -V[5] , V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc534, 0}, {(12*I)*cW*cwbar*gc534, 0}, {I*g2*gc534*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc534*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc534*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc534*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc534*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc534*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*cwbar*gc534, 0}, {(12*I)*cW*cwbar*gc534, 0}, {(12*I)*cW*cwbar*gc534, 0}, {(-12*I)*cW*cwbar*gc534, 0}, {(-12*I)*cW*cwbar*gc534, 0}, {(12*I)*cW*cwbar*gc534, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -V[6] , V[4] ] == {{-16*cHWB*gc535*swbar, 0}, {-(g2*gc535*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc535*swbar, 0}, {0, 0}},

C[ S[4] , S[5] , -V[6] , V[4] ] == {{-16*cHWB*gc536*swbar, 0}, {-(g2*gc536*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc536*swbar, 0}, {0, 0}},

C[ S[3] , S[6] , -V[6] , V[4] ] == {{-16*cHWB*gc537*swbar, 0}, {-(g2*gc537*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc537*swbar, 0}, {0, 0}},

C[ S[4] , S[6] , -V[6] , V[4] ] == {{-16*cHWB*gc538*swbar, 0}, {-(g2*gc538*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))), 0}, {16*cHWB*gc538*swbar, 0}, {0, 0}},

C[ S[5] , S[1] , -V[6] , V[4] ] == {{(-16*I)*cHWB*gc539*swbar, 0}, {(-I)*g2*gc539*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc539*swbar, 0}, {0, 0}},

C[ S[6] , S[1] , -V[6] , V[4] ] == {{(-16*I)*cHWB*gc540*swbar, 0}, {(-I)*g2*gc540*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc540*swbar, 0}, {0, 0}},

C[ S[5] , S[2] , -V[6] , V[4] ] == {{(-16*I)*cHWB*gc541*swbar, 0}, {(-I)*g2*gc541*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc541*swbar, 0}, {0, 0}},

C[ S[6] , S[2] , -V[6] , V[4] ] == {{(-16*I)*cHWB*gc542*swbar, 0}, {(-I)*g2*gc542*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*cHWB*gc542*swbar, 0}, {0, 0}},

C[ S[5] , -V[6] , V[4] ] == {{(-8*I)*cHWB*gc543*swbar, 0}, {(-I)*g2*gc543*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc543*swbar, 0}, {0, 0}},

C[ S[6] , -V[6] , V[4] ] == {{(-8*I)*cHWB*gc544*swbar, 0}, {(-I)*g2*gc544*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)), 0}, {(8*I)*cHWB*gc544*swbar, 0}, {0, 0}},

C[ V[5] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc545, 0}, {(12*I)*cW*cwbar*gc545, 0}, {I*g2*gc545*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc545*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc545*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc545*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc545*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc545*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*cwbar*gc545, 0}, {(12*I)*cW*cwbar*gc545, 0}, {(12*I)*cW*cwbar*gc545, 0}, {(-12*I)*cW*cwbar*gc545, 0}, {(-12*I)*cW*cwbar*gc545, 0}, {(12*I)*cW*cwbar*gc545, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[6] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc546, 0}, {(12*I)*cW*cwbar*gc546, 0}, {I*g2*gc546*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc546*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {(-I)*g2*gc546*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc546*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc546*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)), 0}, {I*g2*gc546*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)), 0}, {(-12*I)*cW*cwbar*gc546, 0}, {(12*I)*cW*cwbar*gc546, 0}, {(12*I)*cW*cwbar*gc546, 0}, {(-12*I)*cW*cwbar*gc546, 0}, {(-12*I)*cW*cwbar*gc546, 0}, {(12*I)*cW*cwbar*gc546, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , V[3] , V[4] ] == {{(-16*I)*gc547*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc547*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc547*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[3] , V[4] ] == {{(-16*I)*gc548*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc548*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc548*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[3] , V[4] ] == {{(-16*I)*gc549*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc549*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc549*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[3] , V[4] ] == {{(-8*I)*gc550*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc550*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc550*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[3] , V[4] ] == {{(-8*I)*gc551*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc551*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc551*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[3] , V[4] ] == {{(-8*I)*gc552*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc552*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc552*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[3] , V[4] ] == {{(-8*I)*gc553*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc553*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc553*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[1] , V[3] , V[4] ] == {{(-16*I)*gc554*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc554*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc554*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[3] , V[4] ] == {{(-16*I)*gc555*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc555*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc555*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[3] , V[4] ] == {{(-16*I)*gc556*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc556*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc556*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , V[3] , V[4] ] == {{(-32*I)*gc557*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc557*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc557*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , V[3] , V[4] ] == {{(-32*I)*gc558*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc558*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc558*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[3] , S[3] , V[4] , V[4] ] == {{(-16*I)*gc559*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc559*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc559*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , V[4] , V[4] ] == {{(-16*I)*gc560*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc560*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc560*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[4] , S[4] , V[4] , V[4] ] == {{(-16*I)*gc561*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc561*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc561*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[5] , -S[5] , V[4] , V[4] ] == {{(-8*I)*gc562*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc562*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc562*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , V[4] , V[4] ] == {{(-8*I)*gc563*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc563*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc563*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[5] , -S[6] , V[4] , V[4] ] == {{(-8*I)*gc564*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc564*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc564*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[6] , -S[6] , V[4] , V[4] ] == {{(-8*I)*gc565*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {I*gc565*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2)), 0}, {(8*I)*gc565*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[1] , V[4] , V[4] ] == {{(-16*I)*gc566*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc566*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc566*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , V[4] , V[4] ] == {{(-16*I)*gc567*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc567*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc567*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , S[2] , V[4] , V[4] ] == {{(-16*I)*gc568*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc568*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)), 0}, {(16*I)*gc568*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , V[4] , V[4] ] == {{(-32*I)*gc569*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc569*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc569*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[2] , V[4] , V[4] ] == {{(-32*I)*gc570*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {(-I)*gc570*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)), 0}, {(32*I)*gc570*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[3] , S[4] , -U[1] , U[1] ] == {{I*gc571, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[1] , U[1] ] == {{I*gc572*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2*swbar*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc572*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , -U[1] , U[1] ] == {{I*gc573, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , -U[1] , U[1] ] == {{I*gc574, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[1] , U[1] ] == {{I*gc575*(cwbar*g1 + g2*swbar)*(swbar*(g2 - cHWB*g1*vev^2 - cHD*g2*vev^2 + 2*cHW*g2*vev^2) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2))*xiBG, 0}, {(8*I)*gc575*(cHB*cwbar^2 + swbar*(cHWB*cwbar + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , -U[1] , U[1] ] == {{I*gc576, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[1] , U[1] ] == {{I*gc577*(cwbar*g1 - g2*swbar)*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2*swbar*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc577*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[1] , -U[1] , U[1] ] == {{I*gc578, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[1] , U[1] ] == {{I*gc579*(cwbar*g1 - g2*swbar)*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG, 0}, {(32*I)*gc579*(cHB*cwbar^2 + swbar*(-(cHWB*cwbar) + cHW*swbar)), 0}, {0, 0}},

C[ S[4] , S[5] , -U[1] , U[4] ] == {{gc580, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -U[1] , U[4] ] == {{gc581, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -U[1] , U[4] ] == {{g2*gc582*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*cwbar*gc582, 0}, {0, 0}},

C[ S[6] , S[1] , -U[1] , U[4] ] == {{I*gc583, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[2] , -U[1] , U[4] ] == {{I*gc584, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[2] , -U[1] , U[4] ] == {{I*g2*gc585*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc585, 0}, {0, 0}},

C[ S[5] , -U[1] , U[4] ] == {{I*gc586, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[1] , U[4] ] == {{(-I)*g2*gc587*((cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc587, 0}, {0, 0}},

C[ S[6] , -U[1] , U[4] , V[1] ] == {{I*gc588, 0}, {I*gc588, 0}, {0, 0}},

C[ S[6] , -U[1] , U[4] , V[2] ] == {{(-I)*gc589, 0}, {(-I)*gc589, 0}, {I*gc589, 0}},

C[ S[4] , -S[5] , -U[1] , U[3] ] == {{gc590, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[6] , -U[1] , U[3] ] == {{gc591, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[6] , -U[1] , U[3] ] == {{g2*gc592*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*cwbar*gc592, 0}, {0, 0}},

C[ -S[6] , S[1] , -U[1] , U[3] ] == {{I*gc593, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[2] , -U[1] , U[3] ] == {{I*gc594, 0}, {0, 0}, {0, 0}},

C[ -S[6] , S[2] , -U[1] , U[3] ] == {{I*g2*gc595*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc595, 0}, {0, 0}},

C[ -S[5] , -U[1] , U[3] ] == {{I*gc596, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -U[1] , U[3] ] == {{(-I)*g2*gc597*((cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc597, 0}, {0, 0}},

C[ -S[6] , -U[1] , U[3] , V[1] ] == {{I*gc598, 0}, {I*gc598, 0}, {0, 0}},

C[ -S[6] , -U[1] , U[3] , V[2] ] == {{(-I)*gc599, 0}, {(-I)*gc599, 0}, {I*gc599, 0}},

C[ S[3] , S[4] , -U[1] , U[2] ] == {{I*gc600, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[1] , U[2] ] == {{I*gc601*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc601*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , -U[1] , U[2] ] == {{I*gc602, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , -U[1] , U[2] ] == {{I*gc603, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[1] , U[2] ] == {{I*gc604*(2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + swbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)))*xiBG, 0}, {(8*I)*gc604*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , -U[1] , U[2] ] == {{I*gc605, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[1] , U[2] ] == {{I*gc606*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc606*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , -U[1] , U[2] ] == {{I*gc607, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[1] , U[2] ] == {{I*gc608*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)))*xiBG, 0}, {(16*I)*gc608*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[4] , -S[5] , -U[4] , U[1] ] == {{gc609, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[6] , -U[4] , U[1] ] == {{gc610, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[6] , -U[4] , U[1] ] == {{g2*gc611*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*cwbar*gc611, 0}, {0, 0}},

C[ -S[6] , S[1] , -U[4] , U[1] ] == {{I*gc612, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[2] , -U[4] , U[1] ] == {{I*gc613, 0}, {0, 0}, {0, 0}},

C[ -S[6] , S[2] , -U[4] , U[1] ] == {{I*g2*gc614*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc614, 0}, {0, 0}},

C[ -S[5] , -U[4] , U[1] ] == {{I*gc615, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -U[4] , U[1] ] == {{(-I)*g2*gc616*((cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc616, 0}, {0, 0}},

C[ S[3] , S[4] , -U[4] , U[4] ] == {{I*gc617, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[4] , U[4] ] == {{(-I)*g2^2*gc618*(-2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc618, 0}, {0, 0}},

C[ S[5] , -S[6] , -U[4] , U[4] ] == {{I*gc619, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[4] , U[4] ] == {{I*g2^2*gc620*(1 + cHD*vev^2 + 2*cHW*vev^2)*xiBG, 0}, {(8*I)*cHW*gc620, 0}, {0, 0}},

C[ S[4] , S[1] , -U[4] , U[4] ] == {{gc621, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[2] , -U[4] , U[4] ] == {{gc622, 0}, {0, 0}, {0, 0}},

C[ S[1] , S[2] , -U[4] , U[4] ] == {{I*gc623, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[4] , U[4] ] == {{I*g2^2*gc624*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc624, 0}, {0, 0}},

C[ S[3] , -U[4] , U[4] ] == {{gc625, 0}, {0, 0}, {0, 0}},

C[ S[1] , -U[4] , U[4] ] == {{I*gc626, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[4] , U[4] ] == {{I*g2^2*gc627*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG, 0}, {(32*I)*cHW*gc627, 0}, {0, 0}},

C[ -U[4] , U[4] , V[1] , V[2] ] == {{I*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ -U[4] , U[4] , V[2] , V[2] ] == {{(2*I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[4] , U[4] , V[1] ] == {{I*gc630, 0}, {I*gc630, 0}, {0, 0}},

C[ S[2] , -U[4] , U[4] , V[2] ] == {{(-I)*gc631, 0}, {(-I)*gc631, 0}, {I*gc631, 0}},

C[ -S[5] , -S[6] , -U[4] , U[3] ] == {{I*gc632, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -S[6] , -U[4] , U[3] ] == {{I*gc633, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , -U[4] , U[2] ] == {{gc634, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[6] , -U[4] , U[2] ] == {{gc635, 0}, {0, 0}, {0, 0}},

C[ -S[6] , S[1] , -U[4] , U[2] ] == {{I*gc636, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[2] , -U[4] , U[2] ] == {{I*gc637, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[6] , -U[4] , U[2] ] == {{g2*gc638*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*gc638*swbar, 0}, {0, 0}},

C[ -S[6] , S[2] , -U[4] , U[2] ] == {{I*g2*gc639*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc639*swbar, 0}, {0, 0}},

C[ -S[5] , -U[4] , U[2] ] == {{I*gc640, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -U[4] , U[2] ] == {{I*g2*gc641*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc641*swbar, 0}, {0, 0}},

C[ -U[4] , U[4] , V[2] ] == {{(-I)*gc642, 0}, {I*gc642, 0}},

C[ S[4] , S[5] , -U[3] , U[1] ] == {{gc643, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -U[3] , U[1] ] == {{gc644, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -U[3] , U[1] ] == {{g2*gc645*(-2*(cHWB*g1 + cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*cwbar*gc645, 0}, {0, 0}},

C[ S[6] , S[1] , -U[3] , U[1] ] == {{I*gc646, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[2] , -U[3] , U[1] ] == {{I*gc647, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[2] , -U[3] , U[1] ] == {{I*g2*gc648*(-2*(cHWB*g1 + 3*cHD*g2)*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*cwbar*gc648, 0}, {0, 0}},

C[ S[5] , -U[3] , U[1] ] == {{I*gc649, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[3] , U[1] ] == {{(-I)*g2*gc650*((cHWB*g1 + cHD*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*cwbar*gc650, 0}, {0, 0}},

C[ S[5] , S[6] , -U[3] , U[4] ] == {{I*gc651, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[6] , -U[3] , U[4] ] == {{I*gc652, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , -U[3] , U[3] ] == {{I*gc653, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[3] , U[3] ] == {{(-I)*g2^2*gc654*(-2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc654, 0}, {0, 0}},

C[ -S[5] , S[6] , -U[3] , U[3] ] == {{I*gc655, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[3] , U[3] ] == {{I*g2^2*gc656*(1 + cHD*vev^2 + 2*cHW*vev^2)*xiBG, 0}, {(8*I)*cHW*gc656, 0}, {0, 0}},

C[ S[4] , S[1] , -U[3] , U[3] ] == {{gc657, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[2] , -U[3] , U[3] ] == {{gc658, 0}, {0, 0}, {0, 0}},

C[ S[1] , S[2] , -U[3] , U[3] ] == {{I*gc659, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[3] , U[3] ] == {{I*g2^2*gc660*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG, 0}, {(16*I)*cHW*gc660, 0}, {0, 0}},

C[ S[3] , -U[3] , U[3] ] == {{gc661, 0}, {0, 0}, {0, 0}},

C[ S[1] , -U[3] , U[3] ] == {{I*gc662, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[3] , U[3] ] == {{I*g2^2*gc663*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG, 0}, {(32*I)*cHW*gc663, 0}, {0, 0}},

C[ -U[3] , U[3] , V[1] , V[2] ] == {{I*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ -U[3] , U[3] , V[2] , V[2] ] == {{(2*I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[3] , U[3] , V[1] ] == {{I*gc666, 0}, {I*gc666, 0}, {0, 0}},

C[ S[2] , -U[3] , U[3] , V[2] ] == {{(-I)*gc667, 0}, {(-I)*gc667, 0}, {I*gc667, 0}},

C[ S[4] , S[5] , -U[3] , U[2] ] == {{gc668, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -U[3] , U[2] ] == {{gc669, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[1] , -U[3] , U[2] ] == {{I*gc670, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[2] , -U[3] , U[2] ] == {{I*gc671, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -U[3] , U[2] ] == {{g2*gc672*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*gc672*swbar, 0}, {0, 0}},

C[ S[6] , S[2] , -U[3] , U[2] ] == {{I*g2*gc673*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc673*swbar, 0}, {0, 0}},

C[ S[5] , -U[3] , U[2] ] == {{I*gc674, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[3] , U[2] ] == {{I*g2*gc675*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc675*swbar, 0}, {0, 0}},

C[ -U[3] , U[3] , V[2] ] == {{(-I)*gc676, 0}, {I*gc676, 0}},

C[ S[3] , S[4] , -U[2] , U[1] ] == {{I*gc677, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[2] , U[1] ] == {{I*gc678*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) - g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc678*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ -S[5] , S[6] , -U[2] , U[1] ] == {{I*gc679, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , -U[2] , U[1] ] == {{I*gc680, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[2] , U[1] ] == {{I*gc681*(2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + cHD*vev^2) + g2^2*(-1 + cHD*vev^2 - 2*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + swbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)))*xiBG, 0}, {(8*I)*gc681*(2*(cHB - cHW)*cwbar*swbar + cHWB*(-cwbar^2 + swbar^2)), 0}, {0, 0}},

C[ S[1] , S[2] , -U[2] , U[1] ] == {{I*gc682, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[2] , U[1] ] == {{I*gc683*(cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 2*cHW*vev^2)) + cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) - g2^2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2)))*xiBG, 0}, {(8*I)*gc683*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[1] , -U[2] , U[1] ] == {{I*gc684, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[2] , U[1] ] == {{I*gc685*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2)))*xiBG, 0}, {(16*I)*gc685*(2*(cHB - cHW)*cwbar*swbar + cHWB*(cwbar^2 - swbar^2)), 0}, {0, 0}},

C[ S[4] , S[5] , -U[2] , U[4] ] == {{gc686, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -U[2] , U[4] ] == {{gc687, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[1] , -U[2] , U[4] ] == {{I*gc688, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[2] , -U[2] , U[4] ] == {{I*gc689, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -U[2] , U[4] ] == {{g2*gc690*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*gc690*swbar, 0}, {0, 0}},

C[ S[6] , S[2] , -U[2] , U[4] ] == {{I*g2*gc691*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc691*swbar, 0}, {0, 0}},

C[ S[5] , -U[2] , U[4] ] == {{I*gc692, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[2] , U[4] ] == {{I*g2*gc693*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc693*swbar, 0}, {0, 0}},

C[ S[6] , -U[2] , U[4] , V[1] ] == {{I*gc694, 0}, {I*gc694, 0}, {0, 0}},

C[ S[6] , -U[2] , U[4] , V[2] ] == {{(-I)*gc695, 0}, {(-I)*gc695, 0}, {I*gc695, 0}},

C[ S[4] , -S[5] , -U[2] , U[3] ] == {{gc696, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[6] , -U[2] , U[3] ] == {{gc697, 0}, {0, 0}, {0, 0}},

C[ -S[6] , S[1] , -U[2] , U[3] ] == {{I*gc698, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[2] , -U[2] , U[3] ] == {{I*gc699, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[6] , -U[2] , U[3] ] == {{g2*gc700*(2*cHWB*cwbar*g1*vev^2 + 2*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {16*cHWB*gc700*swbar, 0}, {0, 0}},

C[ -S[6] , S[2] , -U[2] , U[3] ] == {{I*g2*gc701*(2*cHWB*cwbar*g1*vev^2 + 6*cHD*cwbar*g2*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*cHWB*gc701*swbar, 0}, {0, 0}},

C[ -S[5] , -U[2] , U[3] ] == {{I*gc702, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[3] ] == {{I*g2*gc703*(cHWB*cwbar*g1*vev^2 + cHD*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG, 0}, {(8*I)*cHWB*gc703*swbar, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[3] , V[1] ] == {{I*gc704, 0}, {I*gc704, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[3] , V[2] ] == {{(-I)*gc705, 0}, {(-I)*gc705, 0}, {I*gc705, 0}},

C[ S[3] , S[4] , -U[2] , U[2] ] == {{I*gc706, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -U[2] , U[2] ] == {{I*gc707*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc707*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ -S[5] , S[6] , -U[2] , U[2] ] == {{I*gc708, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , -U[2] , U[2] ] == {{I*gc709, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , -U[2] , U[2] ] == {{(-I)*gc710*(cwbar*g2 - g1*swbar)*(cHWB*cwbar*g1*vev^2 + cwbar*g2*(-1 + cHD*vev^2 - 2*cHW*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHD*g1*vev^2 - cHWB*g2*vev^2))*xiBG, 0}, {(8*I)*gc710*(cHW*cwbar^2 + swbar*(-(cHWB*cwbar) + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , S[2] , -U[2] , U[2] ] == {{I*gc711, 0}, {0, 0}, {0, 0}},

C[ S[2] , S[2] , -U[2] , U[2] ] == {{I*gc712*(cwbar*g2 + g1*swbar)*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2) + cwbar*g2*(2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2))*xiBG, 0}, {(16*I)*gc712*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ S[1] , -U[2] , U[2] ] == {{I*gc713, 0}, {0, 0}, {0, 0}},

C[ S[2] , -U[2] , U[2] ] == {{I*gc714*(cwbar*g2 + g1*swbar)*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG, 0}, {(32*I)*gc714*(cHW*cwbar^2 + swbar*(cHWB*cwbar + cHB*swbar)), 0}, {0, 0}},

C[ -U[4] , U[4] , V[1] ] == {{I*gc715, 0}, {0, 0}},

C[ -U[3] , U[3] , V[1] ] == {{I*gc716, 0}, {0, 0}},

C[ S[4] , S[4] , -U[5, {e1x1}] , U[5, {e2x1}] ] == {{0, 0}, {I*gc717*IndexDelta[e1x1, e2x1], 0}, {0, 0}},

C[ S[6] , -S[6] , -U[5, {e1x1}] , U[5, {e2x1}] ] == {{0, 0}, {I*gc718*IndexDelta[e1x1, e2x1], 0}, {0, 0}},

C[ S[2] , S[2] , -U[5, {e1x1}] , U[5, {e2x1}] ] == {{0, 0}, {I*gc719*IndexDelta[e1x1, e2x1], 0}, {0, 0}},

C[ S[2] , -U[5, {e1x1}] , U[5, {e2x1}] ] == {{0, 0}, {I*gc720*IndexDelta[e1x1, e2x1], 0}, {0, 0}},

C[ V[7, {e1x2}] , V[7, {e2x2}] , V[7, {e3x2}] ] == {{-6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-(g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc721*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc721*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[7, {e1x2}] , V[7, {e2x2}] , V[8, {e3x2}] ] == {{-6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2]), 0}, {-(g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2]), 0}, {g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc722*(1 + cHG*vev^2)*xiGBG*SUNF[e1x2, e2x2, e3x2]), 0}, {-6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc722*xiGBG*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {-(g3*gc722*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {g3*gc722*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}},

C[ V[7, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-(g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc723*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc723*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[8, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-(g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2], 0}, {-(g3*gc724*(1 + cHG*vev^2)*SUNF[e1x2, e2x2, e3x2]), 0}, {-6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {-6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {6*cG*gc724*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -U[5, {e1x1}] , U[5, {e2x1}] , V[7, {e3x2}] ] == {{gc725*SUNF[e3x2, e1x1, e2x1], 0}, {0, 0}},

C[ S[2] , -U[5, {e1x1}] , U[5, {e2x1}] , V[7, {e3x2}] ] == {{gc726*SUNF[e3x2, e1x1, e2x1], 0}, {gc726*SUNF[e3x2, e1x1, e2x1], 0}, {0, 0}},

C[ S[1] , V[7, {e1x2}] , V[7, {e2x2}] , V[7, {e3x2}] ] == {{-(gc727*SUNF[e1x2, e2x2, e3x2]), 0}, {gc727*SUNF[e1x2, e2x2, e3x2], 0}, {gc727*SUNF[e1x2, e2x2, e3x2], 0}, {-(gc727*SUNF[e1x2, e2x2, e3x2]), 0}, {-(gc727*SUNF[e1x2, e2x2, e3x2]), 0}, {gc727*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[7, {e1x2}] , V[7, {e2x2}] , V[7, {e3x2}] ] == {{-(gc728*SUNF[e1x2, e2x2, e3x2]), 0}, {gc728*SUNF[e1x2, e2x2, e3x2], 0}, {gc728*SUNF[e1x2, e2x2, e3x2], 0}, {-(gc728*SUNF[e1x2, e2x2, e3x2]), 0}, {-(gc728*SUNF[e1x2, e2x2, e3x2]), 0}, {gc728*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[7, {e1x2}] , V[7, {e2x2}] , V[8, {e3x2}] ] == {{-(gc729*SUNF[e3x2, e1x2, e2x2]), 0}, {gc729*SUNF[e3x2, e1x2, e2x2], 0}, {gc729*SUNF[e3x2, e1x2, e2x2], 0}, {-(gc729*SUNF[e3x2, e1x2, e2x2]), 0}, {-(gc729*SUNF[e3x2, e1x2, e2x2]), 0}, {gc729*SUNF[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[7, {e1x2}] , V[7, {e2x2}] , V[8, {e3x2}] ] == {{gc730*xiGBG*SUNF[e3x2, e1x2, e2x2], 0}, {-(gc730*xiGBG*SUNF[e3x2, e1x2, e2x2]), 0}, {-(gc730*xiGBG*SUNF[e3x2, e1x2, e2x2]), 0}, {gc730*xiGBG*SUNF[e3x2, e1x2, e2x2], 0}, {gc730*xiGBG*SUNF[e3x2, e1x2, e2x2], 0}, {-(gc730*xiGBG*SUNF[e3x2, e1x2, e2x2]), 0}, {-(gc730*SUNF[e3x2, e1x2, e2x2]), 0}, {gc730*SUNF[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ V[7, {e1x2}] , V[7, {e2x2}] , V[7, {e3x2}] , V[7, {e4x2}] ] == {{(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {I*g3*gc731*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e3x2, e4x2] + SUNF[e1x2, e3x2, e2x2, e4x2]), 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc731*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e3x2, e4x2] - SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc731*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e3x2, e2x2, e4x2] + SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc731*SUNF[e1x2, e2x2, e3x2, e4x2], 0}},

C[ V[7, {e1x2}] , V[7, {e2x2}] , V[7, {e3x2}] , V[8, {e4x2}] ] == {{(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {I*g3*gc732*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e4x2, e3x2] + SUNF[e1x2, e3x2, e4x2, e2x2]), 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-I)*g3*gc732*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e4x2, e3x2] + SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-I)*g3*gc732*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e3x2, e4x2, e2x2] - SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e3x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}, {(6*I)*cG*gc732*SUNF[e1x2, e2x2, e4x2, e3x2], 0}},

C[ V[7, {e1x2}] , V[7, {e2x2}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {I*g3*gc733*(1 + 2*cHG*vev^2)*(xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2] + xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2] - SUNF[e3x2, e2x2, e4x2, e1x2]), 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc733*(1 + 2*cHG*vev^2)*(xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2] + SUNF[e3x2, e1x2, e4x2, e2x2] - xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2]), 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc733*(1 + 2*cHG*vev^2)*xiGBG*(SUNF[e3x2, e1x2, e4x2, e2x2] + SUNF[e3x2, e2x2, e4x2, e1x2]), 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e2x2, e4x2, e1x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e3x2, e1x2, e4x2, e2x2], 0}, {(-6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc733*xiGBG*SUNF[e1x2, e2x2, e3x2, e4x2], 0}},

C[ S[1] , V[7, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-(gc734*SUNF[e2x2, e1x2, e3x2]), 0}, {gc734*SUNF[e2x2, e1x2, e3x2], 0}, {gc734*SUNF[e2x2, e1x2, e3x2], 0}, {-(gc734*SUNF[e2x2, e1x2, e3x2]), 0}, {-(gc734*SUNF[e2x2, e1x2, e3x2]), 0}, {gc734*SUNF[e2x2, e1x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[7, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-(gc735*SUNF[e2x2, e1x2, e3x2]), 0}, {gc735*SUNF[e2x2, e1x2, e3x2], 0}, {gc735*SUNF[e2x2, e1x2, e3x2], 0}, {-(gc735*SUNF[e2x2, e1x2, e3x2]), 0}, {-(gc735*SUNF[e2x2, e1x2, e3x2]), 0}, {gc735*SUNF[e2x2, e1x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[7, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {I*g3*gc736*(1 + 2*cHG*vev^2)*(SUNF[e2x2, e1x2, e3x2, e4x2] + SUNF[e2x2, e4x2, e3x2, e1x2]), 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-I)*g3*gc736*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e4x2, e2x2, e3x2] + SUNF[e2x2, e1x2, e3x2, e4x2]), 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {I*g3*gc736*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e4x2, e2x2, e3x2] - SUNF[e2x2, e4x2, e3x2, e1x2]), 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e4x2, e3x2, e1x2], 0}, {(-6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}, {(6*I)*cG*gc736*SUNF[e2x2, e1x2, e3x2, e4x2], 0}},

C[ -U[5, {e1x1}] , U[5, {e2x1}] , V[8, {e3x2}] ] == {{-(gc737*SUNF[e3x2, e1x1, e2x1]), 0}, {gc737*SUNF[e3x2, e1x1, e2x1], 0}},

C[ S[2] , -U[5, {e1x1}] , U[5, {e2x1}] , V[8, {e3x2}] ] == {{-(gc738*SUNF[e3x2, e1x1, e2x1]), 0}, {-(gc738*SUNF[e3x2, e1x1, e2x1]), 0}, {gc738*SUNF[e3x2, e1x1, e2x1], 0}},

C[ -U[5, {e1x1}] , U[5, {e2x1}] , V[7, {e3x2}] , V[8, {e4x2}] ] == {{I*g3^2*(1 + 2*cHG*vev^2)*SUNF[e3x2, e2x1, e4x2, e1x1], 0}},

C[ -U[5, {e1x1}] , U[5, {e2x1}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{I*g3^2*(1 + 2*cHG*vev^2)*(SUNF[e3x2, e1x1, e4x2, e2x1] + SUNF[e3x2, e2x1, e4x2, e1x1]), 0}},

C[ S[1] , V[8, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-(gc741*SUNF[e1x2, e2x2, e3x2]), 0}, {gc741*SUNF[e1x2, e2x2, e3x2], 0}, {gc741*SUNF[e1x2, e2x2, e3x2], 0}, {-(gc741*SUNF[e1x2, e2x2, e3x2]), 0}, {-(gc741*SUNF[e1x2, e2x2, e3x2]), 0}, {gc741*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[8, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] ] == {{-(gc742*SUNF[e1x2, e2x2, e3x2]), 0}, {gc742*SUNF[e1x2, e2x2, e3x2], 0}, {gc742*SUNF[e1x2, e2x2, e3x2], 0}, {-(gc742*SUNF[e1x2, e2x2, e3x2]), 0}, {-(gc742*SUNF[e1x2, e2x2, e3x2]), 0}, {gc742*SUNF[e1x2, e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[8, {e1x2}] , V[8, {e2x2}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {I*g3*gc743*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e3x2, e4x2] + SUNF[e1x2, e3x2, e2x2, e4x2]), 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc743*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e2x2, e3x2, e4x2] - SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-I)*g3*gc743*(1 + 2*cHG*vev^2)*(SUNF[e1x2, e3x2, e2x2, e4x2] + SUNF[e1x2, e4x2, e2x2, e3x2]), 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e4x2, e2x2, e3x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e3x2, e2x2, e4x2], 0}, {(-6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}, {(6*I)*cG*gc743*SUNF[e1x2, e2x2, e3x2, e4x2], 0}},

C[ -F[6] , F[3] , -S[5] ] == {{I*gc744*(-2*Sqrt[2]*MTAbar + vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHl33x3*gc744*vev^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] ] == {{I*gc745*(-2*Sqrt[2]*MTAbar + vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHl33x3*gc745*vev^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] ] == {{gc746, 0}, {0, 0}, {-((gc746*(Sqrt[2]*ceH3x3*vev^3 + MTAbar*(-4 + cHD*vev^2)))/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3])), 0}, {0, 0}, {(-4*(cHl13x3 + cHl33x3)*gc746*vev^2)/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {(-8*cHe3x3*gc746*vev^2)/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] ] == {{gc747, 0}, {0, 0}, {-((gc747*(Sqrt[2]*ceH3x3*vev^3 + MTAbar*(-4 + cHD*vev^2)))/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3])), 0}, {0, 0}, {(-4*(cHl13x3 + cHl33x3)*gc747*vev^2)/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {(-8*cHe3x3*gc747*vev^2)/(MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] ] == {{I*gc748, 0}, {0, 0}, {(I*gc748*(3*Sqrt[2]*ceH3x3*vev^3 + MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2)))/(MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 3*Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] ] == {{I*gc749, 0}, {0, 0}, {(I*gc749*(3*Sqrt[2]*ceH3x3*vev^3 + MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2)))/(MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 3*Sqrt[2]*vev^3*Conjugate[ceH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] ] == {{gc750*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc750*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {(-4*(cHq13x3 + cHq33x3)*gc750*vev^2*IndexDelta[e1x2, e2x2])/(MBbar*(-4 + cHD*vev^2)), 0}, {0, 0}, {(8*cHd3x3*gc750*vev^2*IndexDelta[e1x2, e2x2])/(4*MBbar - cHD*MBbar*vev^2), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] ] == {{gc751*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc751*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {(-4*(cHq13x3 + cHq33x3)*gc751*vev^2*IndexDelta[e1x2, e2x2])/(MBbar*(-4 + cHD*vev^2)), 0}, {0, 0}, {(8*cHd3x3*gc751*vev^2*IndexDelta[e1x2, e2x2])/(4*MBbar - cHD*MBbar*vev^2), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] ] == {{I*gc752*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(I*gc752*(2*Sqrt[2]*cdH3x3*vev^3 + MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2))*IndexDelta[e1x2, e2x2])/(MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cdH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] ] == {{I*gc753*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(I*gc753*(2*Sqrt[2]*cdH3x3*vev^3 + MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2))*IndexDelta[e1x2, e2x2])/(MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cdH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] ] == {{gc754*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc754*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {(4*(cHq13x3 - cHq33x3)*gc754*vev^2*IndexDelta[e1x2, e2x2])/(MTbar*(-4 + cHD*vev^2)), 0}, {0, 0}, {(8*cHu3x3*gc754*vev^2*IndexDelta[e1x2, e2x2])/(MTbar*(-4 + cHD*vev^2)), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] ] == {{gc755*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc755*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {(4*(cHq13x3 - cHq33x3)*gc755*vev^2*IndexDelta[e1x2, e2x2])/(MTbar*(-4 + cHD*vev^2)), 0}, {0, 0}, {(8*cHu3x3*gc755*vev^2*IndexDelta[e1x2, e2x2])/(MTbar*(-4 + cHD*vev^2)), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] ] == {{I*gc756*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(I*gc756*(2*Sqrt[2]*cuH3x3*vev^3 + MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2))*IndexDelta[e1x2, e2x2])/(MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cuH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] ] == {{I*gc757*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(I*gc757*(2*Sqrt[2]*cuH3x3*vev^3 + MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2))*IndexDelta[e1x2, e2x2])/(MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cuH3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] ] == {{I*gc758*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I)*gc758*MTbar*IndexDelta[e1x2, e2x2])/MBbar, 0}, {0, 0}, {(I*cHq33x3*gc758*vev^2*IndexDelta[e1x2, e2x2])/(MBbar*Conjugate[CKM3x3]), 0}, {0, 0}, {((-I/2)*gc758*vev^2*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2])/(MBbar*Conjugate[CKM3x3]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] ] == {{I*gc759*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I)*gc759*MTbar*IndexDelta[e1x2, e2x2])/MBbar, 0}, {0, 0}, {(I*cHq33x3*gc759*vev^2*IndexDelta[e1x2, e2x2])/(MBbar*Conjugate[CKM3x3]), 0}, {0, 0}, {((-I/2)*gc759*vev^2*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2])/(MBbar*Conjugate[CKM3x3]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] ] == {{I*gc760*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I)*gc760*MBbar*IndexDelta[e1x2, e2x2])/MTbar, 0}, {0, 0}, {(I*cHq33x3*gc760*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3*MTbar), 0}, {0, 0}, {((-I/2)*cHud3x3*gc760*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3*MTbar), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] ] == {{I*gc761*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I)*gc761*MBbar*IndexDelta[e1x2, e2x2])/MTbar, 0}, {0, 0}, {(I*cHq33x3*gc761*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3*MTbar), 0}, {0, 0}, {((-I/2)*cHud3x3*gc761*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3*MTbar), 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , S[1] ] == {{I*vev*Conjugate[ceH3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , S[1] ] == {{I*vev*Conjugate[ceH3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , S[2] ] == {{I*vev*Conjugate[ceH3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , S[2] ] == {{I*vev*Conjugate[ceH3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , S[3] ] == {{I*gc766*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc766, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , S[4] ] == {{I*gc767*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc767, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , S[4] ] == {{I*gc768*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc768, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[5] , -S[5] ] == {{(-I)*gc769*vev*Conjugate[ceH3x3], 0}, {0, 0}, {(-I)*ceH3x3*gc769*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*(cHl13x3 - cHl33x3)*gc769, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc769, 0}, {0, 0}, {I*Sqrt[2]*(cHl13x3 - cHl33x3)*gc769, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc769, 0}, {0, 0}},

C[ -F[6] , F[6] , -S[5] , S[6] ] == {{I*gc770*vev*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc770*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*(cHl13x3 - cHl33x3)*gc770, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc770, 0}, {0, 0}, {I*Sqrt[2]*(cHl13x3 - cHl33x3)*gc770, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc770, 0}, {0, 0}},

C[ -F[6] , F[6] , S[5] , -S[6] ] == {{(-I)*gc771*vev*Conjugate[ceH3x3], 0}, {0, 0}, {(-I)*ceH3x3*gc771*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*(cHl13x3 - cHl33x3)*gc771, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc771, 0}, {0, 0}, {I*Sqrt[2]*(cHl13x3 - cHl33x3)*gc771, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc771, 0}, {0, 0}},

C[ -F[6] , F[6] , S[6] , -S[6] ] == {{(-I)*gc772*vev*Conjugate[ceH3x3], 0}, {0, 0}, {(-I)*ceH3x3*gc772*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*(cHl13x3 - cHl33x3)*gc772, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc772, 0}, {0, 0}, {I*Sqrt[2]*(cHl13x3 - cHl33x3)*gc772, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc772, 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , S[1] ] == {{gc773*vev*Conjugate[ceH3x3], 0}, {0, 0}, {-(ceH3x3*gc773*vev), 0}, {0, 0}, {-(Sqrt[2]*(cHl13x3 + cHl33x3)*gc773), 0}, {0, 0}, {-2*Sqrt[2]*cHe3x3*gc773, 0}, {0, 0}, {Sqrt[2]*(cHl13x3 + cHl33x3)*gc773, 0}, {0, 0}, {2*Sqrt[2]*cHe3x3*gc773, 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , S[1] ] == {{gc774*vev*Conjugate[ceH3x3], 0}, {0, 0}, {-(ceH3x3*gc774*vev), 0}, {0, 0}, {-(Sqrt[2]*(cHl13x3 + cHl33x3)*gc774), 0}, {0, 0}, {-2*Sqrt[2]*cHe3x3*gc774, 0}, {0, 0}, {Sqrt[2]*(cHl13x3 + cHl33x3)*gc774, 0}, {0, 0}, {2*Sqrt[2]*cHe3x3*gc774, 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , S[1] ] == {{I*gc775*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc775, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , S[2] ] == {{gc776*vev*Conjugate[ceH3x3], 0}, {0, 0}, {-(ceH3x3*gc776*vev), 0}, {0, 0}, {-(Sqrt[2]*(cHl13x3 + cHl33x3)*gc776), 0}, {0, 0}, {-2*Sqrt[2]*cHe3x3*gc776, 0}, {0, 0}, {Sqrt[2]*(cHl13x3 + cHl33x3)*gc776, 0}, {0, 0}, {2*Sqrt[2]*cHe3x3*gc776, 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , S[2] ] == {{gc777*vev*Conjugate[ceH3x3], 0}, {0, 0}, {-(ceH3x3*gc777*vev), 0}, {0, 0}, {-(Sqrt[2]*(cHl13x3 + cHl33x3)*gc777), 0}, {0, 0}, {-2*Sqrt[2]*cHe3x3*gc777, 0}, {0, 0}, {Sqrt[2]*(cHl13x3 + cHl33x3)*gc777, 0}, {0, 0}, {2*Sqrt[2]*cHe3x3*gc777, 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , S[2] ] == {{I*gc778*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc778, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] , S[2] ] == {{I*gc779*Conjugate[ceH3x3], 0}, {0, 0}, {I*ceH3x3*gc779, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , S[3] ] == {{I*gc780*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc780*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , S[4] ] == {{I*gc781*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc781*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , S[4] ] == {{I*gc782*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc782*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[5] , -S[5] ] == {{(-I)*gc783*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdH3x3*gc783*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc783*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc783*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc783*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc783*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -S[5] , S[6] ] == {{I*gc784*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc784*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc784*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc784*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc784*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc784*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[5] , -S[6] ] == {{(-I)*gc785*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdH3x3*gc785*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc785*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc785*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc785*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc785*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[6] , -S[6] ] == {{(-I)*gc786*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdH3x3*gc786*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc786*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc786*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc786*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc786*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , S[1] ] == {{gc787*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cdH3x3*gc787*vev*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 + cHq33x3)*gc787*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHd3x3*gc787*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 + cHq33x3)*gc787*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHd3x3*gc787*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , S[1] ] == {{gc788*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cdH3x3*gc788*vev*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 + cHq33x3)*gc788*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHd3x3*gc788*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 + cHq33x3)*gc788*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHd3x3*gc788*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , S[1] ] == {{I*gc789*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc789*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , S[2] ] == {{gc790*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cdH3x3*gc790*vev*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 + cHq33x3)*gc790*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHd3x3*gc790*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 + cHq33x3)*gc790*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHd3x3*gc790*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , S[2] ] == {{gc791*vev*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cdH3x3*gc791*vev*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 + cHq33x3)*gc791*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHd3x3*gc791*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 + cHq33x3)*gc791*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHd3x3*gc791*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , S[2] ] == {{I*gc792*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc792*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , S[2] ] == {{I*gc793*Conjugate[cdH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdH3x3*gc793*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , S[3] ] == {{I*gc794*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc794*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , S[4] ] == {{I*gc795*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc795*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , S[4] ] == {{I*gc796*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc796*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[5] , -S[5] ] == {{(-I)*gc797*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuH3x3*gc797*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc797*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc797*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc797*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc797*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -S[5] , S[6] ] == {{I*gc798*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc798*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc798*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc798*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc798*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc798*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[5] , -S[6] ] == {{(-I)*gc799*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuH3x3*gc799*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc799*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc799*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc799*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc799*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[6] , -S[6] ] == {{(-I)*gc800*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuH3x3*gc800*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc800*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc800*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc800*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc800*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , S[1] ] == {{-(gc801*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {cuH3x3*gc801*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 - cHq33x3)*gc801*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHu3x3*gc801*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 - cHq33x3)*gc801*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHu3x3*gc801*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , S[1] ] == {{-(gc802*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {cuH3x3*gc802*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 - cHq33x3)*gc802*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHu3x3*gc802*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 - cHq33x3)*gc802*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHu3x3*gc802*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , S[1] ] == {{I*gc803*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc803*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , S[2] ] == {{-(gc804*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {cuH3x3*gc804*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 - cHq33x3)*gc804*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHu3x3*gc804*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 - cHq33x3)*gc804*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHu3x3*gc804*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , S[2] ] == {{-(gc805*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {cuH3x3*gc805*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*(cHq13x3 - cHq33x3)*gc805*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-2*Sqrt[2]*cHu3x3*gc805*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*(cHq13x3 - cHq33x3)*gc805*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {2*Sqrt[2]*cHu3x3*gc805*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , S[2] ] == {{I*gc806*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc806*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , S[2] ] == {{I*gc807*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuH3x3*gc807*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , S[1] ] == {{(-I)*Sqrt[2]*gc808*vev*(Conjugate[cdH1x3]*Conjugate[CKM3x1] + Conjugate[cdH2x3]*Conjugate[CKM3x2] + Conjugate[cdH3x3]*Conjugate[CKM3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuH3x3*gc808*vev*Conjugate[CKM3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc808*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc808*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc808*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc808*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , S[1] ] == {{(-I)*Sqrt[2]*gc809*vev*(Conjugate[cdH1x3]*Conjugate[CKM3x1] + Conjugate[cdH2x3]*Conjugate[CKM3x2] + Conjugate[cdH3x3]*Conjugate[CKM3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuH3x3*gc809*vev*Conjugate[CKM3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc809*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc809*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc809*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc809*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , S[2] ] == {{(-I)*Sqrt[2]*gc810*vev*(Conjugate[cdH1x3]*Conjugate[CKM3x1] + Conjugate[cdH2x3]*Conjugate[CKM3x2] + Conjugate[cdH3x3]*Conjugate[CKM3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuH3x3*gc810*vev*Conjugate[CKM3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc810*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc810*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc810*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc810*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , S[2] ] == {{(-I)*Sqrt[2]*gc811*vev*(Conjugate[cdH1x3]*Conjugate[CKM3x1] + Conjugate[cdH2x3]*Conjugate[CKM3x2] + Conjugate[cdH3x3]*Conjugate[CKM3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuH3x3*gc811*vev*Conjugate[CKM3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc811*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc811*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc811*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc811*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , S[5] , S[1] ] == {{I*gc812*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , S[6] , S[1] ] == {{I*gc813*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , S[5] , S[2] ] == {{I*gc814*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , S[6] , S[2] ] == {{I*gc815*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , S[5] , S[1] ] == {{I*gc816*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , S[6] , S[1] ] == {{I*gc817*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , S[5] , S[2] ] == {{I*gc818*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , S[6] , S[2] ] == {{I*gc819*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , S[1] ] == {{(-I)*Sqrt[2]*CKM3x3*gc820*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cdH1x3*CKM3x1 + cdH2x3*CKM3x2 + cdH3x3*CKM3x3)*gc820*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc820*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cHud3x3*gc820*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc820*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*gc820*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , S[1] ] == {{(-I)*Sqrt[2]*CKM3x3*gc821*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cdH1x3*CKM3x1 + cdH2x3*CKM3x2 + cdH3x3*CKM3x3)*gc821*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc821*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cHud3x3*gc821*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc821*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*gc821*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , S[2] ] == {{(-I)*Sqrt[2]*CKM3x3*gc822*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cdH1x3*CKM3x1 + cdH2x3*CKM3x2 + cdH3x3*CKM3x3)*gc822*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc822*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cHud3x3*gc822*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc822*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*gc822*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , S[2] ] == {{(-I)*Sqrt[2]*CKM3x3*gc823*vev*Conjugate[cuH3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*(cdH1x3*CKM3x1 + cdH2x3*CKM3x2 + cdH3x3*CKM3x3)*gc823*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHq33x3*gc823*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cHud3x3*gc823*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHq33x3*gc823*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*gc823*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , -F[9, {e3x2}] , F[12, {e2x2}] , F[9, {e4x2}] ] == {{(-I)*gc824*(6*Conjugate[cquqd13x3x3x3]*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + Conjugate[cquqd83x3x3x3]*(-(IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2]) + 3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2])), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc824*(6*Conjugate[cquqd13x3x3x3]*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2] + Conjugate[cquqd83x3x3x3]*(3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] - IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2])), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc824*((6*cquqd13x3x3x3 - cquqd83x3x3x3)*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + 3*cquqd83x3x3x3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc824*(3*cquqd83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cquqd13x3x3x3 - cquqd83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(24*I)*cqq33x3x3x3*gc824*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*(cqq13x3x3x3 - cqq33x3x3x3)*gc824*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc824*(3*cqd83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqd13x3x3x3 - cqd83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc824*(3*cqu83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqu13x3x3x3 - cqu83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc824*(3*cud83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cud13x3x3x3 - cud83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , -F[9, {e3x2}] , F[12, {e2x2}] , F[3] ] == {{(2*I)*gc825*Conjugate[clequ13x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*gc825*Conjugate[cledq3x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(4*I)*clq33x3x3x3*gc825*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc825*Conjugate[clequ33x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc825*Conjugate[clequ33x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , -F[9, {e3x2}] , F[9, {e2x2}] , F[6] ] == {{(2*I)*gc826*Conjugate[clequ13x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*clequ13x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*(clq13x3x3x3 - clq33x3x3x3)*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*cqe3x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*clu3x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-2*I)*ceu3x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc826*Conjugate[clequ33x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*clequ33x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc826*Conjugate[clequ33x3x3x3]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*clequ33x3x3x3*gc826*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , -F[6] , F[12, {e2x2}] , F[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[cledq3x3x3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cledq3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(clq13x3x3x3 + clq33x3x3x3)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cld3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cqe3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*ced3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] ] == {{0, 0}, {0, 0}, {((I/2)*(-2*Sqrt[2]*MTAbar + ceH3x3*vev^3))/vev, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*vev, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] ] == {{0, 0}, {0, 0}, {((I/2)*(-2*Sqrt[2]*MTAbar + ceH3x3*vev^3))/vev, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*vev, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , S[1] ] == {{0, 0}, {0, 0}, {(-I)*ceH3x3*gc830*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3*gc830, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*gc830, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , S[1] ] == {{0, 0}, {0, 0}, {(-I)*ceH3x3*gc831*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3*gc831, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*gc831, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , S[2] ] == {{0, 0}, {0, 0}, {(-I)*ceH3x3*gc832*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3*gc832, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*gc832, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , S[2] ] == {{0, 0}, {0, 0}, {(-I)*ceH3x3*gc833*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*cHl33x3*gc833, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cHl33x3*gc833, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -S[5] , S[1] ] == {{0, 0}, {0, 0}, {I*gc834*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -S[6] , S[1] ] == {{0, 0}, {0, 0}, {I*gc835*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -S[5] , S[2] ] == {{0, 0}, {0, 0}, {I*gc836*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -S[6] , S[2] ] == {{0, 0}, {0, 0}, {I*gc837*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -S[5] , S[1] ] == {{0, 0}, {0, 0}, {I*gc838*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -S[6] , S[1] ] == {{0, 0}, {0, 0}, {I*gc839*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -S[5] , S[2] ] == {{0, 0}, {0, 0}, {I*gc840*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -S[6] , S[2] ] == {{0, 0}, {0, 0}, {I*gc841*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , -F[3] , F[9, {e2x2}] , F[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cledq3x3x3x3*gc842*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*clequ13x3x3x3*gc842*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(4*I)*clq33x3x3x3*gc842*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*clequ33x3x3x3*gc842*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*clequ33x3x3x3*gc842*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , V[5] ] == {{gc843*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc843*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , S[3] , -S[5] , V[5] ] == {{I*gc844, 0}, {I*gc844, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , -S[5] , V[5] ] == {{I*gc845, 0}, {I*gc845, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , -S[6] , V[5] ] == {{I*gc846, 0}, {I*gc846, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[1] , V[5] ] == {{-2*gc847, 0}, {0, 0}, {gc847, 0}, {0, 0}},

C[ S[3] , -S[6] , S[1] , V[5] ] == {{-2*gc848, 0}, {0, 0}, {gc848, 0}, {0, 0}},

C[ S[3] , -S[5] , S[2] , V[5] ] == {{-2*gc849, 0}, {0, 0}, {gc849, 0}, {0, 0}},

C[ S[4] , -S[6] , V[5] ] == {{gc850*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc850*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , S[4] , -S[5] , V[5] ] == {{I*gc851, 0}, {I*gc851, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -S[6] , V[5] ] == {{I*gc852, 0}, {I*gc852, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[1] , V[5] ] == {{-2*gc853, 0}, {0, 0}, {gc853, 0}, {0, 0}},

C[ S[4] , -S[5] , S[2] , V[5] ] == {{-2*gc854, 0}, {0, 0}, {gc854, 0}, {0, 0}},

C[ S[4] , -S[6] , S[2] , V[5] ] == {{-2*gc855, 0}, {0, 0}, {gc855, 0}, {0, 0}},

C[ S[5] , -S[5] , -S[5] , V[5] ] == {{(-2*I)*gc856, 0}, {I*gc856, 0}, {I*gc856, 0}, {0, 0}},

C[ S[5] , -S[5] , -S[6] , V[5] ] == {{(-2*I)*gc857, 0}, {I*gc857, 0}, {I*gc857, 0}, {0, 0}},

C[ -S[5] , S[1] , V[5] ] == {{(-I)*gc858, 0}, {I*gc858, 0}, {0, 0}},

C[ -S[5] , -S[5] , S[6] , V[5] ] == {{(-I)*gc859, 0}, {(-I)*gc859, 0}, {(2*I)*gc859, 0}, {0, 0}},

C[ S[6] , -S[6] , -S[6] , V[5] ] == {{(-2*I)*gc860, 0}, {I*gc860, 0}, {I*gc860, 0}, {0, 0}},

C[ -S[6] , S[2] , V[5] ] == {{(-I)*gc861, 0}, {I*gc861, 0}, {0, 0}},

C[ -S[5] , V[1] , V[1] , V[5] ] == {{(-I)*gc862, 0}, {(-I)*gc862, 0}, {I*gc862, 0}, {0, 0}, {I*gc862, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[1] , V[5] ] == {{(-I)*gc863, 0}, {(-I)*gc863, 0}, {I*gc863, 0}, {0, 0}, {I*gc863, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[1] , V[2] , V[5] ] == {{(-I)*gc864, 0}, {(-I)*gc864, 0}, {I*gc864, 0}, {0, 0}, {I*gc864, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[2] , V[5] ] == {{(-I)*gc865*xiBG, 0}, {(-I)*gc865*xiBG, 0}, {I*gc865*xiBG, 0}, {0, 0}, {I*gc865*xiBG, 0}, {0, 0}, {0, 0}, {I*gc865, 0}, {0, 0}},

C[ -S[5] , V[2] , V[2] , V[5] ] == {{(-I)*gc866, 0}, {(-I)*gc866, 0}, {I*gc866, 0}, {0, 0}, {I*gc866, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[2] , V[5] ] == {{(-I)*gc867, 0}, {(-I)*gc867, 0}, {I*gc867, 0}, {0, 0}, {I*gc867, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[1] , V[5] , -V[5] ] == {{I*gc868*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc868*swbar, 0}, {(-I)*gc868*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc868*swbar, 0}, {(-2*I)*cHW*gc868*swbar, 0}, {(2*I)*cHW*gc868*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[1] , V[5] , -V[5] ] == {{I*gc869*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc869*swbar, 0}, {(-I)*gc869*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc869*swbar, 0}, {(-2*I)*cHW*gc869*swbar, 0}, {(2*I)*cHW*gc869*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[2] , V[5] , -V[5] ] == {{I*gc870*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc870*swbar, 0}, {(-I)*gc870*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc870*swbar, 0}, {(-2*I)*cHW*gc870*swbar, 0}, {(2*I)*cHW*gc870*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[2] , V[5] , -V[5] ] == {{I*gc871*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(2*I)*cHW*gc871*swbar*xiBG, 0}, {(-I)*gc871*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(-2*I)*cHW*gc871*swbar*xiBG, 0}, {(-2*I)*cHW*gc871*swbar*xiBG, 0}, {(2*I)*cHW*gc871*swbar*xiBG, 0}, {(-2*I)*cHW*gc871*swbar, 0}, {0, 0}, {(2*I)*cHW*gc871*swbar, 0}},

C[ V[1] , V[1] , V[5] , -V[5] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {0, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {0, 0}, {I*g2*gc872*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {0, 0}, {I*g2*gc872*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {0, 0}, {(-6*I)*cW*gc872*swbar, 0}, {0, 0}, {(-2*I)*g2*gc872*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {(-6*I)*cW*gc872*swbar, 0}, {(6*I)*cW*gc872*swbar, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[2] , V[5] , -V[5] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {0, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {0, 0}, {I*g2*gc873*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {0, 0}, {I*g2*gc873*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {0, 0}, {(-6*I)*cW*gc873*swbar, 0}, {0, 0}, {(-2*I)*g2*gc873*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {(-6*I)*cW*gc873*swbar, 0}, {(6*I)*cW*gc873*swbar, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[2] , V[5] , -V[5] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {I*g2*gc874*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {I*g2*gc874*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc874*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {(-6*I)*cW*gc874*swbar*xiBG, 0}, {(6*I)*cW*gc874*swbar*xiBG, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[1] , V[5] , -V[6] ] == {{I*gc875*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc875*swbar, 0}, {(-I)*gc875*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc875*swbar, 0}, {(-2*I)*cHW*gc875*swbar, 0}, {(2*I)*cHW*gc875*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[1] , V[5] , -V[6] ] == {{I*gc876*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(2*I)*cHW*gc876*swbar*xiBG, 0}, {(-I)*gc876*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(-2*I)*cHW*gc876*swbar*xiBG, 0}, {(-2*I)*cHW*gc876*swbar*xiBG, 0}, {(2*I)*cHW*gc876*swbar*xiBG, 0}, {(2*I)*cHW*gc876*swbar, 0}, {I*gc876*(cHWB*cwbar - 2*cHW*swbar), 0}, {0, 0}},

C[ S[1] , V[2] , V[5] , -V[6] ] == {{I*gc877*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc877*swbar, 0}, {(-I)*gc877*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc877*swbar, 0}, {(-2*I)*cHW*gc877*swbar, 0}, {(2*I)*cHW*gc877*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[2] , V[5] , -V[6] ] == {{I*gc878*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc878*swbar, 0}, {(-I)*gc878*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc878*swbar, 0}, {(-2*I)*cHW*gc878*swbar, 0}, {(2*I)*cHW*gc878*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[1] , V[5] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {0, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {0, 0}, {I*g2*gc879*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {0, 0}, {I*g2*gc879*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {0, 0}, {(-6*I)*cW*gc879*swbar, 0}, {0, 0}, {(-2*I)*g2*gc879*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {(-6*I)*cW*gc879*swbar, 0}, {(6*I)*cW*gc879*swbar, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[2] , V[5] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {I*g2*gc880*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {I*g2*gc880*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc880*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {(-6*I)*cW*gc880*swbar*xiBG, 0}, {(6*I)*cW*gc880*swbar*xiBG, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[2] , V[5] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {0, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {0, 0}, {I*g2*gc881*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {0, 0}, {I*g2*gc881*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {0, 0}, {(-6*I)*cW*gc881*swbar, 0}, {0, 0}, {(-2*I)*g2*gc881*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {(-6*I)*cW*gc881*swbar, 0}, {(6*I)*cW*gc881*swbar, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[1] , V[5] , V[3] ] == {{(-I)*cwbar^2*gc882, 0}, {0, 0}, {I*cwbar^2*gc882, 0}, {(-I)*gc882*swbar^2, 0}, {0, 0}, {I*gc882*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[5] , V[3] ] == {{(-I)*cwbar^2*gc883, 0}, {0, 0}, {I*cwbar^2*gc883, 0}, {(-I)*gc883*swbar^2, 0}, {0, 0}, {I*gc883*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[2] , V[5] , V[3] ] == {{(-I)*cwbar^2*gc884, 0}, {0, 0}, {I*cwbar^2*gc884, 0}, {(-I)*gc884*swbar^2, 0}, {0, 0}, {I*gc884*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[5] , V[3] ] == {{(-I)*cwbar^2*gc885*xiBG, 0}, {0, 0}, {I*cwbar^2*gc885*xiBG, 0}, {(-I)*gc885*swbar^2*xiBG, 0}, {0, 0}, {I*gc885*swbar^2*xiBG, 0}, {0, 0}, {0, 0}, {I*gc885*swbar^2, 0}},

C[ V[1] , V[5] , -V[5] , V[3] ] == {{(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(-2*I)*g2*gc886*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {I*g2*gc886*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {I*g2*gc886*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}, {(-12*I)*cW*cwbar*gc886*swbar, 0}, {(12*I)*cW*cwbar*gc886*swbar, 0}},

C[ V[2] , V[5] , -V[5] , V[3] ] == {{(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(-2*I)*g2*gc887*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {I*g2*gc887*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {I*g2*gc887*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}, {(-12*I)*cW*cwbar*gc887*swbar, 0}, {(12*I)*cW*cwbar*gc887*swbar, 0}},

C[ V[1] , V[5] , -V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(-2*I)*g2*gc888*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {I*g2*gc888*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {I*g2*gc888*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}, {(-12*I)*cW*cwbar*gc888*swbar, 0}, {(12*I)*cW*cwbar*gc888*swbar, 0}},

C[ V[2] , V[5] , -V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-2*I)*g2*gc889*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {I*g2*gc889*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {I*g2*gc889*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc889*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc889*swbar*xiBG, 0}},

C[ -S[5] , V[1] , V[5] , V[4] ] == {{(-I)*cwbar^2*gc890, 0}, {0, 0}, {I*cwbar^2*gc890, 0}, {(-I)*gc890*swbar^2, 0}, {0, 0}, {I*gc890*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[5] , V[4] ] == {{I*cwbar^2*gc891*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc891*xiBG, 0}, {I*gc891*swbar^2*xiBG, 0}, {0, 0}, {(-I)*gc891*swbar^2*xiBG, 0}, {0, 0}, {I*cwbar^2*gc891, 0}, {0, 0}},

C[ -S[5] , V[2] , V[5] , V[4] ] == {{(-I)*cwbar^2*gc892, 0}, {0, 0}, {I*cwbar^2*gc892, 0}, {(-I)*gc892*swbar^2, 0}, {0, 0}, {I*gc892*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[5] , V[4] ] == {{(-I)*cwbar^2*gc893, 0}, {0, 0}, {I*cwbar^2*gc893, 0}, {(-I)*gc893*swbar^2, 0}, {0, 0}, {I*gc893*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[5] , -V[5] , V[4] ] == {{(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(-2*I)*g2*gc894*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {I*g2*gc894*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {I*g2*gc894*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}, {(-12*I)*cW*cwbar*gc894*swbar, 0}, {(12*I)*cW*cwbar*gc894*swbar, 0}},

C[ V[2] , V[5] , -V[5] , V[4] ] == {{(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-2*I)*g2*gc895*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {I*g2*gc895*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(-1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {I*g2*gc895*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(-1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc895*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc895*swbar*xiBG, 0}},

C[ V[1] , V[5] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-2*I)*g2*gc896*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {I*g2*gc896*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {I*g2*gc896*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc896*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc896*swbar*xiBG, 0}},

C[ V[2] , V[5] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(-2*I)*g2*gc897*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {I*g2*gc897*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {I*g2*gc897*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}, {(-12*I)*cW*cwbar*gc897*swbar, 0}, {(12*I)*cW*cwbar*gc897*swbar, 0}},

C[ -S[6] , -U[1] , U[1] , V[5] ] == {{I*gc898, 0}, {I*gc898, 0}, {0, 0}},

C[ S[2] , -U[1] , U[4] , V[5] ] == {{I*gc899, 0}, {I*gc899, 0}, {0, 0}},

C[ -S[6] , -U[1] , U[2] , V[5] ] == {{I*gc900, 0}, {I*gc900, 0}, {0, 0}},

C[ -U[3] , U[1] , V[2] , V[5] ] == {{(-I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[3] , U[1] , V[5] ] == {{I*gc902, 0}, {I*gc902, 0}, {0, 0}},

C[ -U[3] , U[2] , V[2] , V[5] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[3] , U[2] , V[5] ] == {{I*gc904, 0}, {I*gc904, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[1] , V[5] ] == {{I*gc905, 0}, {I*gc905, 0}, {0, 0}},

C[ S[2] , -U[2] , U[4] , V[5] ] == {{I*gc906, 0}, {I*gc906, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[2] , V[5] ] == {{I*gc907, 0}, {I*gc907, 0}, {0, 0}},

C[ -U[1] , U[4] , V[5] ] == {{I*gc908, 0}, {0, 0}},

C[ -U[3] , U[1] , V[5] ] == {{I*gc909, 0}, {0, 0}},

C[ -U[3] , U[2] , V[5] ] == {{I*gc910, 0}, {0, 0}},

C[ -U[2] , U[4] , V[5] ] == {{I*gc911, 0}, {0, 0}},

C[ -S[5] , -S[5] , V[5] , V[5] ] == {{0, 0}, {I*gc912, 0}, {0, 0}, {0, 0}},

C[ -S[5] , -S[6] , V[5] , V[5] ] == {{0, 0}, {I*gc913, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -S[6] , V[5] , V[5] ] == {{0, 0}, {I*gc914, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -V[5] ] == {{gc915*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc915*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , S[3] , S[5] , -V[5] ] == {{I*gc916, 0}, {I*gc916, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , S[5] , -V[5] ] == {{I*gc917, 0}, {I*gc917, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , S[6] , -V[5] ] == {{I*gc918, 0}, {I*gc918, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , S[1] , -V[5] ] == {{-2*gc919, 0}, {0, 0}, {gc919, 0}, {0, 0}},

C[ S[3] , S[6] , S[1] , -V[5] ] == {{-2*gc920, 0}, {0, 0}, {gc920, 0}, {0, 0}},

C[ S[3] , S[5] , S[2] , -V[5] ] == {{-2*gc921, 0}, {0, 0}, {gc921, 0}, {0, 0}},

C[ S[4] , S[6] , -V[5] ] == {{gc922*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc922*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , S[4] , S[5] , -V[5] ] == {{I*gc923, 0}, {I*gc923, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , S[6] , -V[5] ] == {{I*gc924, 0}, {I*gc924, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , S[1] , -V[5] ] == {{-2*gc925, 0}, {0, 0}, {gc925, 0}, {0, 0}},

C[ S[4] , S[5] , S[2] , -V[5] ] == {{-2*gc926, 0}, {0, 0}, {gc926, 0}, {0, 0}},

C[ S[4] , S[6] , S[2] , -V[5] ] == {{-2*gc927, 0}, {0, 0}, {gc927, 0}, {0, 0}},

C[ S[5] , S[1] , -V[5] ] == {{(-I)*gc928, 0}, {I*gc928, 0}, {0, 0}},

C[ S[5] , S[5] , -S[5] , -V[5] ] == {{(-I)*gc929, 0}, {(-I)*gc929, 0}, {(2*I)*gc929, 0}, {0, 0}},

C[ S[5] , -S[5] , S[6] , -V[5] ] == {{I*gc930, 0}, {(-2*I)*gc930, 0}, {I*gc930, 0}, {0, 0}},

C[ S[5] , S[5] , -S[6] , -V[5] ] == {{(-I)*gc931, 0}, {(-I)*gc931, 0}, {(2*I)*gc931, 0}, {0, 0}},

C[ S[6] , S[2] , -V[5] ] == {{(-I)*gc932, 0}, {I*gc932, 0}, {0, 0}},

C[ S[6] , S[6] , -S[6] , -V[5] ] == {{(-I)*gc933, 0}, {(-I)*gc933, 0}, {(2*I)*gc933, 0}, {0, 0}},

C[ S[5] , V[1] , V[1] , -V[5] ] == {{(-I)*gc934, 0}, {(-I)*gc934, 0}, {I*gc934, 0}, {0, 0}, {I*gc934, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , V[1] , -V[5] ] == {{(-I)*gc935, 0}, {(-I)*gc935, 0}, {I*gc935, 0}, {0, 0}, {I*gc935, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[1] , V[2] , -V[5] ] == {{(-I)*gc936, 0}, {(-I)*gc936, 0}, {I*gc936, 0}, {0, 0}, {I*gc936, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , V[2] , -V[5] ] == {{(-I)*gc937*xiBG, 0}, {(-I)*gc937*xiBG, 0}, {I*gc937*xiBG, 0}, {0, 0}, {I*gc937*xiBG, 0}, {0, 0}, {0, 0}, {I*gc937, 0}, {0, 0}},

C[ S[5] , V[2] , V[2] , -V[5] ] == {{(-I)*gc938, 0}, {(-I)*gc938, 0}, {I*gc938, 0}, {0, 0}, {I*gc938, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , V[2] , -V[5] ] == {{(-I)*gc939, 0}, {(-I)*gc939, 0}, {I*gc939, 0}, {0, 0}, {I*gc939, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[1] , -V[5] , V[6] ] == {{I*gc940*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc940*swbar, 0}, {(-I)*gc940*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc940*swbar, 0}, {(-2*I)*cHW*gc940*swbar, 0}, {(2*I)*cHW*gc940*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[1] , -V[5] , V[6] ] == {{I*gc941*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(2*I)*cHW*gc941*swbar*xiBG, 0}, {(-I)*gc941*(cHWB*cwbar - 2*cHW*swbar)*xiBG, 0}, {(-2*I)*cHW*gc941*swbar*xiBG, 0}, {(-2*I)*cHW*gc941*swbar*xiBG, 0}, {(2*I)*cHW*gc941*swbar*xiBG, 0}, {(2*I)*cHW*gc941*swbar, 0}, {I*gc941*(cHWB*cwbar - 2*cHW*swbar), 0}, {0, 0}},

C[ S[1] , V[2] , -V[5] , V[6] ] == {{I*gc942*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc942*swbar, 0}, {(-I)*gc942*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc942*swbar, 0}, {(-2*I)*cHW*gc942*swbar, 0}, {(2*I)*cHW*gc942*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[2] , -V[5] , V[6] ] == {{I*gc943*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc943*swbar, 0}, {(-I)*gc943*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc943*swbar, 0}, {(-2*I)*cHW*gc943*swbar, 0}, {(2*I)*cHW*gc943*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[1] , -V[5] , V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {0, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {0, 0}, {I*g2*gc944*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {0, 0}, {I*g2*gc944*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {0, 0}, {(-6*I)*cW*gc944*swbar, 0}, {0, 0}, {(-2*I)*g2*gc944*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {(-6*I)*cW*gc944*swbar, 0}, {(6*I)*cW*gc944*swbar, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[2] , -V[5] , V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {I*g2*gc945*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {I*g2*gc945*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc945*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {(-6*I)*cW*gc945*swbar*xiBG, 0}, {(6*I)*cW*gc945*swbar*xiBG, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[2] , -V[5] , V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {0, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {0, 0}, {I*g2*gc946*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {0, 0}, {I*g2*gc946*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {0, 0}, {(-6*I)*cW*gc946*swbar, 0}, {0, 0}, {(-2*I)*g2*gc946*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {(-6*I)*cW*gc946*swbar, 0}, {(6*I)*cW*gc946*swbar, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[1] , -V[5] , V[3] ] == {{(-I)*cwbar^2*gc947, 0}, {0, 0}, {I*cwbar^2*gc947, 0}, {(-I)*gc947*swbar^2, 0}, {0, 0}, {I*gc947*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , -V[5] , V[3] ] == {{(-I)*cwbar^2*gc948, 0}, {0, 0}, {I*cwbar^2*gc948, 0}, {(-I)*gc948*swbar^2, 0}, {0, 0}, {I*gc948*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[2] , -V[5] , V[3] ] == {{(-I)*cwbar^2*gc949, 0}, {0, 0}, {I*cwbar^2*gc949, 0}, {(-I)*gc949*swbar^2, 0}, {0, 0}, {I*gc949*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , -V[5] , V[3] ] == {{(-I)*cwbar^2*gc950*xiBG, 0}, {0, 0}, {I*cwbar^2*gc950*xiBG, 0}, {(-I)*gc950*swbar^2*xiBG, 0}, {0, 0}, {I*gc950*swbar^2*xiBG, 0}, {0, 0}, {0, 0}, {I*gc950*swbar^2, 0}},

C[ V[1] , -V[5] , V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(-2*I)*g2*gc951*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {I*g2*gc951*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {I*g2*gc951*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}, {(-12*I)*cW*cwbar*gc951*swbar, 0}, {(12*I)*cW*cwbar*gc951*swbar, 0}},

C[ V[2] , -V[5] , V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-2*I)*g2*gc952*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {I*g2*gc952*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {I*g2*gc952*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc952*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc952*swbar*xiBG, 0}},

C[ S[5] , V[1] , -V[5] , V[4] ] == {{(-I)*cwbar^2*gc953, 0}, {0, 0}, {I*cwbar^2*gc953, 0}, {(-I)*gc953*swbar^2, 0}, {0, 0}, {I*gc953*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , -V[5] , V[4] ] == {{I*cwbar^2*gc954*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc954*xiBG, 0}, {I*gc954*swbar^2*xiBG, 0}, {0, 0}, {(-I)*gc954*swbar^2*xiBG, 0}, {0, 0}, {I*cwbar^2*gc954, 0}, {0, 0}},

C[ S[5] , V[2] , -V[5] , V[4] ] == {{(-I)*cwbar^2*gc955, 0}, {0, 0}, {I*cwbar^2*gc955, 0}, {(-I)*gc955*swbar^2, 0}, {0, 0}, {I*gc955*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , -V[5] , V[4] ] == {{(-I)*cwbar^2*gc956, 0}, {0, 0}, {I*cwbar^2*gc956, 0}, {(-I)*gc956*swbar^2, 0}, {0, 0}, {I*gc956*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , -V[5] , V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-2*I)*g2*gc957*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {I*g2*gc957*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {I*g2*gc957*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc957*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc957*swbar*xiBG, 0}},

C[ V[2] , -V[5] , V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(-2*I)*g2*gc958*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {I*g2*gc958*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {I*g2*gc958*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}, {(-12*I)*cW*cwbar*gc958*swbar, 0}, {(12*I)*cW*cwbar*gc958*swbar, 0}},

C[ S[6] , -U[1] , U[1] , -V[5] ] == {{I*gc959, 0}, {I*gc959, 0}, {0, 0}},

C[ S[2] , -U[1] , U[3] , -V[5] ] == {{I*gc960, 0}, {I*gc960, 0}, {0, 0}},

C[ S[6] , -U[1] , U[2] , -V[5] ] == {{I*gc961, 0}, {I*gc961, 0}, {0, 0}},

C[ -U[4] , U[1] , V[2] , -V[5] ] == {{(-I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[4] , U[1] , -V[5] ] == {{I*gc963, 0}, {I*gc963, 0}, {0, 0}},

C[ -U[4] , U[2] , V[2] , -V[5] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[4] , U[2] , -V[5] ] == {{I*gc965, 0}, {I*gc965, 0}, {0, 0}},

C[ S[6] , -U[2] , U[1] , -V[5] ] == {{I*gc966, 0}, {I*gc966, 0}, {0, 0}},

C[ S[2] , -U[2] , U[3] , -V[5] ] == {{I*gc967, 0}, {I*gc967, 0}, {0, 0}},

C[ S[6] , -U[2] , U[2] , -V[5] ] == {{I*gc968, 0}, {I*gc968, 0}, {0, 0}},

C[ -U[1] , U[3] , -V[5] ] == {{I*gc969, 0}, {0, 0}},

C[ -U[4] , U[1] , -V[5] ] == {{I*gc970, 0}, {0, 0}},

C[ -U[4] , U[2] , -V[5] ] == {{I*gc971, 0}, {0, 0}},

C[ -U[2] , U[3] , -V[5] ] == {{I*gc972, 0}, {0, 0}},

C[ V[5] , V[5] , -V[5] , -V[5] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {0, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {0, 0}, {I*g2*gc973*(1 + 2*cHW*vev^2), 0}, {0, 0}, {(6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {0, 0}, {I*g2*gc973*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {0, 0}, {(-6*I)*cW*gc973, 0}, {0, 0}, {(-2*I)*g2*gc973*(1 + 2*cHW*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {(-6*I)*cW*gc973, 0}, {(6*I)*cW*gc973, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[5] , -V[5] , V[6] ] == {{(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {0, 0}, {(6*I)*cW*gc974, 0}, {0, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {0, 0}, {(6*I)*cW*gc974, 0}, {0, 0}, {(6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(2*I)*g2*gc974*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc974, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {(-I)*g2*gc974*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc974, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(-I)*g2*gc974*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}, {(-6*I)*cW*gc974, 0}, {(6*I)*cW*gc974, 0}},

C[ V[5] , V[5] , -V[5] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {0, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {0, 0}, {I*g2*gc975*(1 + 2*cHW*vev^2), 0}, {0, 0}, {(6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {0, 0}, {I*g2*gc975*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {0, 0}, {(-6*I)*cW*gc975, 0}, {0, 0}, {(-2*I)*g2*gc975*(1 + 2*cHW*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {(-6*I)*cW*gc975, 0}, {(6*I)*cW*gc975, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[5] , V[6] , -V[6] ] == {{(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {I*g2*gc976*(1 + 2*cHW*vev^2)*(1 + xiBG), 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(-2*I)*g2*gc976*(1 + 2*cHW*vev^2)*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {I*g2*gc976*(1 + 2*cHW*vev^2)*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc976*xiBG, 0}, {(6*I)*cW*gc976*xiBG, 0}},

C[ S[1] , V[5] , -V[5] , V[3] ] == {{(-2*I)*cHW*cwbar*gc977, 0}, {(2*I)*cHW*cwbar*gc977, 0}, {(2*I)*cHW*cwbar*gc977, 0}, {(-I)*gc977*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc977, 0}, {I*gc977*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[5] , -V[5] , V[3] ] == {{(-2*I)*cHW*cwbar*gc978, 0}, {(2*I)*cHW*cwbar*gc978, 0}, {(2*I)*cHW*cwbar*gc978, 0}, {(-I)*gc978*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc978, 0}, {I*gc978*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[5] , -V[5] , V[4] ] == {{(-2*I)*cHW*cwbar*gc979, 0}, {(2*I)*cHW*cwbar*gc979, 0}, {(2*I)*cHW*cwbar*gc979, 0}, {(-I)*gc979*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc979, 0}, {I*gc979*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[5] , -V[5] , V[4] ] == {{(2*I)*cHW*cwbar*gc980*xiBG, 0}, {(-2*I)*cHW*cwbar*gc980*xiBG, 0}, {(-2*I)*cHW*cwbar*gc980*xiBG, 0}, {I*gc980*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {(2*I)*cHW*cwbar*gc980*xiBG, 0}, {(-I)*gc980*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {(-2*I)*cHW*cwbar*gc980, 0}, {(2*I)*cHW*cwbar*gc980, 0}, {0, 0}},

C[ S[5] , S[5] , -V[5] , -V[5] ] == {{0, 0}, {I*gc981, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[6] , -V[5] , -V[5] ] == {{0, 0}, {I*gc982, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[6] , -V[5] , -V[5] ] == {{0, 0}, {I*gc983, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , V[6] ] == {{gc984*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc984*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , -S[6] , V[6] ] == {{gc985*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc985*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , S[3] , -S[5] , V[6] ] == {{I*gc986, 0}, {I*gc986, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , -S[5] , V[6] ] == {{I*gc987, 0}, {I*gc987, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , -S[6] , V[6] ] == {{I*gc988, 0}, {I*gc988, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , -S[6] , V[6] ] == {{I*gc989, 0}, {I*gc989, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[1] , V[6] ] == {{-2*gc990, 0}, {0, 0}, {gc990, 0}, {0, 0}},

C[ S[3] , -S[6] , S[1] , V[6] ] == {{-2*gc991, 0}, {0, 0}, {gc991, 0}, {0, 0}},

C[ S[3] , -S[5] , S[2] , V[6] ] == {{-2*gc992, 0}, {0, 0}, {gc992, 0}, {0, 0}},

C[ S[3] , -S[6] , S[2] , V[6] ] == {{-2*gc993, 0}, {0, 0}, {gc993, 0}, {0, 0}},

C[ S[4] , -S[5] , V[6] ] == {{gc994*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc994*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , -S[6] , V[6] ] == {{gc995*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc995*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , S[4] , -S[5] , V[6] ] == {{I*gc996, 0}, {I*gc996, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , -S[6] , V[6] ] == {{I*gc997, 0}, {I*gc997, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[1] , V[6] ] == {{-2*gc998, 0}, {0, 0}, {gc998, 0}, {0, 0}},

C[ S[4] , -S[6] , S[1] , V[6] ] == {{-2*gc999, 0}, {0, 0}, {gc999, 0}, {0, 0}},

C[ S[4] , -S[5] , S[2] , V[6] ] == {{-2*gc1000, 0}, {0, 0}, {gc1000, 0}, {0, 0}},

C[ S[4] , -S[6] , S[2] , V[6] ] == {{-2*gc1001, 0}, {0, 0}, {gc1001, 0}, {0, 0}},

C[ S[5] , -S[5] , -S[5] , V[6] ] == {{(-2*I)*gc1002, 0}, {I*gc1002, 0}, {I*gc1002, 0}, {0, 0}},

C[ S[5] , -S[5] , -S[6] , V[6] ] == {{(-2*I)*gc1003, 0}, {I*gc1003, 0}, {I*gc1003, 0}, {0, 0}},

C[ S[5] , -S[6] , -S[6] , V[6] ] == {{(-2*I)*gc1004, 0}, {I*gc1004, 0}, {I*gc1004, 0}, {0, 0}},

C[ -S[5] , S[1] , V[6] ] == {{(-I)*gc1005, 0}, {I*gc1005, 0}, {0, 0}},

C[ -S[5] , S[2] , V[6] ] == {{(-I)*gc1006, 0}, {I*gc1006, 0}, {0, 0}},

C[ -S[5] , -S[5] , S[6] , V[6] ] == {{(-I)*gc1007, 0}, {(-I)*gc1007, 0}, {(2*I)*gc1007, 0}, {0, 0}},

C[ -S[5] , S[6] , -S[6] , V[6] ] == {{I*gc1008, 0}, {(-2*I)*gc1008, 0}, {I*gc1008, 0}, {0, 0}},

C[ S[6] , -S[6] , -S[6] , V[6] ] == {{(-2*I)*gc1009, 0}, {I*gc1009, 0}, {I*gc1009, 0}, {0, 0}},

C[ -S[6] , S[1] , V[6] ] == {{(-I)*gc1010, 0}, {I*gc1010, 0}, {0, 0}},

C[ -S[6] , S[2] , V[6] ] == {{(-I)*gc1011, 0}, {I*gc1011, 0}, {0, 0}},

C[ -S[5] , V[1] , V[1] , V[6] ] == {{(-I)*gc1012, 0}, {(-I)*gc1012, 0}, {I*gc1012, 0}, {0, 0}, {I*gc1012, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[1] , V[6] ] == {{I*gc1013*xiBG, 0}, {I*gc1013*xiBG, 0}, {(-I)*gc1013*xiBG, 0}, {0, 0}, {(-I)*gc1013*xiBG, 0}, {0, 0}, {I*gc1013, 0}, {I*gc1013, 0}, {0, 0}},

C[ -S[5] , V[1] , V[2] , V[6] ] == {{(-I)*gc1014, 0}, {(-I)*gc1014, 0}, {I*gc1014, 0}, {0, 0}, {I*gc1014, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[2] , V[6] ] == {{(-I)*gc1015, 0}, {(-I)*gc1015, 0}, {I*gc1015, 0}, {0, 0}, {I*gc1015, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[2] , V[2] , V[6] ] == {{(-I)*gc1016, 0}, {(-I)*gc1016, 0}, {I*gc1016, 0}, {0, 0}, {I*gc1016, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[2] , V[6] ] == {{(-I)*gc1017, 0}, {(-I)*gc1017, 0}, {I*gc1017, 0}, {0, 0}, {I*gc1017, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[1] , V[6] , -V[6] ] == {{I*gc1018*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc1018*swbar, 0}, {(-I)*gc1018*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc1018*swbar, 0}, {(-2*I)*cHW*gc1018*swbar, 0}, {(2*I)*cHW*gc1018*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[1] , V[6] , -V[6] ] == {{I*gc1019*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc1019*swbar, 0}, {(-I)*gc1019*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc1019*swbar, 0}, {(-2*I)*cHW*gc1019*swbar, 0}, {(2*I)*cHW*gc1019*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[2] , V[6] , -V[6] ] == {{I*gc1020*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc1020*swbar, 0}, {(-I)*gc1020*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc1020*swbar, 0}, {(-2*I)*cHW*gc1020*swbar, 0}, {(2*I)*cHW*gc1020*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[2] , V[6] , -V[6] ] == {{I*gc1021*(cHWB*cwbar - 2*cHW*swbar), 0}, {(2*I)*cHW*gc1021*swbar, 0}, {(-I)*gc1021*(cHWB*cwbar - 2*cHW*swbar), 0}, {(-2*I)*cHW*gc1021*swbar, 0}, {(-2*I)*cHW*gc1021*swbar, 0}, {(2*I)*cHW*gc1021*swbar, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[1] , V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {I*g2*gc1022*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {I*g2*gc1022*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1022*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {(-6*I)*cW*gc1022*swbar*xiBG, 0}, {(6*I)*cW*gc1022*swbar*xiBG, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[2] , V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {0, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {0, 0}, {I*g2*gc1023*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {0, 0}, {I*g2*gc1023*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {0, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {0, 0}, {(-2*I)*g2*gc1023*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {(-6*I)*cW*gc1023*swbar, 0}, {(6*I)*cW*gc1023*swbar, 0}, {0, 0}, {0, 0}},

C[ V[2] , V[2] , V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {0, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {0, 0}, {I*g2*gc1024*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {0, 0}, {I*g2*gc1024*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {0, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {0, 0}, {(-2*I)*g2*gc1024*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {(-6*I)*cW*gc1024*swbar, 0}, {(6*I)*cW*gc1024*swbar, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[1] , V[6] , V[3] ] == {{(-I)*cwbar^2*gc1025, 0}, {0, 0}, {I*cwbar^2*gc1025, 0}, {(-I)*gc1025*swbar^2, 0}, {0, 0}, {I*gc1025*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[6] , V[3] ] == {{I*cwbar^2*gc1026*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc1026*xiBG, 0}, {I*gc1026*swbar^2*xiBG, 0}, {0, 0}, {(-I)*gc1026*swbar^2*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc1026, 0}, {I*gc1026*swbar^2, 0}},

C[ -S[5] , V[2] , V[6] , V[3] ] == {{(-I)*cwbar^2*gc1027, 0}, {0, 0}, {I*cwbar^2*gc1027, 0}, {(-I)*gc1027*swbar^2, 0}, {0, 0}, {I*gc1027*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[6] , V[3] ] == {{(-I)*cwbar^2*gc1028, 0}, {0, 0}, {I*cwbar^2*gc1028, 0}, {(-I)*gc1028*swbar^2, 0}, {0, 0}, {I*gc1028*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[6] , -V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-2*I)*g2*gc1029*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {I*g2*gc1029*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(-1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {I*g2*gc1029*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2))*(-1 + xiBG), 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(-12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}, {(12*I)*cW*cwbar*gc1029*swbar*xiBG, 0}},

C[ V[2] , V[6] , -V[6] , V[3] ] == {{(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(-2*I)*g2*gc1030*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {I*g2*gc1030*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {I*g2*gc1030*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}, {(-12*I)*cW*cwbar*gc1030*swbar, 0}, {(12*I)*cW*cwbar*gc1030*swbar, 0}},

C[ -S[5] , V[1] , V[6] , V[4] ] == {{(-I)*cwbar^2*gc1031, 0}, {0, 0}, {I*cwbar^2*gc1031, 0}, {(-I)*gc1031*swbar^2, 0}, {0, 0}, {I*gc1031*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[1] , V[6] , V[4] ] == {{(-I)*cwbar^2*gc1032, 0}, {0, 0}, {I*cwbar^2*gc1032, 0}, {(-I)*gc1032*swbar^2, 0}, {0, 0}, {I*gc1032*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[2] , V[6] , V[4] ] == {{(-I)*cwbar^2*gc1033, 0}, {0, 0}, {I*cwbar^2*gc1033, 0}, {(-I)*gc1033*swbar^2, 0}, {0, 0}, {I*gc1033*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[2] , V[6] , V[4] ] == {{(-I)*cwbar^2*gc1034, 0}, {0, 0}, {I*cwbar^2*gc1034, 0}, {(-I)*gc1034*swbar^2, 0}, {0, 0}, {I*gc1034*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[1] , V[6] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(-2*I)*g2*gc1035*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {I*g2*gc1035*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {I*g2*gc1035*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}, {(-12*I)*cW*cwbar*gc1035*swbar, 0}, {(12*I)*cW*cwbar*gc1035*swbar, 0}},

C[ V[2] , V[6] , -V[6] , V[4] ] == {{(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {0, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(-2*I)*g2*gc1036*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {I*g2*gc1036*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {I*g2*gc1036*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}, {(-12*I)*cW*cwbar*gc1036*swbar, 0}, {(12*I)*cW*cwbar*gc1036*swbar, 0}},

C[ -S[6] , -U[1] , U[1] , V[6] ] == {{(-I)*gc1037, 0}, {(-I)*gc1037, 0}, {I*gc1037, 0}},

C[ -U[1] , U[4] , V[1] , V[6] ] == {{(-I)*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[4] , V[2] , V[6] ] == {{(-I)*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ S[2] , -U[1] , U[4] , V[6] ] == {{(-I)*gc1040, 0}, {(-I)*gc1040, 0}, {I*gc1040, 0}},

C[ -S[6] , -U[1] , U[2] , V[6] ] == {{(-I)*gc1041, 0}, {(-I)*gc1041, 0}, {I*gc1041, 0}},

C[ -U[1] , U[4] , V[6] ] == {{(-I)*gc1042, 0}, {I*gc1042, 0}},

C[ -U[3] , U[1] , V[2] , V[6] ] == {{(-I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[3] , U[1] , V[6] ] == {{(-I)*gc1044, 0}, {(-I)*gc1044, 0}, {I*gc1044, 0}},

C[ -U[3] , U[2] , V[2] , V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[3] , U[2] , V[6] ] == {{(-I)*gc1046, 0}, {(-I)*gc1046, 0}, {I*gc1046, 0}},

C[ -U[3] , U[1] , V[6] ] == {{(-I)*gc1047, 0}, {I*gc1047, 0}},

C[ -U[3] , U[2] , V[6] ] == {{(-I)*gc1048, 0}, {I*gc1048, 0}},

C[ -S[6] , -U[2] , U[1] , V[6] ] == {{(-I)*gc1049, 0}, {(-I)*gc1049, 0}, {I*gc1049, 0}},

C[ -U[2] , U[4] , V[1] , V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[4] , V[2] , V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[2] , U[4] , V[6] ] == {{(-I)*gc1052, 0}, {(-I)*gc1052, 0}, {I*gc1052, 0}},

C[ -S[6] , -U[2] , U[2] , V[6] ] == {{(-I)*gc1053, 0}, {(-I)*gc1053, 0}, {I*gc1053, 0}},

C[ -U[2] , U[4] , V[6] ] == {{(-I)*gc1054, 0}, {I*gc1054, 0}},

C[ -S[5] , -S[5] , V[5] , V[6] ] == {{0, 0}, {I*gc1055, 0}, {0, 0}, {0, 0}},

C[ -S[5] , -S[6] , V[5] , V[6] ] == {{0, 0}, {I*gc1056, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -S[6] , V[5] , V[6] ] == {{0, 0}, {I*gc1057, 0}, {0, 0}, {0, 0}},

C[ -U[3] , U[4] , V[5] , V[6] ] == {{(-I)*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ S[4] , S[1] , -V[5] , V[6] ] == {{0, 0}, {gc1059, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[2] , -V[5] , V[6] ] == {{0, 0}, {gc1060, 0}, {0, 0}, {0, 0}},

C[ S[3] , -V[5] , V[6] ] == {{0, 0}, {gc1061, 0}, {0, 0}, {0, 0}},

C[ S[2] , -V[5] , V[6] , V[3] ] == {{(2*I)*cHW*cwbar*gc1062*xiBG, 0}, {(-2*I)*cHW*cwbar*gc1062*xiBG, 0}, {(-2*I)*cHW*cwbar*gc1062*xiBG, 0}, {I*gc1062*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {(2*I)*cHW*cwbar*gc1062*xiBG, 0}, {(-I)*gc1062*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {0, 0}, {(-2*I)*cHW*cwbar*gc1062, 0}, {I*gc1062*(2*cHW*cwbar + cHWB*swbar), 0}},

C[ -U[1] , U[1] , -V[5] , V[6] ] == {{I*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[2] , -V[5] , V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[3] , U[3] , -V[5] , V[6] ] == {{I*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[2] , U[1] , -V[5] , V[6] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[2] , -V[5] , V[6] ] == {{I*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -V[5] , -V[5] , V[6] , V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {I*g2*gc1068*(1 + 2*cHW*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {I*g2*gc1068*(1 + 2*cHW*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1068*(1 + 2*cHW*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {(-6*I)*cW*gc1068*xiBG, 0}, {(6*I)*cW*gc1068*xiBG, 0}, {0, 0}, {0, 0}},

C[ -V[5] , V[6] , V[6] , -V[6] ] == {{(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {0, 0}, {(6*I)*cW*gc1069, 0}, {0, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {0, 0}, {(6*I)*cW*gc1069, 0}, {0, 0}, {(6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(2*I)*g2*gc1069*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc1069, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {(-I)*g2*gc1069*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc1069, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(-I)*g2*gc1069*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}, {(-6*I)*cW*gc1069, 0}, {(6*I)*cW*gc1069, 0}},

C[ S[1] , -V[5] , V[6] , V[3] ] == {{(-2*I)*cHW*cwbar*gc1070, 0}, {(2*I)*cHW*cwbar*gc1070, 0}, {(2*I)*cHW*cwbar*gc1070, 0}, {(-I)*gc1070*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1070, 0}, {I*gc1070*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , -V[5] , V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1071, 0}, {(2*I)*cHW*cwbar*gc1071, 0}, {(2*I)*cHW*cwbar*gc1071, 0}, {(-I)*gc1071*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1071, 0}, {I*gc1071*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , -V[5] , V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1072, 0}, {(2*I)*cHW*cwbar*gc1072, 0}, {(2*I)*cHW*cwbar*gc1072, 0}, {(-I)*gc1072*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1072, 0}, {I*gc1072*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[5] , -S[5] , V[6] , V[6] ] == {{0, 0}, {I*gc1073, 0}, {0, 0}, {0, 0}},

C[ -S[5] , -S[6] , V[6] , V[6] ] == {{0, 0}, {I*gc1074, 0}, {0, 0}, {0, 0}},

C[ -S[6] , -S[6] , V[6] , V[6] ] == {{0, 0}, {I*gc1075, 0}, {0, 0}, {0, 0}},

C[ -U[3] , U[4] , V[6] , V[6] ] == {{(-2*I)*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ S[3] , S[5] , -V[6] ] == {{gc1077*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc1077*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , S[6] , -V[6] ] == {{gc1078*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc1078*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[3] , S[3] , S[5] , -V[6] ] == {{I*gc1079, 0}, {I*gc1079, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , S[5] , -V[6] ] == {{I*gc1080, 0}, {I*gc1080, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[3] , S[6] , -V[6] ] == {{I*gc1081, 0}, {I*gc1081, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[4] , S[6] , -V[6] ] == {{I*gc1082, 0}, {I*gc1082, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , S[1] , -V[6] ] == {{-2*gc1083, 0}, {0, 0}, {gc1083, 0}, {0, 0}},

C[ S[3] , S[6] , S[1] , -V[6] ] == {{-2*gc1084, 0}, {0, 0}, {gc1084, 0}, {0, 0}},

C[ S[3] , S[5] , S[2] , -V[6] ] == {{-2*gc1085, 0}, {0, 0}, {gc1085, 0}, {0, 0}},

C[ S[3] , S[6] , S[2] , -V[6] ] == {{-2*gc1086, 0}, {0, 0}, {gc1086, 0}, {0, 0}},

C[ S[4] , S[5] , -V[6] ] == {{gc1087*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc1087*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , S[6] , -V[6] ] == {{gc1088*(4 + 3*cHD*vev^2 + 4*cHW*vev^2), 0}, {gc1088*(-4 + cHD*vev^2 - 4*cHW*vev^2), 0}, {0, 0}},

C[ S[4] , S[4] , S[5] , -V[6] ] == {{I*gc1089, 0}, {I*gc1089, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[4] , S[6] , -V[6] ] == {{I*gc1090, 0}, {I*gc1090, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , S[1] , -V[6] ] == {{-2*gc1091, 0}, {0, 0}, {gc1091, 0}, {0, 0}},

C[ S[4] , S[6] , S[1] , -V[6] ] == {{-2*gc1092, 0}, {0, 0}, {gc1092, 0}, {0, 0}},

C[ S[4] , S[5] , S[2] , -V[6] ] == {{-2*gc1093, 0}, {0, 0}, {gc1093, 0}, {0, 0}},

C[ S[4] , S[6] , S[2] , -V[6] ] == {{-2*gc1094, 0}, {0, 0}, {gc1094, 0}, {0, 0}},

C[ S[5] , S[1] , -V[6] ] == {{(-I)*gc1095, 0}, {I*gc1095, 0}, {0, 0}},

C[ S[5] , S[2] , -V[6] ] == {{(-I)*gc1096, 0}, {I*gc1096, 0}, {0, 0}},

C[ S[5] , S[5] , -S[5] , -V[6] ] == {{(-I)*gc1097, 0}, {(-I)*gc1097, 0}, {(2*I)*gc1097, 0}, {0, 0}},

C[ S[5] , -S[5] , S[6] , -V[6] ] == {{I*gc1098, 0}, {(-2*I)*gc1098, 0}, {I*gc1098, 0}, {0, 0}},

C[ S[5] , S[5] , -S[6] , -V[6] ] == {{(-I)*gc1099, 0}, {(-I)*gc1099, 0}, {(2*I)*gc1099, 0}, {0, 0}},

C[ S[5] , S[6] , -S[6] , -V[6] ] == {{(-I)*gc1100, 0}, {(-I)*gc1100, 0}, {(2*I)*gc1100, 0}, {0, 0}},

C[ -S[5] , S[6] , S[6] , -V[6] ] == {{(-2*I)*gc1101, 0}, {I*gc1101, 0}, {I*gc1101, 0}, {0, 0}},

C[ S[6] , S[1] , -V[6] ] == {{(-I)*gc1102, 0}, {I*gc1102, 0}, {0, 0}},

C[ S[6] , S[2] , -V[6] ] == {{(-I)*gc1103, 0}, {I*gc1103, 0}, {0, 0}},

C[ S[6] , S[6] , -S[6] , -V[6] ] == {{(-I)*gc1104, 0}, {(-I)*gc1104, 0}, {(2*I)*gc1104, 0}, {0, 0}},

C[ S[5] , V[1] , V[1] , -V[6] ] == {{(-I)*gc1105, 0}, {(-I)*gc1105, 0}, {I*gc1105, 0}, {0, 0}, {I*gc1105, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , V[1] , -V[6] ] == {{I*gc1106*xiBG, 0}, {I*gc1106*xiBG, 0}, {(-I)*gc1106*xiBG, 0}, {0, 0}, {(-I)*gc1106*xiBG, 0}, {0, 0}, {I*gc1106, 0}, {I*gc1106, 0}, {0, 0}},

C[ S[5] , V[1] , V[2] , -V[6] ] == {{(-I)*gc1107, 0}, {(-I)*gc1107, 0}, {I*gc1107, 0}, {0, 0}, {I*gc1107, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , V[2] , -V[6] ] == {{(-I)*gc1108, 0}, {(-I)*gc1108, 0}, {I*gc1108, 0}, {0, 0}, {I*gc1108, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[2] , V[2] , -V[6] ] == {{(-I)*gc1109, 0}, {(-I)*gc1109, 0}, {I*gc1109, 0}, {0, 0}, {I*gc1109, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , V[2] , -V[6] ] == {{(-I)*gc1110, 0}, {(-I)*gc1110, 0}, {I*gc1110, 0}, {0, 0}, {I*gc1110, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[1] , -V[6] , V[3] ] == {{(-I)*cwbar^2*gc1111, 0}, {0, 0}, {I*cwbar^2*gc1111, 0}, {(-I)*gc1111*swbar^2, 0}, {0, 0}, {I*gc1111*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , -V[6] , V[3] ] == {{I*cwbar^2*gc1112*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc1112*xiBG, 0}, {I*gc1112*swbar^2*xiBG, 0}, {0, 0}, {(-I)*gc1112*swbar^2*xiBG, 0}, {0, 0}, {(-I)*cwbar^2*gc1112, 0}, {I*gc1112*swbar^2, 0}},

C[ S[5] , V[2] , -V[6] , V[3] ] == {{(-I)*cwbar^2*gc1113, 0}, {0, 0}, {I*cwbar^2*gc1113, 0}, {(-I)*gc1113*swbar^2, 0}, {0, 0}, {I*gc1113*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , -V[6] , V[3] ] == {{(-I)*cwbar^2*gc1114, 0}, {0, 0}, {I*cwbar^2*gc1114, 0}, {(-I)*gc1114*swbar^2, 0}, {0, 0}, {I*gc1114*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[1] , -V[6] , V[4] ] == {{(-I)*cwbar^2*gc1115, 0}, {0, 0}, {I*cwbar^2*gc1115, 0}, {(-I)*gc1115*swbar^2, 0}, {0, 0}, {I*gc1115*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[1] , -V[6] , V[4] ] == {{(-I)*cwbar^2*gc1116, 0}, {0, 0}, {I*cwbar^2*gc1116, 0}, {(-I)*gc1116*swbar^2, 0}, {0, 0}, {I*gc1116*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , V[2] , -V[6] , V[4] ] == {{(-I)*cwbar^2*gc1117, 0}, {0, 0}, {I*cwbar^2*gc1117, 0}, {(-I)*gc1117*swbar^2, 0}, {0, 0}, {I*gc1117*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , V[2] , -V[6] , V[4] ] == {{(-I)*cwbar^2*gc1118, 0}, {0, 0}, {I*cwbar^2*gc1118, 0}, {(-I)*gc1118*swbar^2, 0}, {0, 0}, {I*gc1118*swbar^2, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[1] , U[1] , -V[6] ] == {{(-I)*gc1119, 0}, {(-I)*gc1119, 0}, {I*gc1119, 0}},

C[ -U[1] , U[3] , V[1] , -V[6] ] == {{(-I)*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[3] , V[2] , -V[6] ] == {{(-I)*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ S[2] , -U[1] , U[3] , -V[6] ] == {{(-I)*gc1122, 0}, {(-I)*gc1122, 0}, {I*gc1122, 0}},

C[ S[6] , -U[1] , U[2] , -V[6] ] == {{(-I)*gc1123, 0}, {(-I)*gc1123, 0}, {I*gc1123, 0}},

C[ -U[1] , U[3] , -V[6] ] == {{(-I)*gc1124, 0}, {I*gc1124, 0}},

C[ -U[4] , U[1] , V[2] , -V[6] ] == {{(-I)*g2^2*swbar*(swbar - cHWB*cwbar*vev^2 + 2*cHW*swbar*vev^2), 0}},

C[ S[2] , -U[4] , U[1] , -V[6] ] == {{(-I)*gc1126, 0}, {(-I)*gc1126, 0}, {I*gc1126, 0}},

C[ -U[4] , U[2] , V[2] , -V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[4] , U[2] , -V[6] ] == {{(-I)*gc1128, 0}, {(-I)*gc1128, 0}, {I*gc1128, 0}},

C[ -U[4] , U[1] , -V[6] ] == {{(-I)*gc1129, 0}, {I*gc1129, 0}},

C[ -U[4] , U[2] , -V[6] ] == {{(-I)*gc1130, 0}, {I*gc1130, 0}},

C[ S[6] , -U[2] , U[1] , -V[6] ] == {{(-I)*gc1131, 0}, {(-I)*gc1131, 0}, {I*gc1131, 0}},

C[ -U[2] , U[3] , V[1] , -V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[3] , V[2] , -V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[2] , U[3] , -V[6] ] == {{(-I)*gc1134, 0}, {(-I)*gc1134, 0}, {I*gc1134, 0}},

C[ S[6] , -U[2] , U[2] , -V[6] ] == {{(-I)*gc1135, 0}, {(-I)*gc1135, 0}, {I*gc1135, 0}},

C[ -U[2] , U[3] , -V[6] ] == {{(-I)*gc1136, 0}, {I*gc1136, 0}},

C[ S[4] , S[1] , V[5] , -V[6] ] == {{0, 0}, {gc1137, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[2] , V[5] , -V[6] ] == {{0, 0}, {gc1138, 0}, {0, 0}, {0, 0}},

C[ S[3] , V[5] , -V[6] ] == {{0, 0}, {gc1139, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[5] , -V[6] , V[3] ] == {{(2*I)*cHW*cwbar*gc1140*xiBG, 0}, {(-2*I)*cHW*cwbar*gc1140*xiBG, 0}, {(-2*I)*cHW*cwbar*gc1140*xiBG, 0}, {I*gc1140*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {(2*I)*cHW*cwbar*gc1140*xiBG, 0}, {(-I)*gc1140*(2*cHW*cwbar + cHWB*swbar)*xiBG, 0}, {0, 0}, {(-2*I)*cHW*cwbar*gc1140, 0}, {I*gc1140*(2*cHW*cwbar + cHWB*swbar), 0}},

C[ -U[1] , U[1] , V[5] , -V[6] ] == {{I*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[2] , V[5] , -V[6] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[4] , V[5] , -V[6] ] == {{I*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[2] , U[1] , V[5] , -V[6] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[2] , V[5] , -V[6] ] == {{I*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ V[5] , V[5] , -V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {I*g2*gc1146*(1 + 2*cHW*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {I*g2*gc1146*(1 + 2*cHW*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1146*(1 + 2*cHW*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {(-6*I)*cW*gc1146*xiBG, 0}, {(6*I)*cW*gc1146*xiBG, 0}, {0, 0}, {0, 0}},

C[ V[5] , V[6] , -V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {0, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {0, 0}, {I*g2*gc1147*(1 + 2*cHW*vev^2), 0}, {0, 0}, {(6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {0, 0}, {I*g2*gc1147*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {0, 0}, {(-6*I)*cW*gc1147, 0}, {0, 0}, {(-2*I)*g2*gc1147*(1 + 2*cHW*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {(-6*I)*cW*gc1147, 0}, {(6*I)*cW*gc1147, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[5] , -V[6] , V[3] ] == {{(-2*I)*cHW*cwbar*gc1148, 0}, {(2*I)*cHW*cwbar*gc1148, 0}, {(2*I)*cHW*cwbar*gc1148, 0}, {(-I)*gc1148*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1148, 0}, {I*gc1148*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[5] , -V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1149, 0}, {(2*I)*cHW*cwbar*gc1149, 0}, {(2*I)*cHW*cwbar*gc1149, 0}, {(-I)*gc1149*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1149, 0}, {I*gc1149*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[5] , -V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1150, 0}, {(2*I)*cHW*cwbar*gc1150, 0}, {(2*I)*cHW*cwbar*gc1150, 0}, {(-I)*gc1150*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1150, 0}, {I*gc1150*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[5] , -V[5] , -V[6] ] == {{0, 0}, {I*gc1151, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[6] , -V[5] , -V[6] ] == {{0, 0}, {I*gc1152, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[6] , -V[5] , -V[6] ] == {{0, 0}, {I*gc1153, 0}, {0, 0}, {0, 0}},

C[ -U[4] , U[3] , -V[5] , -V[6] ] == {{(-I)*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[1] , V[6] , -V[6] ] == {{(2*I)*g2^2*swbar^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[1] , U[2] , V[6] , -V[6] ] == {{I*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[4] , V[6] , -V[6] ] == {{I*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[3] , U[3] , V[6] , -V[6] ] == {{I*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -U[2] , U[1] , V[6] , -V[6] ] == {{(-I)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[2] , V[6] , -V[6] ] == {{(2*I)*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ V[6] , V[6] , -V[6] , -V[6] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {0, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {0, 0}, {0, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {0, 0}, {I*g2*gc1161*(1 + 2*cHW*vev^2), 0}, {0, 0}, {(6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {0, 0}, {I*g2*gc1161*(1 + 2*cHW*vev^2), 0}, {(-6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {0, 0}, {(-6*I)*cW*gc1161, 0}, {0, 0}, {(-2*I)*g2*gc1161*(1 + 2*cHW*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {(-6*I)*cW*gc1161, 0}, {(6*I)*cW*gc1161, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[6] , -V[6] , V[3] ] == {{(-2*I)*cHW*cwbar*gc1162, 0}, {(2*I)*cHW*cwbar*gc1162, 0}, {(2*I)*cHW*cwbar*gc1162, 0}, {(-I)*gc1162*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1162, 0}, {I*gc1162*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[6] , -V[6] , V[3] ] == {{(-2*I)*cHW*cwbar*gc1163, 0}, {(2*I)*cHW*cwbar*gc1163, 0}, {(2*I)*cHW*cwbar*gc1163, 0}, {(-I)*gc1163*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1163, 0}, {I*gc1163*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[1] , V[6] , -V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1164, 0}, {(2*I)*cHW*cwbar*gc1164, 0}, {(2*I)*cHW*cwbar*gc1164, 0}, {(-I)*gc1164*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1164, 0}, {I*gc1164*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[2] , V[6] , -V[6] , V[4] ] == {{(-2*I)*cHW*cwbar*gc1165, 0}, {(2*I)*cHW*cwbar*gc1165, 0}, {(2*I)*cHW*cwbar*gc1165, 0}, {(-I)*gc1165*(2*cHW*cwbar + cHWB*swbar), 0}, {(-2*I)*cHW*cwbar*gc1165, 0}, {I*gc1165*(2*cHW*cwbar + cHWB*swbar), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[5] , -V[6] , -V[6] ] == {{0, 0}, {I*gc1166, 0}, {0, 0}, {0, 0}},

C[ S[5] , S[6] , -V[6] , -V[6] ] == {{0, 0}, {I*gc1167, 0}, {0, 0}, {0, 0}},

C[ S[6] , S[6] , -V[6] , -V[6] ] == {{0, 0}, {I*gc1168, 0}, {0, 0}, {0, 0}},

C[ -U[4] , U[3] , -V[6] , -V[6] ] == {{(-2*I)*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ S[3] , S[1] , V[3] ] == {{gc1170*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1170*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[3] , S[3] , V[3] ] == {{gc1171, 0}, {gc1171, 0}, {gc1171, 0}, {0, 0}},

C[ S[3] , S[3] , S[4] , V[3] ] == {{gc1172, 0}, {gc1172, 0}, {gc1172, 0}, {0, 0}},

C[ S[3] , S[5] , -S[5] , V[3] ] == {{gc1173, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[6] , V[3] ] == {{gc1174, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -S[6] , V[3] ] == {{gc1175, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[1] , S[1] , V[3] ] == {{-3*gc1176, 0}, {gc1176, 0}, {gc1176, 0}, {0, 0}},

C[ S[3] , S[1] , S[2] , V[3] ] == {{-3*gc1177, 0}, {gc1177, 0}, {gc1177, 0}, {0, 0}},

C[ S[4] , S[2] , V[3] ] == {{gc1178*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1178*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[4] , S[4] , V[3] ] == {{gc1179, 0}, {gc1179, 0}, {gc1179, 0}, {0, 0}},

C[ S[4] , S[5] , -S[5] , V[3] ] == {{gc1180, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[6] , V[3] ] == {{gc1181, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , -S[6] , V[3] ] == {{gc1182, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -S[6] , V[3] ] == {{gc1183, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[1] , S[1] , V[3] ] == {{-3*gc1184, 0}, {gc1184, 0}, {gc1184, 0}, {0, 0}},

C[ S[4] , S[2] , S[2] , V[3] ] == {{-3*gc1185, 0}, {gc1185, 0}, {gc1185, 0}, {0, 0}},

C[ S[5] , -S[5] , V[3] ] == {{(-I)*gc1186, 0}, {I*gc1186, 0}, {0, 0}},

C[ S[5] , -S[5] , S[1] , V[3] ] == {{(-I)*gc1187, 0}, {I*gc1187, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , V[3] ] == {{(-I)*gc1188, 0}, {I*gc1188, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[5] , S[2] , V[3] ] == {{(-I)*gc1189, 0}, {I*gc1189, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , S[1] , V[3] ] == {{(-I)*gc1190, 0}, {I*gc1190, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , V[3] ] == {{(-I)*gc1191, 0}, {I*gc1191, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , V[3] ] == {{(-I)*gc1192, 0}, {I*gc1192, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , S[2] , V[3] ] == {{(-I)*gc1193, 0}, {I*gc1193, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[1] , U[4] , V[3] ] == {{I*gc1194, 0}, {I*gc1194, 0}, {0, 0}},

C[ -S[6] , -U[1] , U[3] , V[3] ] == {{I*gc1195, 0}, {I*gc1195, 0}, {0, 0}},

C[ -U[4] , U[4] , V[2] , V[3] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[4] , U[4] , V[3] ] == {{I*gc1197, 0}, {I*gc1197, 0}, {0, 0}},

C[ -U[3] , U[3] , V[2] , V[3] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[3] , U[3] , V[3] ] == {{I*gc1199, 0}, {I*gc1199, 0}, {0, 0}},

C[ S[6] , -U[2] , U[4] , V[3] ] == {{I*gc1200, 0}, {I*gc1200, 0}, {0, 0}},

C[ -S[6] , -U[2] , U[3] , V[3] ] == {{I*gc1201, 0}, {I*gc1201, 0}, {0, 0}},

C[ -U[4] , U[4] , V[3] ] == {{I*gc1202, 0}, {0, 0}},

C[ -U[3] , U[3] , V[3] ] == {{I*gc1203, 0}, {0, 0}},

C[ -S[5] , V[5] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1204, 0}, {0, 0}, {(-I)*gc1204, 0}, {I*gc1204, 0}, {I*gc1204, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[5] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1205, 0}, {0, 0}, {(-I)*gc1205, 0}, {I*gc1205, 0}, {I*gc1205, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[5] , V[3] , V[3] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {I*g2*gc1206*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {I*g2*gc1206*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {(-2*I)*g2*gc1206*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {(-6*I)*cW*cwbar*gc1206, 0}, {(6*I)*cW*cwbar*gc1206, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[6] , V[3] , V[3] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {I*g2*gc1207*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {I*g2*gc1207*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {(-2*I)*g2*gc1207*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {(-6*I)*cW*cwbar*gc1207, 0}, {(6*I)*cW*cwbar*gc1207, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[5] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1208, 0}, {0, 0}, {(-I)*gc1208, 0}, {I*gc1208, 0}, {I*gc1208, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[5] , V[3] , V[4] ] == {{0, 0}, {I*gc1209*xiBG, 0}, {0, 0}, {I*gc1209*xiBG, 0}, {(-I)*gc1209*xiBG, 0}, {(-I)*gc1209*xiBG, 0}, {I*gc1209, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[5] , V[3] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {I*g2*gc1210*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {I*g2*gc1210*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {(-2*I)*g2*gc1210*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {(-6*I)*cW*cwbar*gc1210, 0}, {(6*I)*cW*cwbar*gc1210, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[6] , V[3] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {I*g2*gc1211*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(1 + xiBG), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {I*g2*gc1211*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1211*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {(-6*I)*cW*cwbar*gc1211*xiBG, 0}, {(6*I)*cW*cwbar*gc1211*xiBG, 0}, {0, 0}, {0, 0}},

C[ S[5] , -V[5] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1212, 0}, {0, 0}, {(-I)*gc1212, 0}, {I*gc1212, 0}, {I*gc1212, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[5] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1213, 0}, {0, 0}, {(-I)*gc1213, 0}, {I*gc1213, 0}, {I*gc1213, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -V[5] , V[6] , V[3] , V[3] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {I*g2*gc1214*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {I*g2*gc1214*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {(-2*I)*g2*gc1214*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {(-6*I)*cW*cwbar*gc1214, 0}, {(6*I)*cW*cwbar*gc1214, 0}, {0, 0}, {0, 0}},

C[ S[5] , -V[5] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1215, 0}, {0, 0}, {(-I)*gc1215, 0}, {I*gc1215, 0}, {I*gc1215, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[5] , V[3] , V[4] ] == {{0, 0}, {I*gc1216*xiBG, 0}, {0, 0}, {I*gc1216*xiBG, 0}, {(-I)*gc1216*xiBG, 0}, {(-I)*gc1216*xiBG, 0}, {I*gc1216, 0}, {0, 0}, {0, 0}},

C[ -V[5] , V[6] , V[3] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {I*g2*gc1217*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(1 + xiBG), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {I*g2*gc1217*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1217*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {(-6*I)*cW*cwbar*gc1217*xiBG, 0}, {(6*I)*cW*cwbar*gc1217*xiBG, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[6] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1218*xiBG, 0}, {0, 0}, {(-I)*gc1218*xiBG, 0}, {I*gc1218*xiBG, 0}, {I*gc1218*xiBG, 0}, {I*gc1218, 0}, {0, 0}, {I*gc1218, 0}},

C[ -U[1] , U[4] , V[6] , V[3] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[4] , V[6] , V[3] ] == {{(-I)*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -S[5] , V[6] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1221, 0}, {0, 0}, {(-I)*gc1221, 0}, {I*gc1221, 0}, {I*gc1221, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[6] , -V[6] , V[3] , V[3] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {I*g2*gc1222*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {I*g2*gc1222*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1222*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {(-6*I)*cW*cwbar*gc1222*xiBG, 0}, {(6*I)*cW*cwbar*gc1222*xiBG, 0}, {0, 0}, {0, 0}},

C[ -S[5] , V[6] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1223, 0}, {0, 0}, {(-I)*gc1223, 0}, {I*gc1223, 0}, {I*gc1223, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[6] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1224, 0}, {0, 0}, {(-I)*gc1224, 0}, {I*gc1224, 0}, {I*gc1224, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[6] , -V[6] , V[3] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {I*g2*gc1225*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {I*g2*gc1225*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {(-2*I)*g2*gc1225*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {(-6*I)*cW*cwbar*gc1225, 0}, {(6*I)*cW*cwbar*gc1225, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[6] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1226*xiBG, 0}, {0, 0}, {(-I)*gc1226*xiBG, 0}, {I*gc1226*xiBG, 0}, {I*gc1226*xiBG, 0}, {I*gc1226, 0}, {0, 0}, {I*gc1226, 0}},

C[ -U[1] , U[3] , -V[6] , V[3] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[2] , U[3] , -V[6] , V[3] ] == {{(-I)*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ S[5] , -V[6] , V[3] , V[3] ] == {{0, 0}, {(-I)*gc1229, 0}, {0, 0}, {(-I)*gc1229, 0}, {I*gc1229, 0}, {I*gc1229, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[5] , -V[6] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1230, 0}, {0, 0}, {(-I)*gc1230, 0}, {I*gc1230, 0}, {I*gc1230, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[6] , V[3] , V[4] ] == {{0, 0}, {(-I)*gc1231, 0}, {0, 0}, {(-I)*gc1231, 0}, {I*gc1231, 0}, {I*gc1231, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[1] , V[4] ] == {{gc1232*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1232*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[2] , V[4] ] == {{gc1233*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1233*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[3] , S[3] , S[3] , V[4] ] == {{gc1234, 0}, {gc1234, 0}, {gc1234, 0}, {0, 0}},

C[ S[3] , S[3] , S[4] , V[4] ] == {{gc1235, 0}, {gc1235, 0}, {gc1235, 0}, {0, 0}},

C[ S[3] , S[4] , S[4] , V[4] ] == {{gc1236, 0}, {gc1236, 0}, {gc1236, 0}, {0, 0}},

C[ S[3] , S[5] , -S[5] , V[4] ] == {{gc1237, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , -S[5] , S[6] , V[4] ] == {{gc1238, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[5] , -S[6] , V[4] ] == {{gc1239, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[6] , -S[6] , V[4] ] == {{gc1240, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[3] , S[1] , S[1] , V[4] ] == {{-3*gc1241, 0}, {gc1241, 0}, {gc1241, 0}, {0, 0}},

C[ S[3] , S[1] , S[2] , V[4] ] == {{-3*gc1242, 0}, {gc1242, 0}, {gc1242, 0}, {0, 0}},

C[ S[3] , S[2] , S[2] , V[4] ] == {{-3*gc1243, 0}, {gc1243, 0}, {gc1243, 0}, {0, 0}},

C[ S[4] , S[1] , V[4] ] == {{gc1244*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1244*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[2] , V[4] ] == {{gc1245*(-(swbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 + cHbox*vev^2 + cHD*vev^2))) - cwbar*(cHWB*g1*vev^2 + 2*g2*(1 + cHbox*vev^2 + cHD*vev^2 + cHW*vev^2))), 0}, {gc1245*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHbox*vev^2) + 2*cwbar*g2*(1 + cHbox*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ S[4] , S[4] , S[4] , V[4] ] == {{gc1246, 0}, {gc1246, 0}, {gc1246, 0}, {0, 0}},

C[ S[4] , S[5] , -S[5] , V[4] ] == {{gc1247, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , -S[5] , S[6] , V[4] ] == {{gc1248, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[5] , -S[6] , V[4] ] == {{gc1249, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[6] , -S[6] , V[4] ] == {{gc1250, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[4] , S[1] , S[1] , V[4] ] == {{-3*gc1251, 0}, {gc1251, 0}, {gc1251, 0}, {0, 0}},

C[ S[4] , S[1] , S[2] , V[4] ] == {{-3*gc1252, 0}, {gc1252, 0}, {gc1252, 0}, {0, 0}},

C[ S[4] , S[2] , S[2] , V[4] ] == {{-3*gc1253, 0}, {gc1253, 0}, {gc1253, 0}, {0, 0}},

C[ S[5] , -S[5] , V[4] ] == {{(-I)*gc1254, 0}, {I*gc1254, 0}, {0, 0}},

C[ S[5] , -S[6] , V[4] ] == {{(-I)*gc1255, 0}, {I*gc1255, 0}, {0, 0}},

C[ S[5] , -S[5] , S[1] , V[4] ] == {{(-I)*gc1256, 0}, {I*gc1256, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[1] , V[4] ] == {{(-I)*gc1257, 0}, {I*gc1257, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[5] , S[2] , V[4] ] == {{(-I)*gc1258, 0}, {I*gc1258, 0}, {0, 0}, {0, 0}},

C[ S[5] , -S[6] , S[2] , V[4] ] == {{(-I)*gc1259, 0}, {I*gc1259, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , V[4] ] == {{(-I)*gc1260, 0}, {I*gc1260, 0}, {0, 0}},

C[ -S[5] , S[6] , S[1] , V[4] ] == {{(-I)*gc1261, 0}, {I*gc1261, 0}, {0, 0}, {0, 0}},

C[ -S[5] , S[6] , S[2] , V[4] ] == {{(-I)*gc1262, 0}, {I*gc1262, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , V[4] ] == {{(-I)*gc1263, 0}, {I*gc1263, 0}, {0, 0}},

C[ S[6] , -S[6] , S[1] , V[4] ] == {{(-I)*gc1264, 0}, {I*gc1264, 0}, {0, 0}, {0, 0}},

C[ S[6] , -S[6] , S[2] , V[4] ] == {{(-I)*gc1265, 0}, {I*gc1265, 0}, {0, 0}, {0, 0}},

C[ S[6] , -U[1] , U[4] , V[4] ] == {{(-I)*gc1266, 0}, {(-I)*gc1266, 0}, {I*gc1266, 0}},

C[ -S[6] , -U[1] , U[3] , V[4] ] == {{(-I)*gc1267, 0}, {(-I)*gc1267, 0}, {I*gc1267, 0}},

C[ -U[4] , U[4] , V[1] , V[4] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[4] , V[2] , V[4] ] == {{(-I)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[4] , U[4] , V[4] ] == {{(-I)*gc1270, 0}, {(-I)*gc1270, 0}, {I*gc1270, 0}},

C[ -U[4] , U[4] , V[4] ] == {{(-I)*gc1271, 0}, {I*gc1271, 0}},

C[ -U[3] , U[3] , V[1] , V[4] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[3] , U[3] , V[2] , V[4] ] == {{(-I)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ S[2] , -U[3] , U[3] , V[4] ] == {{(-I)*gc1274, 0}, {(-I)*gc1274, 0}, {I*gc1274, 0}},

C[ -U[3] , U[3] , V[4] ] == {{(-I)*gc1275, 0}, {I*gc1275, 0}},

C[ S[6] , -U[2] , U[4] , V[4] ] == {{(-I)*gc1276, 0}, {(-I)*gc1276, 0}, {I*gc1276, 0}},

C[ -S[6] , -U[2] , U[3] , V[4] ] == {{(-I)*gc1277, 0}, {(-I)*gc1277, 0}, {I*gc1277, 0}},

C[ -U[3] , U[1] , V[5] , V[4] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[3] , U[2] , V[5] , V[4] ] == {{(-I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -S[5] , V[5] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1280, 0}, {0, 0}, {(-I)*gc1280, 0}, {I*gc1280, 0}, {I*gc1280, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[5] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1281, 0}, {0, 0}, {(-I)*gc1281, 0}, {I*gc1281, 0}, {I*gc1281, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[5] , V[4] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {I*g2*gc1282*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(-1 + xiBG), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {I*g2*gc1282*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*(-1 + xiBG), 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {(-2*I)*g2*gc1282*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2)*xiBG, 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {(-6*I)*cW*cwbar*gc1282*xiBG, 0}, {(6*I)*cW*cwbar*gc1282*xiBG, 0}, {0, 0}, {0, 0}},

C[ V[5] , -V[6] , V[4] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {I*g2*gc1283*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {I*g2*gc1283*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {(-2*I)*g2*gc1283*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {(-6*I)*cW*cwbar*gc1283, 0}, {(6*I)*cW*cwbar*gc1283, 0}, {0, 0}, {0, 0}},

C[ -U[4] , U[1] , -V[5] , V[4] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[2] , -V[5] , V[4] ] == {{(-I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ S[5] , -V[5] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1286, 0}, {0, 0}, {(-I)*gc1286, 0}, {I*gc1286, 0}, {I*gc1286, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[5] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1287, 0}, {0, 0}, {(-I)*gc1287, 0}, {I*gc1287, 0}, {I*gc1287, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -V[5] , V[6] , V[4] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {I*g2*gc1288*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {I*g2*gc1288*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {(-2*I)*g2*gc1288*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {(-6*I)*cW*cwbar*gc1288, 0}, {(6*I)*cW*cwbar*gc1288, 0}, {0, 0}, {0, 0}},

C[ -U[1] , U[4] , V[6] , V[4] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[3] , U[1] , V[6] , V[4] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[3] , U[2] , V[6] , V[4] ] == {{(-I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -U[2] , U[4] , V[6] , V[4] ] == {{(-I)*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ -S[5] , V[6] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1293, 0}, {0, 0}, {(-I)*gc1293, 0}, {I*gc1293, 0}, {I*gc1293, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -S[6] , V[6] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1294, 0}, {0, 0}, {(-I)*gc1294, 0}, {I*gc1294, 0}, {I*gc1294, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ V[6] , -V[6] , V[4] , V[4] ] == {{0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {0, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {I*g2*gc1295*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {I*g2*gc1295*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {(-2*I)*g2*gc1295*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}, {0, 0}, {0, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {(-6*I)*cW*cwbar*gc1295, 0}, {(6*I)*cW*cwbar*gc1295, 0}, {0, 0}, {0, 0}},

C[ -U[1] , U[3] , -V[6] , V[4] ] == {{(-I/2)*g2^2*(cHWB*cwbar^2*vev^2 + cHWB*swbar^2*vev^2 + 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[1] , -V[6] , V[4] ] == {{(I/2)*g2^2*(cHWB*cwbar^2*vev^2 - cHWB*swbar^2*vev^2 - 2*cwbar*(swbar + 2*cHW*swbar*vev^2)), 0}},

C[ -U[4] , U[2] , -V[6] , V[4] ] == {{(-I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -U[2] , U[3] , -V[6] , V[4] ] == {{(-I)*cwbar^2*g2^2*(1 + 2*cHW*vev^2), 0}},

C[ S[5] , -V[6] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1300, 0}, {0, 0}, {(-I)*gc1300, 0}, {I*gc1300, 0}, {I*gc1300, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ S[6] , -V[6] , V[4] , V[4] ] == {{0, 0}, {(-I)*gc1301, 0}, {0, 0}, {(-I)*gc1301, 0}, {I*gc1301, 0}, {I*gc1301, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -U[4] , U[4] , V[3] , V[4] ] == {{I*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -U[3] , U[3] , V[3] , V[4] ] == {{I*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -U[4] , U[4] , V[4] , V[4] ] == {{(2*I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -U[3] , U[3] , V[4] , V[4] ] == {{(2*I)*cwbar*g2^2*(cwbar + 2*cHW*cwbar*vev^2 + cHWB*swbar*vev^2), 0}},

C[ -F[1] , F[1] , V[1] ] == {{I*gc1306, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[2] , V[1] ] == {{I*gc1307, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , V[1] ] == {{I*gc1308, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[4] , F[4] , V[1] ] == {{I*gc1309, 0}, {0, 0}, {((2*I)*g1*gc1309*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[5] , V[1] ] == {{I*gc1310, 0}, {0, 0}, {((2*I)*g1*gc1310*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , V[1] ] == {{I*gc1311, 0}, {0, 0}, {((2*I)*gc1311*((cHWB*g1 - 2*cHe3x3*g2)*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 - cHe3x3*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1311*vev*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1311*(ceB3x3*cwbar - ceW3x3*swbar)*vev)/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-2*I)*Sqrt[2]*gc1311*vev*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-2*I)*Sqrt[2]*gc1311*(ceB3x3*cwbar - ceW3x3*swbar)*vev)/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[1] , F[1] , V[2] ] == {{I*gc1312, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[2] , V[2] ] == {{I*gc1313, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , V[2] ] == {{I*gc1314, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[4] , F[4] , V[2] ] == {{I*gc1315, 0}, {0, 0}, {((2*I)*g1*gc1315*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[5] , V[2] ] == {{I*gc1316, 0}, {0, 0}, {((2*I)*g1*gc1316*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , V[2] ] == {{I*gc1317, 0}, {0, 0}, {((2*I)*gc1317*((cHWB*g1 - 2*cHe3x3*g2)*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 - cHe3x3*vev^2)))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1317*vev*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1317*(ceB3x3*cwbar - ceW3x3*swbar)*vev)/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-2*I)*Sqrt[2]*gc1317*vev*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-2*I)*Sqrt[2]*gc1317*(ceB3x3*cwbar - ceW3x3*swbar)*vev)/(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 + cwbar*g1*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) - 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[1] ] == {{I*gc1318*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1318*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[1] ] == {{I*gc1319*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*gc1319*((cHWB*g1 + 3*cHu3x3*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + 3*cHu3x3*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1319*vev*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1319*(cuB3x3*cwbar + cuW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1319*vev*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1319*(cuB3x3*cwbar + cuW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[1] ] == {{I*gc1320*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1320*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[1] ] == {{I*gc1321*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*gc1321*((-(cHWB*g1) + 6*cHd3x3*g2)*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 - 3*cHd3x3*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1321*vev*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1321*(cdB3x3*cwbar - cdW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1321*vev*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1321*(cdB3x3*cwbar - cdW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[1] ] == {{I*gc1322*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*g1*gc1322*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[1] ] == {{I*gc1323*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*g1*gc1323*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[2] ] == {{I*gc1324*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1324*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[2] ] == {{I*gc1325*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*gc1325*((cHWB*g1 + 3*cHu3x3*g2)*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + 3*cHu3x3*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1325*vev*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1325*(cuB3x3*cwbar + cuW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1325*vev*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1325*(cuB3x3*cwbar + cuW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*g2*swbar*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[2] ] == {{I*gc1326*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1326*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[2] ] == {{I*gc1327*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*gc1327*((-(cHWB*g1) + 6*cHd3x3*g2)*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 - 3*cHd3x3*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1327*vev*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1327*(cdB3x3*cwbar - cdW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1327*vev*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1327*(cdB3x3*cwbar - cdW3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[2] ] == {{I*gc1328*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*g1*gc1328*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[2] ] == {{I*gc1329*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((2*I)*g1*gc1329*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1330*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1330*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1331*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1331*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(I*gc1331*vev*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {(I*cuG3x3*gc1331*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*gc1331*vev*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*cuG3x3*gc1331*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1332*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1332*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1333*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1333*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(I*gc1333*vev*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {(I*cdG3x3*gc1333*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*gc1333*vev*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*cdG3x3*gc1333*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1334*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1334*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[7, {e3x2}] ] == {{I*gc1335*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1335*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1336*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1336*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1337*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1337*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(I*gc1337*vev*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {(I*cuG3x3*gc1337*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*gc1337*vev*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*cuG3x3*gc1337*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1338*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1338*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1339*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1339*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(I*gc1339*vev*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {(I*cdG3x3*gc1339*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*gc1339*vev*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}, {((-I)*cdG3x3*gc1339*vev*SUNT[e3x2, e1x2, e2x2])/(Sqrt[2]*(g3 + cHG*g3*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1340*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1340*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[8, {e3x2}] ] == {{I*gc1341*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1341*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , V[5] ] == {{I*gc1342*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[10, {e2x2}] , V[5] ] == {{I*gc1343*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[11, {e2x2}] , V[5] ] == {{I*gc1344*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[5] ] == {{I*gc1345*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I/2)*cHud3x3*gc1345*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2), 0}, {0, 0}, {(I*Sqrt[2]*gc1345*vev*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {(I*Sqrt[2]*cdW3x3*gc1345*vev*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {((-I)*Sqrt[2]*gc1345*vev*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {((-I)*Sqrt[2]*cdW3x3*gc1345*vev*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[10, {e2x2}] , V[5] ] == {{I*gc1346*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[11, {e2x2}] , V[5] ] == {{I*gc1347*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , V[5] ] == {{I*gc1348*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[10, {e2x2}] , V[5] ] == {{I*gc1349*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[11, {e2x2}] , V[5] ] == {{I*gc1350*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[12, {e2x2}] , V[6] ] == {{I*gc1351*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[10, {e2x2}] , V[6] ] == {{I*gc1352*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[11, {e2x2}] , V[6] ] == {{I*gc1353*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[6] ] == {{I*gc1354*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I/2)*cHud3x3*gc1354*vev^2*IndexDelta[e1x2, e2x2])/(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2), 0}, {0, 0}, {(I*Sqrt[2]*gc1354*vev*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {(I*Sqrt[2]*cdW3x3*gc1354*vev*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {((-I)*Sqrt[2]*gc1354*vev*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}, {((-I)*Sqrt[2]*cdW3x3*gc1354*vev*IndexDelta[e1x2, e2x2])/(g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2)), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[10, {e2x2}] , V[6] ] == {{I*gc1355*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[11, {e2x2}] , V[6] ] == {{I*gc1356*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[12, {e2x2}] , V[6] ] == {{I*gc1357*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[10, {e2x2}] , V[6] ] == {{I*gc1358*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[11, {e2x2}] , V[6] ] == {{I*gc1359*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -V[5] ] == {{I*gc1360*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[5] ] == {{I*gc1361*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I/2)*gc1361*vev^2*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2])/(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3]), 0}, {0, 0}, {(I*Sqrt[2]*gc1361*vev*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {(I*Sqrt[2]*cuW3x3*gc1361*vev*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {((-I)*Sqrt[2]*gc1361*vev*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {((-I)*Sqrt[2]*cuW3x3*gc1361*vev*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -V[5] ] == {{I*gc1362*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[8, {e2x2}] , -V[5] ] == {{I*gc1363*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[9, {e2x2}] , -V[5] ] == {{I*gc1364*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[7, {e2x2}] , -V[5] ] == {{I*gc1365*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[8, {e2x2}] , -V[5] ] == {{I*gc1366*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[9, {e2x2}] , -V[5] ] == {{I*gc1367*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[7, {e2x2}] , -V[5] ] == {{I*gc1368*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[8, {e2x2}] , -V[6] ] == {{I*gc1369*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[6] ] == {{I*gc1370*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-I/2)*gc1370*vev^2*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2])/(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3]), 0}, {0, 0}, {(I*Sqrt[2]*gc1370*vev*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {(I*Sqrt[2]*cuW3x3*gc1370*vev*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {((-I)*Sqrt[2]*gc1370*vev*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}, {((-I)*Sqrt[2]*cuW3x3*gc1370*vev*IndexDelta[e1x2, e2x2])/(g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3])), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[7, {e2x2}] , -V[6] ] == {{I*gc1371*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[8, {e2x2}] , -V[6] ] == {{I*gc1372*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[9, {e2x2}] , -V[6] ] == {{I*gc1373*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[7, {e2x2}] , -V[6] ] == {{I*gc1374*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[8, {e2x2}] , -V[6] ] == {{I*gc1375*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[9, {e2x2}] , -V[6] ] == {{I*gc1376*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[7, {e2x2}] , -V[6] ] == {{I*gc1377*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[1] , F[4] , V[5] ] == {{I*gc1378, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[5] , V[5] ] == {{I*gc1379, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , V[5] ] == {{I*gc1380, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(I*Sqrt[2]*ceW3x3*gc1380*vev)/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}, {((-I)*Sqrt[2]*ceW3x3*gc1380*vev)/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}},

C[ -F[1] , F[4] , V[6] ] == {{I*gc1381, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[5] , V[6] ] == {{I*gc1382, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , V[6] ] == {{I*gc1383, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(I*Sqrt[2]*ceW3x3*gc1383*vev)/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}, {((-I)*Sqrt[2]*ceW3x3*gc1383*vev)/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}},

C[ -F[4] , F[1] , -V[5] ] == {{I*gc1384, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[2] , -V[5] ] == {{I*gc1385, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[5] ] == {{I*gc1386, 0}, {0, 0}, {0, 0}, {0, 0}, {(I*Sqrt[2]*gc1386*vev*Conjugate[ceW3x3])/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}, {((-I)*Sqrt[2]*gc1386*vev*Conjugate[ceW3x3])/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[4] , F[1] , -V[6] ] == {{I*gc1387, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[2] , -V[6] ] == {{I*gc1388, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[6] ] == {{I*gc1389, 0}, {0, 0}, {0, 0}, {0, 0}, {(I*Sqrt[2]*gc1389*vev*Conjugate[ceW3x3])/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}, {((-I)*Sqrt[2]*gc1389*vev*Conjugate[ceW3x3])/(g2 + cHl33x3*g2*vev^2 + cHW*g2*vev^2), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[3] ] == {{I*gc1390*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1390*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[3] ] == {{I*gc1391*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*gc1391*(cHWB*cwbar*g1*vev^2 + 3*cHu3x3*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + 3*cHu3x3*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1391*vev*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1391*(cuW3x3*cwbar - cuB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1391*vev*(-(swbar*Conjugate[cuB3x3]) + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1391*(cuW3x3*cwbar - cuB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[3] ] == {{I*gc1392*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1392*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[8, {e1x2}] , F[8, {e2x2}] , V[4] ] == {{I*gc1393*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1393*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[4] ] == {{I*gc1394*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*gc1394*(cHWB*cwbar*g1*vev^2 + 3*cHu3x3*cwbar*g2*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + 3*cHu3x3*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1394*vev*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1394*(cuW3x3*cwbar - cuB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1394*vev*(-(swbar*Conjugate[cuB3x3]) + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1394*(cuW3x3*cwbar - cuB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2)), 0}, {0, 0}},

C[ -F[7, {e1x2}] , F[7, {e2x2}] , V[4] ] == {{I*gc1395*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((4*I)*g1*gc1395*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[3] ] == {{I*gc1396*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*gc1396*(cHWB*cwbar*g1*vev^2 - 6*cHd3x3*cwbar*g2*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - 3*cHd3x3*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1396*vev*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1396*(cdW3x3*cwbar + cdB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1396*vev*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1396*(cdW3x3*cwbar + cdB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[3] ] == {{I*gc1397*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*g1*gc1397*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[3] ] == {{I*gc1398*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*g1*gc1398*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[4] ] == {{I*gc1399*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*gc1399*(cHWB*cwbar*g1*vev^2 - 6*cHd3x3*cwbar*g2*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - 3*cHd3x3*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1399*vev*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((6*I)*Sqrt[2]*gc1399*(cdW3x3*cwbar + cdB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1399*vev*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((-6*I)*Sqrt[2]*gc1399*(cdW3x3*cwbar + cdB3x3*swbar)*vev*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[10, {e1x2}] , F[10, {e2x2}] , V[4] ] == {{I*gc1400*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*g1*gc1400*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[11, {e1x2}] , F[11, {e2x2}] , V[4] ] == {{I*gc1401*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {((-2*I)*g1*gc1401*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2))*IndexDelta[e1x2, e2x2])/(cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[1] , F[1] , V[3] ] == {{I*gc1402, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[2] , V[3] ] == {{I*gc1403, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , V[3] ] == {{I*gc1404, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[1] , F[1] , V[4] ] == {{I*gc1405, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[2] , F[2] , V[4] ] == {{I*gc1406, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , V[4] ] == {{I*gc1407, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[4] , F[4] , V[3] ] == {{I*gc1408, 0}, {0, 0}, {((2*I)*g1*gc1408*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[5] , V[3] ] == {{I*gc1409, 0}, {0, 0}, {((2*I)*g1*gc1409*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , V[3] ] == {{I*gc1410, 0}, {0, 0}, {((2*I)*gc1410*(cHWB*cwbar*g1*vev^2 - 2*cHe3x3*cwbar*g2*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHe3x3*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1410*vev*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]))/(-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 + g1*swbar*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1410*(ceW3x3*cwbar + ceB3x3*swbar)*vev)/(-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 + g1*swbar*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1410*vev*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1410*(ceW3x3*cwbar + ceB3x3*swbar)*vev)/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[4] , F[4] , V[4] ] == {{I*gc1411, 0}, {0, 0}, {((2*I)*g1*gc1411*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[5] , F[5] , V[4] ] == {{I*gc1412, 0}, {0, 0}, {((2*I)*g1*gc1412*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHB*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2)), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , V[4] ] == {{I*gc1413, 0}, {0, 0}, {((2*I)*gc1413*(cHWB*cwbar*g1*vev^2 - 2*cHe3x3*cwbar*g2*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHe3x3*vev^2)))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1413*vev*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]))/(-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 + g1*swbar*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1413*(ceW3x3*cwbar + ceB3x3*swbar)*vev)/(-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 + g1*swbar*(-2 - 2*cHB*vev^2 + 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1413*vev*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]))/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}, {((2*I)*Sqrt[2]*gc1413*(ceW3x3*cwbar + ceB3x3*swbar)*vev)/(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) - 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2)), 0}, {0, 0}},

C[ -F[3] , F[3] , S[1] , V[1] ] == {{I*gc1414, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[2] , V[1] ] == {{I*gc1415, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[1] , V[2] ] == {{I*gc1416, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[2] , V[2] ] == {{I*gc1417, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[3] , S[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(cHl13x3 - cHl33x3)*gc1418, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*gc1418, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[3] , S[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(cHl13x3 - cHl33x3)*gc1419, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*gc1419, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*vev, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[4] , S[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(cHl13x3 - cHl33x3)*gc1421, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*gc1421, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[4] , S[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(cHl13x3 - cHl33x3)*gc1422, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*gc1422, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-cHl13x3 + cHl33x3)*vev, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[5] , -S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1424, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1424, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[5] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1425, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1425, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , -S[5] , S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1426, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1426, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[6] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1427, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1427, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , -S[5] , V[5] ] == {{I*gc1428, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , -S[6] , V[5] ] == {{I*gc1429, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[5] , -V[5] ] == {{I*gc1430, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[6] , -V[5] ] == {{I*gc1431, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , -S[5] , V[6] ] == {{I*gc1432, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , -S[6] , V[6] ] == {{I*gc1433, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[5] , -V[6] ] == {{I*gc1434, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[6] , -V[6] ] == {{I*gc1435, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[1] , V[3] ] == {{I*gc1436, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[2] , V[3] ] == {{I*gc1437, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[1] , V[4] ] == {{I*gc1438, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[3] , S[2] , V[4] ] == {{I*gc1439, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , V[1] ] == {{I*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1440*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc1440*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {I*gc1440*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1440*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {(-I)*gc1440*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1440*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] , V[1] ] == {{I*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1441*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc1441*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {I*gc1441*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1441*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {(-I)*gc1441*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1441*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , V[2] ] == {{I*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1442*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc1442*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {I*gc1442*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1442*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {(-I)*gc1442*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1442*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] , V[2] ] == {{I*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1443*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {(2*I)*Sqrt[2]*cHe3x3*gc1443*(cwbar*g1 - g2*swbar)*vev, 0}, {0, 0}, {I*gc1443*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1443*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {(-I)*gc1443*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1443*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , -S[5] , V[5] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , -S[6] , V[5] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[5] , -V[5] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*ceW3x3, 0}, {0, 0}},

C[ -F[6] , F[6] , S[6] , -V[5] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*ceW3x3, 0}, {0, 0}},

C[ -F[6] , F[6] , -S[5] , V[6] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , -S[6] , V[6] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[6] , S[5] , -V[6] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*ceW3x3, 0}, {0, 0}},

C[ -F[6] , F[6] , S[6] , -V[6] ] == {{(-I)*cHl13x3*g2*vev, 0}, {0, 0}, {(-2*I)*cHe3x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*ceW3x3, 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , V[3] ] == {{(-I)*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1452*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc1452*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-I)*gc1452*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1452*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}, {I*gc1452*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1452*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] , V[3] ] == {{(-I)*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1453*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc1453*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-I)*gc1453*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1453*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}, {I*gc1453*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1453*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[1] , V[4] ] == {{(-I)*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1454*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc1454*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-I)*gc1454*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1454*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}, {I*gc1454*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1454*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[2] , V[4] ] == {{(-I)*Sqrt[2]*(cHl13x3 + cHl33x3)*gc1455*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHe3x3*gc1455*(cwbar*g2 + g1*swbar)*vev, 0}, {0, 0}, {(-I)*gc1455*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {(-I)*gc1455*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}, {I*gc1455*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {I*gc1455*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[1] ] == {{(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1456*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc1456*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1456*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1456*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1456*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1456*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[1] ] == {{(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1457*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc1457*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1457*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1457*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1457*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1457*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[2] ] == {{(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1458*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc1458*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1458*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1458*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1458*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1458*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[2] ] == {{(-I)*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1459*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHu3x3*gc1459*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1459*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1459*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1459*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1459*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -S[5] , V[5] ] == {{I*cHq13x3*g2*gc1460*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1460*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1460*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1460*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -S[6] , V[5] ] == {{I*cHq13x3*g2*gc1461*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1461*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1461*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1461*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[5] , -V[5] ] == {{I*cHq13x3*g2*gc1462*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1462*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1462*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*gc1462*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[6] , -V[5] ] == {{I*cHq13x3*g2*gc1463*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1463*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1463*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*gc1463*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -S[5] , V[6] ] == {{I*cHq13x3*g2*gc1464*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1464*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1464*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1464*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -S[6] , V[6] ] == {{I*cHq13x3*g2*gc1465*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1465*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1465*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1465*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[5] , -V[6] ] == {{I*cHq13x3*g2*gc1466*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1466*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1466*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*gc1466*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[6] , -V[6] ] == {{I*cHq13x3*g2*gc1467*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*cHu3x3*g2*gc1467*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1467*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*gc1467*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[3] ] == {{I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1468*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc1468*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1468*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1468*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1468*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1468*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[3] ] == {{I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1469*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc1469*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1469*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1469*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1469*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1469*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[4] ] == {{I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1470*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc1470*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1470*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1470*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1470*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1470*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[4] ] == {{I*Sqrt[2]*(cHq13x3 - cHq33x3)*gc1471*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHu3x3*gc1471*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1471*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1471*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1471*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1471*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[1] ] == {{I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1472*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc1472*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1472*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1472*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1472*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1472*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[1] ] == {{I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1473*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc1473*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1473*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1473*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1473*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1473*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[2] ] == {{I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1474*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc1474*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1474*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1474*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1474*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1474*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[2] ] == {{I*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1475*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(2*I)*Sqrt[2]*cHd3x3*gc1475*(cwbar*g1 - g2*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1475*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1475*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1475*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1475*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -S[5] , V[5] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -S[6] , V[5] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[5] , -V[5] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[6] , -V[5] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -S[5] , V[6] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -S[6] , V[6] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[5] , -V[6] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[6] , -V[6] ] == {{(-I)*cHq13x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*cHd3x3*g2*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[3] ] == {{(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1484*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc1484*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1484*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1484*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1484*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1484*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[3] ] == {{(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1485*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc1485*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1485*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1485*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1485*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1485*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[4] ] == {{(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1486*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc1486*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1486*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1486*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1486*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1486*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[4] ] == {{(-I)*Sqrt[2]*(cHq13x3 + cHq33x3)*gc1487*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-2*I)*Sqrt[2]*cHd3x3*gc1487*(cwbar*g2 + g1*swbar)*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1487*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1487*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1487*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1487*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , V[1] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , V[1] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , V[2] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , V[2] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(cwbar*Conjugate[ceB3x3] + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[3] , -S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1492, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1492, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[3] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1493, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1493, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[4] , -S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1494, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1494, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[4] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1495, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1495, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[1] , -V[5] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[2] , -V[5] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[1] , -V[6] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[2] , -V[6] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[ceW3x3], 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , V[3] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(swbar*Conjugate[ceB3x3] - cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(swbar*Conjugate[ceB3x3]) + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , V[3] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(swbar*Conjugate[ceB3x3] - cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(swbar*Conjugate[ceB3x3]) + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[5] , V[4] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(swbar*Conjugate[ceB3x3] - cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(swbar*Conjugate[ceB3x3]) + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -S[6] , V[4] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(swbar*Conjugate[ceB3x3] - cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(swbar*Conjugate[ceB3x3]) + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , V[1] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , V[1] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , V[2] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , V[2] ] == {{(-I)*Sqrt[2]*cHl33x3*cwbar*g1*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceB3x3*cwbar + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[3] , S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1508, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1508, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[3] , S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1509, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1509, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[4] , S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1510, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1510, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[4] , S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1511, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1511, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[3] , F[6] , S[1] , V[5] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*ceW3x3, 0}, {0, 0}},

C[ -F[3] , F[6] , S[2] , V[5] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*ceW3x3, 0}, {0, 0}},

C[ -F[3] , F[6] , S[1] , V[6] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*ceW3x3, 0}, {0, 0}},

C[ -F[3] , F[6] , S[2] , V[6] ] == {{(-I)*Sqrt[2]*cHl33x3*g2*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*ceW3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {I*ceW3x3, 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , V[3] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(ceW3x3*cwbar) + ceB3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceW3x3*cwbar - ceB3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , V[3] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(ceW3x3*cwbar) + ceB3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceW3x3*cwbar - ceB3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[5] , V[4] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(ceW3x3*cwbar) + ceB3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceW3x3*cwbar - ceB3x3*swbar), 0}, {0, 0}},

C[ -F[3] , F[6] , S[6] , V[4] ] == {{I*Sqrt[2]*cHl33x3*g1*swbar*vev, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(-(ceW3x3*cwbar) + ceB3x3*swbar), 0}, {0, 0}, {0, 0}, {0, 0}, {I*(ceW3x3*cwbar - ceB3x3*swbar), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[1] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1520*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1520*swbar*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1520*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1520*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1520*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1520*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[1] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1521*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1521*swbar*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1521*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1521*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1521*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1521*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[2] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1522*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1522*swbar*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1522*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1522*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1522*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1522*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[2] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1523*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1523*swbar*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1523*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1523*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1523*(cwbar*Conjugate[cdB3x3] + swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1523*(cuB3x3*cwbar - cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[3] , -S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1524*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1524*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1524*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1524*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[3] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1525*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1525*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1525*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1525*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[4] , -S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1526*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1526*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1526*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1526*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[4] , -S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1527*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1527*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1527*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1527*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[1] , -V[5] ] == {{(-2*I)*cHq33x3*g2*gc1528*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1528*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1528*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1528*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1528*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1528*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[2] , -V[5] ] == {{(-2*I)*cHq33x3*g2*gc1529*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1529*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1529*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1529*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1529*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1529*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[1] , -V[6] ] == {{(-2*I)*cHq33x3*g2*gc1530*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1530*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1530*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1530*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1530*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1530*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[2] , -V[6] ] == {{(-2*I)*cHq33x3*g2*gc1531*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*g2*gc1531*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1531*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cuW3x3*gc1531*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1531*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cuW3x3*gc1531*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[3] ] == {{(2*I)*cHq33x3*g1*gc1532*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cwbar*g2*gc1532*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1532*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1532*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1532*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1532*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[3] ] == {{(2*I)*cHq33x3*g1*gc1533*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cwbar*g2*gc1533*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1533*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1533*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1533*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1533*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[4] ] == {{(2*I)*cHq33x3*g1*gc1534*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cwbar*g2*gc1534*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1534*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1534*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1534*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1534*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[4] ] == {{(2*I)*cHq33x3*g1*gc1535*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cwbar*g2*gc1535*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1535*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1535*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1535*(swbar*Conjugate[cdB3x3] - cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1535*(cuW3x3*cwbar + cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[1] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1536*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1536*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1536*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1536*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1536*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1536*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[1] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1537*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1537*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1537*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1537*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1537*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1537*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[2] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1538*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1538*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1538*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1538*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1538*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1538*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[2] ] == {{(-2*I)*cHq33x3*cwbar*g1*gc1539*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1539*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1539*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1539*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1539*(cwbar*Conjugate[cuB3x3] - swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1539*(cdB3x3*cwbar + cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[3] , S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1540*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cHud3x3*gc1540*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1540*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {cHud3x3*gc1540*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[3] , S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1541*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cHud3x3*gc1541*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1541*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {cHud3x3*gc1541*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[4] , S[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1542*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cHud3x3*gc1542*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1542*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {cHud3x3*gc1542*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[4] , S[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-2*cHq33x3*gc1543*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(cHud3x3*gc1543*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {2*cHq33x3*gc1543*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {cHud3x3*gc1543*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[1] , V[5] ] == {{(-2*I)*cHq33x3*g2*gc1544*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1544*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1544*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*gc1544*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1544*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*gc1544*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[2] , V[5] ] == {{(-2*I)*cHq33x3*g2*gc1545*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1545*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1545*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*gc1545*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1545*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*gc1545*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[1] , V[6] ] == {{(-2*I)*cHq33x3*g2*gc1546*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1546*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1546*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*gc1546*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1546*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*gc1546*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[2] , V[6] ] == {{(-2*I)*cHq33x3*g2*gc1547*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*g2*gc1547*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1547*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*cdW3x3*gc1547*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1547*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*cdW3x3*gc1547*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[3] ] == {{(2*I)*cHq33x3*g1*gc1548*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*cwbar*g2*gc1548*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1548*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1548*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1548*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1548*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[3] ] == {{(2*I)*cHq33x3*g1*gc1549*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*cwbar*g2*gc1549*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1549*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1549*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1549*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1549*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[4] ] == {{(2*I)*cHq33x3*g1*gc1550*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*cwbar*g2*gc1550*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1550*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1550*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1550*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1550*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[4] ] == {{(2*I)*cHq33x3*g1*gc1551*swbar*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cHud3x3*cwbar*g2*gc1551*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1551*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*Sqrt[2]*gc1551*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1551*(swbar*Conjugate[cuB3x3] + cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*Sqrt[2]*gc1551*(cdW3x3*cwbar - cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[3] , -F[3] , F[3] , F[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1552, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1552, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , -F[9, {e3x2}] , F[9, {e2x2}] , F[9, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*(cqq13x3x3x3 + cqq33x3x3x3)*gc1553*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*(cqq13x3x3x3 + cqq33x3x3x3)*gc1553*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1553*(3*cqu83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqu13x3x3x3 - cqu83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1553*((6*cqu13x3x3x3 - cqu83x3x3x3)*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + 3*cqu83x3x3x3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1553*((6*cqu13x3x3x3 - cqu83x3x3x3)*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + 3*cqu83x3x3x3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {I*gc1553*(3*cqu83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqu13x3x3x3 - cqu83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*cuu3x3x3x3*gc1553*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*cuu3x3x3x3*gc1553*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , -F[3] , F[9, {e2x2}] , F[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(clq13x3x3x3 + clq33x3x3x3)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*clu3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , -F[3] , F[6] , F[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cll3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cle3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , -F[3] , F[12, {e2x2}] , F[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*(clq13x3x3x3 - clq33x3x3x3)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cld3x3x3x3*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , -F[6] , F[6] , F[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cll3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cll3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cle3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cle3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*cle3x3x3x3, 0}, {0, 0}, {I*cle3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cee3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(2*I)*cee3x3x3x3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , -F[12, {e3x2}] , F[12, {e2x2}] , F[12, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*(cqq13x3x3x3 + cqq33x3x3x3)*gc1558*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*(cqq13x3x3x3 + cqq33x3x3x3)*gc1558*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1558*(3*cqd83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqd13x3x3x3 - cqd83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1558*((6*cqd13x3x3x3 - cqd83x3x3x3)*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + 3*cqd83x3x3x3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1558*((6*cqd13x3x3x3 - cqd83x3x3x3)*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + 3*cqd83x3x3x3*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {I*gc1558*(3*cqd83x3x3x3*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2] + (6*cqd13x3x3x3 - cqd83x3x3x3)*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2]), 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*cdd3x3x3x3*gc1558*IndexDelta[e1x2, e4x2]*IndexDelta[e2x2, e3x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {(12*I)*cdd3x3x3x3*gc1558*IndexDelta[e1x2, e2x2]*IndexDelta[e3x2, e4x2], 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[3] , -V[5] ] == {{0, 0}, {0, 0}, {g2*gc1559*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1559*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cuW3x3*gc1559*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1559*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cuW3x3*gc1559*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[4] , -V[5] ] == {{0, 0}, {0, 0}, {g2*gc1560*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1560*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cuW3x3*gc1560*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1560*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cuW3x3*gc1560*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[3] , -V[6] ] == {{0, 0}, {0, 0}, {g2*gc1561*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1561*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cuW3x3*gc1561*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1561*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cuW3x3*gc1561*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , S[4] , -V[6] ] == {{0, 0}, {0, 0}, {g2*gc1562*vev*Conjugate[cHud3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1562*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cuW3x3*gc1562*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1562*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cuW3x3*gc1562*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[3] , V[5] ] == {{0, 0}, {0, 0}, {cHud3x3*g2*gc1563*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1563*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cdW3x3*gc1563*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1563*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cdW3x3*gc1563*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[4] , V[5] ] == {{0, 0}, {0, 0}, {cHud3x3*g2*gc1564*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1564*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cdW3x3*gc1564*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1564*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cdW3x3*gc1564*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[3] , V[6] ] == {{0, 0}, {0, 0}, {cHud3x3*g2*gc1565*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1565*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cdW3x3*gc1565*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1565*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cdW3x3*gc1565*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[4] , V[6] ] == {{0, 0}, {0, 0}, {cHud3x3*g2*gc1566*vev*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(Sqrt[2]*gc1566*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(Sqrt[2]*cdW3x3*gc1566*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {Sqrt[2]*gc1566*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {Sqrt[2]*cdW3x3*gc1566*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1567*(-(cwbar*Conjugate[ceB3x3]) + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1567*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {gc1567*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1567*(-(ceB3x3*cwbar) + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1568*(-(cwbar*Conjugate[ceB3x3]) + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1568*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {gc1568*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1568*(-(ceB3x3*cwbar) + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1569*(-(cwbar*Conjugate[ceB3x3]) + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1569*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {gc1569*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1569*(-(ceB3x3*cwbar) + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1570*(-(cwbar*Conjugate[ceB3x3]) + swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1570*(ceB3x3*cwbar - ceW3x3*swbar), 0}, {0, 0}, {gc1570*(cwbar*Conjugate[ceB3x3] - swbar*Conjugate[ceW3x3]), 0}, {0, 0}, {gc1570*(-(ceB3x3*cwbar) + ceW3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1571*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {-(gc1571*(ceW3x3*cwbar + ceB3x3*swbar)), 0}, {0, 0}, {-(gc1571*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3])), 0}, {0, 0}, {gc1571*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1572*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {-(gc1572*(ceW3x3*cwbar + ceB3x3*swbar)), 0}, {0, 0}, {-(gc1572*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3])), 0}, {0, 0}, {gc1572*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[3] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1573*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {-(gc1573*(ceW3x3*cwbar + ceB3x3*swbar)), 0}, {0, 0}, {-(gc1573*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3])), 0}, {0, 0}, {gc1573*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[6] , F[6] , S[4] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1574*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3]), 0}, {0, 0}, {-(gc1574*(ceW3x3*cwbar + ceB3x3*swbar)), 0}, {0, 0}, {-(gc1574*(swbar*Conjugate[ceB3x3] + cwbar*Conjugate[ceW3x3])), 0}, {0, 0}, {gc1574*(ceW3x3*cwbar + ceB3x3*swbar), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1575*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1575*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1575*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1575*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1576*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1576*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1576*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1576*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1577*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1577*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1577*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1577*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1578*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1578*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1578*(cwbar*Conjugate[cuB3x3] + swbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1578*(cuB3x3*cwbar + cuW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1579*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1579*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1579*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1579*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1580*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1580*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1580*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1580*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1581*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1581*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1581*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1581*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1582*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1582*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1582*(swbar*Conjugate[cuB3x3] - cwbar*Conjugate[cuW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1582*(cuW3x3*cwbar - cuB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-(gc1583*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1583*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1583*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1583*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[1] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-(gc1584*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1584*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1584*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1584*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-(gc1585*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1585*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1585*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1585*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[2] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-(gc1586*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1586*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {gc1586*(cwbar*Conjugate[cdB3x3] - swbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1586*(cdB3x3*cwbar - cdW3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1587*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1587*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1587*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1587*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[3] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1588*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1588*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1588*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1588*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1589*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1589*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1589*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1589*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[4] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1590*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {-(gc1590*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {-(gc1590*(swbar*Conjugate[cdB3x3] + cwbar*Conjugate[cdW3x3])*IndexDelta[e1x2, e2x2]), 0}, {0, 0}, {gc1590*(cdW3x3*cwbar + cdB3x3*swbar)*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1591*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {-(cuG3x3*gc1591*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1591*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {cuG3x3*gc1591*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1592*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {-(cuG3x3*gc1592*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1592*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {cuG3x3*gc1592*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1593*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1593*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1593*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1593*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1594*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1594*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1594*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1594*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[3] , V[8, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1595*Conjugate[cuG3x3]*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}, {-(cuG3x3*gc1595*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1595*Conjugate[cuG3x3]*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {cuG3x3*gc1595*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[4] , V[8, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1596*Conjugate[cuG3x3]*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}, {-(cuG3x3*gc1596*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1596*Conjugate[cuG3x3]*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {cuG3x3*gc1596*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[1] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1597*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1597*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1597*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1597*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , S[2] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1598*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1598*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1598*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1598*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[7, {e3x2}] , V[7, {e4x2}] ] == {{I*gc1599*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cuG3x3*gc1599*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1599*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cuG3x3*gc1599*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[7, {e3x2}] , V[8, {e4x2}] ] == {{I*gc1600*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cuG3x3*gc1600*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1600*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cuG3x3*gc1600*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{I*gc1601*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cuG3x3*gc1601*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1601*Conjugate[cuG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cuG3x3*gc1601*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[5] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , S[6] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*Conjugate[cuG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1606*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1606*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1606*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1606*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1607*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1607*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1607*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1607*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[5] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1608*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1608*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1608*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1608*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -S[6] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1609*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cuG3x3*gc1609*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*gc1609*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cuG3x3*gc1609*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1610*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {-(cdG3x3*gc1610*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1610*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {cdG3x3*gc1610*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1611*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {-(cdG3x3*gc1611*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1611*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2]), 0}, {0, 0}, {cdG3x3*gc1611*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1612*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*gc1612*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1612*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*gc1612*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[7, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1613*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*gc1613*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1613*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*gc1613*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[3] , V[8, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1614*Conjugate[cdG3x3]*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}, {-(cdG3x3*gc1614*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1614*Conjugate[cdG3x3]*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {cdG3x3*gc1614*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[4] , V[8, {e4x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1615*Conjugate[cdG3x3]*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}, {-(cdG3x3*gc1615*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {-(gc1615*Conjugate[cdG3x3]*SUNT[e4x2, e1x2, e2x2]), 0}, {0, 0}, {cdG3x3*gc1615*SUNT[e4x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[1] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1616*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*gc1616*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1616*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*gc1616*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , S[2] , V[8, {e3x2}] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {(-I)*gc1617*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {(-I)*cdG3x3*gc1617*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*gc1617*Conjugate[cdG3x3]*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}, {I*cdG3x3*gc1617*SUNT[e3x2, e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[7, {e3x2}] , V[7, {e4x2}] ] == {{I*gc1618*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cdG3x3*gc1618*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1618*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cdG3x3*gc1618*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[7, {e3x2}] , V[8, {e4x2}] ] == {{I*gc1619*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cdG3x3*gc1619*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1619*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cdG3x3*gc1619*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[8, {e3x2}] , V[8, {e4x2}] ] == {{I*gc1620*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {I*cdG3x3*gc1620*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*gc1620*Conjugate[cdG3x3]*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}, {(-I)*cdG3x3*gc1620*(SUNT[e3x2, e4x2, e1x2, e2x2] - SUNT[e4x2, e3x2, e1x2, e2x2]), 0}, {0, 0}},

C[ -F[6] , F[6] , V[5] , -V[5] ] == {{(-I)*gc1621*Conjugate[ceW3x3], 0}, {0, 0}, {(-I)*ceW3x3*gc1621, 0}, {0, 0}, {I*gc1621*Conjugate[ceW3x3], 0}, {0, 0}, {I*ceW3x3*gc1621, 0}, {0, 0}},

C[ -F[6] , F[6] , -V[5] , V[6] ] == {{(-I)*gc1622*Conjugate[ceW3x3], 0}, {0, 0}, {(-I)*ceW3x3*gc1622, 0}, {0, 0}, {I*gc1622*Conjugate[ceW3x3], 0}, {0, 0}, {I*ceW3x3*gc1622, 0}, {0, 0}},

C[ -F[6] , F[6] , V[5] , -V[6] ] == {{(-I)*gc1623*Conjugate[ceW3x3], 0}, {0, 0}, {(-I)*ceW3x3*gc1623, 0}, {0, 0}, {I*gc1623*Conjugate[ceW3x3], 0}, {0, 0}, {I*ceW3x3*gc1623, 0}, {0, 0}},

C[ -F[6] , F[6] , V[6] , -V[6] ] == {{(-I)*gc1624*Conjugate[ceW3x3], 0}, {0, 0}, {(-I)*ceW3x3*gc1624, 0}, {0, 0}, {I*gc1624*Conjugate[ceW3x3], 0}, {0, 0}, {I*ceW3x3*gc1624, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[5] , -V[5] ] == {{(-I)*gc1625*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1625*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1625*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1625*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , -V[5] , V[6] ] == {{(-I)*gc1626*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1626*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1626*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1626*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[5] , -V[6] ] == {{(-I)*gc1627*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1627*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1627*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1627*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[9, {e2x2}] , V[6] , -V[6] ] == {{(-I)*gc1628*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1628*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1628*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1628*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[5] , -V[5] ] == {{(-I)*gc1629*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1629*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1629*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1629*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , -V[5] , V[6] ] == {{(-I)*gc1630*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1630*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1630*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1630*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[5] , -V[6] ] == {{(-I)*gc1631*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1631*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1631*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1631*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[12, {e2x2}] , V[6] , -V[6] ] == {{(-I)*gc1632*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1632*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1632*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1632*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[6] , F[3] , S[3] , -V[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1633, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1633, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[4] , -V[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1634, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1634, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[3] , -V[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1635, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1635, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , S[4] , -V[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1636, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1636, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , V[1] , -V[5] ] == {{(-I)*gc1637, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1637, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , V[2] , -V[5] ] == {{(-I)*gc1638, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1638, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , V[1] , -V[6] ] == {{(-I)*gc1639, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1639, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , V[2] , -V[6] ] == {{(-I)*gc1640, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1640, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[5] , V[3] ] == {{(-I)*gc1641, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1641, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[6] , V[3] ] == {{(-I)*gc1642, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1642, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[5] , V[4] ] == {{(-I)*gc1643, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1643, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[6] , F[3] , -V[6] , V[4] ] == {{(-I)*gc1644, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1644, 0}, {0, 0}, {0, 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[1] , V[5] ] == {{(-I)*gc1645*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1645*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1645*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1645*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[2] , V[5] ] == {{(-I)*gc1646*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1646*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1646*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1646*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[1] , V[6] ] == {{(-I)*gc1647*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1647*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1647*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1647*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[2] , V[6] ] == {{(-I)*gc1648*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1648*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1648*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1648*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[5] , V[3] ] == {{(-I)*gc1649*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1649*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1649*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1649*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[6] , V[3] ] == {{(-I)*gc1650*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1650*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1650*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1650*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[5] , V[4] ] == {{(-I)*gc1651*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1651*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1651*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1651*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[9, {e1x2}] , F[12, {e2x2}] , V[6] , V[4] ] == {{(-I)*gc1652*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cdW3x3*gc1652*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1652*Conjugate[cuW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cdW3x3*gc1652*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , V[1] , -V[5] ] == {{(-I)*gc1653*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1653*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1653*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1653*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , V[2] , -V[5] ] == {{(-I)*gc1654*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1654*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1654*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1654*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , V[1] , -V[6] ] == {{(-I)*gc1655*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1655*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1655*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1655*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , V[2] , -V[6] ] == {{(-I)*gc1656*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1656*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1656*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1656*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[5] , V[3] ] == {{(-I)*gc1657*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1657*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1657*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1657*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[6] , V[3] ] == {{(-I)*gc1658*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1658*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1658*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1658*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[5] , V[4] ] == {{(-I)*gc1659*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1659*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1659*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1659*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[12, {e1x2}] , F[9, {e2x2}] , -V[6] , V[4] ] == {{(-I)*gc1660*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {(-I)*cuW3x3*gc1660*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*gc1660*Conjugate[cdW3x3]*IndexDelta[e1x2, e2x2], 0}, {0, 0}, {I*cuW3x3*gc1660*IndexDelta[e1x2, e2x2], 0}, {0, 0}},

C[ -F[3] , F[6] , S[3] , V[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1661, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1661, 0}, {0, 0}},

C[ -F[3] , F[6] , S[4] , V[5] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1662, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1662, 0}, {0, 0}},

C[ -F[3] , F[6] , S[3] , V[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1663, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1663, 0}, {0, 0}},

C[ -F[3] , F[6] , S[4] , V[6] ] == {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {-gc1664, 0}, {0, 0}, {0, 0}, {0, 0}, {gc1664, 0}, {0, 0}},

C[ -F[3] , F[6] , V[1] , V[5] ] == {{0, 0}, {0, 0}, {(-I)*gc1665, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1665, 0}, {0, 0}},

C[ -F[3] , F[6] , V[2] , V[5] ] == {{0, 0}, {0, 0}, {(-I)*gc1666, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1666, 0}, {0, 0}},

C[ -F[3] , F[6] , V[1] , V[6] ] == {{0, 0}, {0, 0}, {(-I)*gc1667, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1667, 0}, {0, 0}},

C[ -F[3] , F[6] , V[2] , V[6] ] == {{0, 0}, {0, 0}, {(-I)*gc1668, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1668, 0}, {0, 0}},

C[ -F[3] , F[6] , V[5] , V[3] ] == {{0, 0}, {0, 0}, {(-I)*gc1669, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1669, 0}, {0, 0}},

C[ -F[3] , F[6] , V[6] , V[3] ] == {{0, 0}, {0, 0}, {(-I)*gc1670, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1670, 0}, {0, 0}},

C[ -F[3] , F[6] , V[5] , V[4] ] == {{0, 0}, {0, 0}, {(-I)*gc1671, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1671, 0}, {0, 0}},

C[ -F[3] , F[6] , V[6] , V[4] ] == {{0, 0}, {0, 0}, {(-I)*gc1672, 0}, {0, 0}, {0, 0}, {0, 0}, {I*gc1672, 0}, {0, 0}}

}

(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

(* Parameter replacement lists (These lists were created by FeynRules) *)

(* FA Couplings *)

M$FACouplings = {
     gc3 -> 1/2,
     gc6 -> 1/2,
     gc7 -> 1/2,
     gc8 -> 1/4,
     gc10 -> 1/2,
     gc11 -> 1/8,
     gc12 -> 1/2,
     gc14 -> 1/2,
     gc15 -> 1/2,
     gc16 -> 1/8,
     gc17 -> 1/2,
     gc19 -> 1/4,
     gc20 -> 1/2,
     gc21 -> 1/2,
     gc22 -> 1/4,
     gc24 -> 1/2,
     gc27 -> -1,
     gc28 -> -1,
     gc29 -> -1/2,
     gc30 -> 1/2,
     gc31 -> 1/2,
     gc32 -> 1/2,
     gc33 -> 1/4,
     gc35 -> -1,
     gc36 -> -1/4,
     gc37 -> -1,
     gc38 -> 1/2,
     gc39 -> 1/8,
     gc40 -> 1/8,
     gc41 -> 1/2,
     gc43 -> -1/2,
     gc44 -> -1,
     gc45 -> -1,
     gc46 -> 1/4,
     gc47 -> 1/2,
     gc48 -> 1/2,
     gc49 -> 1/2,
     gc53 -> vev/2,
     gc54 -> vev/16,
     gc55 -> vev/2,
     gc56 -> vev/2,
     gc57 -> vev/16,
     gc58 -> vev/16,
     gc59 -> vev/2,
     gc60 -> vev/2,
     gc61 -> vev/8,
     gc62 -> vev/2,
     gc63 -> vev/2,
     gc64 -> vev/8,
     gc65 -> vev/2,
     gc66 -> vev/2,
     gc67 -> vev/2,
     gc68 -> vev/2,
     gc69 -> vev/2,
     gc70 -> vev/2,
     gc71 -> 1/8,
     gc72 -> -1/8,
     gc73 -> 1/8,
     gc74 -> -1/8,
     gc75 -> -vev/16,
     gc76 -> vev/16,
     gc77 -> -1/4,
     gc78 -> -1/4,
     gc79 -> -1/(4*xiBG),
     gc80 -> -1/2,
     gc81 -> -1/2,
     gc82 -> -1/2,
     gc83 -> -1/(2*xiBG),
     gc84 -> -1/4,
     gc85 -> -1/4,
     gc86 -> -1/(4*xiBG),
     gc87 -> -vev/8,
     gc88 -> -vev/(8*xiBG),
     gc89 -> -1/4,
     gc90 -> -1/4,
     gc91 -> -1/4,
     gc92 -> -1/2,
     gc93 -> -1/2,
     gc94 -> -1/2,
     gc95 -> -1/2,
     gc96 -> -1/4,
     gc97 -> -1/4,
     gc98 -> -1/4,
     gc99 -> -vev/8,
     gc100 -> -vev/8,
     gc101 -> -1/4,
     gc102 -> -1/4,
     gc103 -> -1/4,
     gc104 -> -1/2,
     gc105 -> -1/2,
     gc106 -> -1/2,
     gc107 -> -1/2,
     gc108 -> -1/4,
     gc109 -> -1/4,
     gc110 -> -1/4,
     gc111 -> -vev/8,
     gc112 -> -vev/8,
     gc113 -> 1/4,
     gc114 -> 1/4,
     gc115 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc116 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc117 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc118 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc119 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc120 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc121 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc122 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc123 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc124 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc125 -> 1/4,
     gc126 -> 1/4,
     gc127 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc128 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc129 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc130 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc131 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc132 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc133 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc134 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc135 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc136 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc137 -> 1/4,
     gc138 -> 1/4,
     gc139 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc140 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc141 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc142 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc143 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc144 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc145 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc146 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc147 -> 1/4,
     gc148 -> 1/4,
     gc149 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc150 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc151 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc152 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc153 -> (cHD*(cwbar*g1 + g2*swbar)*vev)/2,
     gc154 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc155 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc156 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc157 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc158 -> (cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2) + g2*swbar*(-2 + cHD*vev^2 - 2*cHW*vev^2))/4,
     gc159 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc160 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc161 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc162 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc163 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc164 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc165 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc166 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc167 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc168 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc169 -> -cHD/2,
     gc170 -> -cHD/2,
     gc171 -> -cHD/2,
     gc172 -> (cHD*vev)/2,
     gc173 -> -cHD/2,
     gc174 -> -cHD/2,
     gc175 -> -cHD/2,
     gc176 -> (cHD*vev)/2,
     gc177 -> (cHD*vev)/2,
     gc178 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc179 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc180 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc181 -> (cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - cwbar*g1*(2 + 2*cHB*vev^2 + cHD*vev^2) + g2*swbar*(-2 + cHD*vev^2 - 2*cHW*vev^2))/4,
     gc182 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc183 -> -(cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc184 -> cHD/2,
     gc185 -> cHD/2,
     gc186 -> -(cHD*vev)/2,
     gc187 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc188 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc189 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc190 -> (cwbar*(-(cHWB*g2*vev^2) + g1*(2 + 2*cHB*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc191 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc192 -> (cHD*(cwbar*g1 - g2*swbar)*vev)/2,
     gc193 -> -cHD/2,
     gc194 -> -cHD/2,
     gc195 -> (cHD*vev)/2,
     gc196 -> -cHD/2,
     gc197 -> -cHD/2,
     gc198 -> (cHD*vev)/2,
     gc199 -> -4*cHG,
     gc200 -> -4*cHG,
     gc201 -> (-4*cHG)/xiGBG,
     gc202 -> -4*cHG,
     gc203 -> -4*cHG,
     gc204 -> -4*cHG,
     gc205 -> (-4*cHG)/xiGBG,
     gc206 -> -4*cHG,
     gc207 -> -4*cHG,
     gc208 -> (-4*cHG)/xiGBG,
     gc209 -> -4*cHG*vev,
     gc210 -> (-4*cHG*vev)/xiGBG,
     gc211 -> -4*cHG,
     gc212 -> -4*cHG,
     gc213 -> -4*cHG,
     gc214 -> -4*cHG,
     gc215 -> -4*cHG,
     gc216 -> -4*cHG,
     gc217 -> -4*cHG,
     gc218 -> -4*cHG,
     gc219 -> -4*cHG,
     gc220 -> -4*cHG,
     gc221 -> -4*cHG*vev,
     gc222 -> -4*cHG*vev,
     gc223 -> -4*cHG,
     gc224 -> -4*cHG,
     gc225 -> -4*cHG,
     gc226 -> -4*cHG,
     gc227 -> -4*cHG,
     gc228 -> -4*cHG,
     gc229 -> -4*cHG,
     gc230 -> -4*cHG,
     gc231 -> -4*cHG,
     gc232 -> -4*cHG,
     gc233 -> -4*cHG*vev,
     gc234 -> -4*cHG*vev,
     gc235 -> g2/8,
     gc236 -> g2/8,
     gc237 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc238 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc239 -> (cHD*g2*vev)/2,
     gc240 -> (cHD*g2*vev)/2,
     gc241 -> -(cHD*g2*vev)/2,
     gc242 -> -(cHD*g2*vev)/2,
     gc243 -> (cHD*g2*vev)/2,
     gc244 -> 1/(8*xiBG),
     gc245 -> -1/(8*xiBG),
     gc246 -> -vev/(4*xiBG),
     gc247 -> 1/8,
     gc248 -> 1/8,
     gc249 -> 1/8,
     gc250 -> -1/8,
     gc251 -> -1/8,
     gc252 -> -1/8,
     gc253 -> -vev/4,
     gc254 -> 1/8,
     gc255 -> 1/8,
     gc256 -> 1/8,
     gc257 -> 1/8,
     gc258 -> -1/8,
     gc259 -> -1/8,
     gc260 -> -1/8,
     gc261 -> -1/8,
     gc262 -> -vev/4,
     gc263 -> -vev/4,
     gc264 -> g2/8,
     gc265 -> g2/8,
     gc266 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc267 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc268 -> -(cHD*g2*vev)/2,
     gc269 -> (cHD*g2*vev)/2,
     gc270 -> -(cHD*g2*vev)/2,
     gc271 -> -(cHD*g2*vev)/2,
     gc272 -> (cHD*g2*vev)/2,
     gc273 -> -1/(8*xiBG),
     gc274 -> -1/(8*xiBG),
     gc275 -> -vev/(4*xiBG),
     gc276 -> -1/(4*xiBG),
     gc277 -> -1/(2*xiBG),
     gc278 -> -1/(4*xiBG),
     gc279 -> -vev/(8*xiBG),
     gc280 -> -1/8,
     gc281 -> -1/8,
     gc282 -> -1/8,
     gc283 -> -1/8,
     gc284 -> -1/8,
     gc285 -> -1/8,
     gc286 -> -vev/4,
     gc287 -> -1/8,
     gc288 -> -1/8,
     gc289 -> -1/8,
     gc290 -> -1/8,
     gc291 -> -1/8,
     gc292 -> -1/8,
     gc293 -> -1/8,
     gc294 -> -1/8,
     gc295 -> -vev/4,
     gc296 -> -vev/4,
     gc297 -> -1/4,
     gc298 -> -1/4,
     gc299 -> -1/2,
     gc300 -> -1/2,
     gc301 -> -1/2,
     gc302 -> -1/4,
     gc303 -> -1/4,
     gc304 -> -vev/8,
     gc305 -> 1/2,
     gc306 -> 1/(2*xiBG),
     gc307 -> 1/8,
     gc308 -> 1/8,
     gc309 -> 1/8,
     gc310 -> 1/8,
     gc311 -> -1/8,
     gc312 -> -1/8,
     gc313 -> -1/8,
     gc314 -> -1/8,
     gc315 -> -vev/4,
     gc316 -> -vev/4,
     gc317 -> 1/8,
     gc318 -> 1/8,
     gc319 -> 1/8,
     gc320 -> 1/8,
     gc321 -> -1/8,
     gc322 -> -1/8,
     gc323 -> -1/8,
     gc324 -> -1/8,
     gc325 -> -vev/4,
     gc326 -> -vev/4,
     gc327 -> -1/4,
     gc328 -> -1/4,
     gc329 -> -1/4,
     gc330 -> -1/2,
     gc331 -> -1/4,
     gc332 -> -1/4,
     gc333 -> -1/2,
     gc334 -> -1/4,
     gc335 -> -1/4,
     gc336 -> -1/4,
     gc337 -> -vev/8,
     gc338 -> -vev/8,
     gc339 -> -1/(2*xiBG),
     gc340 -> -1/2,
     gc341 -> -1/8,
     gc342 -> -1/8,
     gc343 -> -1/8,
     gc344 -> -1/8,
     gc345 -> -1/8,
     gc346 -> -1/8,
     gc347 -> -1/8,
     gc348 -> -1/8,
     gc349 -> -vev/4,
     gc350 -> -vev/4,
     gc351 -> -1/8,
     gc352 -> -1/8,
     gc353 -> -1/8,
     gc354 -> -1/8,
     gc355 -> -1/8,
     gc356 -> -1/8,
     gc357 -> -1/8,
     gc358 -> -1/8,
     gc359 -> -vev/4,
     gc360 -> -vev/4,
     gc361 -> -1/4,
     gc362 -> -1/4,
     gc363 -> -1/4,
     gc364 -> -1/2,
     gc365 -> -1/4,
     gc366 -> -1/4,
     gc367 -> -1/2,
     gc368 -> -1/4,
     gc369 -> -1/4,
     gc370 -> -1/4,
     gc371 -> -vev/8,
     gc372 -> -vev/8,
     gc373 -> 1/(2*xiBG),
     gc374 -> 1/2,
     gc375 -> -1/4,
     gc376 -> -1/4,
     gc377 -> -1/4,
     gc378 -> -1/2,
     gc379 -> -1/2,
     gc380 -> -1/2,
     gc381 -> -1/2,
     gc382 -> -1/4,
     gc383 -> -1/4,
     gc384 -> -1/4,
     gc385 -> -vev/8,
     gc386 -> -vev/8,
     gc387 -> 1/2,
     gc388 -> 1/2,
     gc389 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc390 -> (cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(-2 + cHD*vev^2 - 2*cHW*vev^2))/4,
     gc391 -> 1/4,
     gc392 -> -1/4,
     gc393 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc394 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc395 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc396 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc397 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc398 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc399 -> 1/(4*xiBG),
     gc400 -> 1/(4*xiBG),
     gc401 -> 1/(4*xiBG),
     gc402 -> vev/(8*xiBG),
     gc403 -> -1/(8*xiBG),
     gc404 -> 1/(8*xiBG),
     gc405 -> vev/(4*xiBG),
     gc406 -> 1/(8*xiBG),
     gc407 -> 1/(8*xiBG),
     gc408 -> vev/(4*xiBG),
     gc409 -> 1/4,
     gc410 -> 1/4,
     gc411 -> 1/4,
     gc412 -> 1/4,
     gc413 -> 1/4,
     gc414 -> 1/4,
     gc415 -> 1/4,
     gc416 -> vev/8,
     gc417 -> 1/4,
     gc418 -> 1/4,
     gc419 -> 1/4,
     gc420 -> 1/4,
     gc421 -> 1/4,
     gc422 -> 1/4,
     gc423 -> 1/4,
     gc424 -> 1/4,
     gc425 -> 1/4,
     gc426 -> 1/4,
     gc427 -> vev/8,
     gc428 -> vev/8,
     gc429 -> -1/8,
     gc430 -> -1/8,
     gc431 -> -1/8,
     gc432 -> 1/8,
     gc433 -> 1/8,
     gc434 -> 1/8,
     gc435 -> vev/4,
     gc436 -> 1/8,
     gc437 -> 1/8,
     gc438 -> 1/8,
     gc439 -> 1/8,
     gc440 -> 1/8,
     gc441 -> 1/8,
     gc442 -> vev/4,
     gc443 -> 1/2,
     gc444 -> -1/8,
     gc445 -> -1/8,
     gc446 -> -1/8,
     gc447 -> -1/8,
     gc448 -> 1/8,
     gc449 -> 1/8,
     gc450 -> 1/8,
     gc451 -> 1/8,
     gc452 -> vev/4,
     gc453 -> vev/4,
     gc454 -> 1/(2*xiBG),
     gc455 -> 1/8,
     gc456 -> 1/8,
     gc457 -> 1/8,
     gc458 -> 1/8,
     gc459 -> 1/8,
     gc460 -> 1/8,
     gc461 -> 1/8,
     gc462 -> 1/8,
     gc463 -> vev/4,
     gc464 -> vev/4,
     gc465 -> -1/(2*xiBG),
     gc466 -> 1/2,
     gc467 -> -1/4,
     gc468 -> -1/4,
     gc469 -> -1/(4*xiBG),
     gc470 -> -1/2,
     gc471 -> -1/2,
     gc472 -> -1/2,
     gc473 -> -1/(2*xiBG),
     gc474 -> -1/4,
     gc475 -> -1/4,
     gc476 -> -1/(4*xiBG),
     gc477 -> -vev/8,
     gc478 -> -vev/(8*xiBG),
     gc479 -> 1/4,
     gc480 -> 1/4,
     gc481 -> 1/4,
     gc482 -> 1/4,
     gc483 -> 1/4,
     gc484 -> 1/4,
     gc485 -> 1/4,
     gc486 -> 1/4,
     gc487 -> 1/4,
     gc488 -> 1/4,
     gc489 -> vev/8,
     gc490 -> vev/8,
     gc491 -> 1/4,
     gc492 -> 1/4,
     gc493 -> 1/4,
     gc494 -> 1/4,
     gc495 -> 1/4,
     gc496 -> 1/4,
     gc497 -> 1/4,
     gc498 -> 1/4,
     gc499 -> 1/4,
     gc500 -> 1/4,
     gc501 -> vev/8,
     gc502 -> vev/8,
     gc503 -> -1/8,
     gc504 -> -1/8,
     gc505 -> -1/8,
     gc506 -> -1/8,
     gc507 -> 1/8,
     gc508 -> 1/8,
     gc509 -> 1/8,
     gc510 -> 1/8,
     gc511 -> vev/4,
     gc512 -> vev/4,
     gc513 -> 1/8,
     gc514 -> 1/8,
     gc515 -> 1/8,
     gc516 -> 1/8,
     gc517 -> 1/8,
     gc518 -> 1/8,
     gc519 -> 1/8,
     gc520 -> 1/8,
     gc521 -> vev/4,
     gc522 -> vev/4,
     gc523 -> 1/(2*xiBG),
     gc524 -> -1/8,
     gc525 -> -1/8,
     gc526 -> -1/8,
     gc527 -> -1/8,
     gc528 -> 1/8,
     gc529 -> 1/8,
     gc530 -> 1/8,
     gc531 -> 1/8,
     gc532 -> vev/4,
     gc533 -> vev/4,
     gc534 -> -1/2,
     gc535 -> 1/8,
     gc536 -> 1/8,
     gc537 -> 1/8,
     gc538 -> 1/8,
     gc539 -> 1/8,
     gc540 -> 1/8,
     gc541 -> 1/8,
     gc542 -> 1/8,
     gc543 -> vev/4,
     gc544 -> vev/4,
     gc545 -> 1/2,
     gc546 -> 1/2,
     gc547 -> -1/4,
     gc548 -> -1/4,
     gc549 -> -1/4,
     gc550 -> -1/2,
     gc551 -> -1/2,
     gc552 -> -1/2,
     gc553 -> -1/2,
     gc554 -> -1/4,
     gc555 -> -1/4,
     gc556 -> -1/4,
     gc557 -> -vev/8,
     gc558 -> -vev/8,
     gc559 -> -1/4,
     gc560 -> -1/4,
     gc561 -> -1/4,
     gc562 -> -1/2,
     gc563 -> -1/2,
     gc564 -> -1/2,
     gc565 -> -1/2,
     gc566 -> -1/4,
     gc567 -> -1/4,
     gc568 -> -1/4,
     gc569 -> -vev/8,
     gc570 -> -vev/8,
     gc571 -> -((cwbar*g1 - g2*swbar)*(-(swbar*(g2 + cHWB*g1*vev^2 + 2*cHW*g2*vev^2)) + cwbar*(g1 + 2*cHB*g1*vev^2 + cHWB*g2*vev^2))*xiBG)/4,
     gc572 -> -1/4,
     gc573 -> -((cwbar*g1 + g2*swbar)*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2*swbar*(2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/8,
     gc574 -> -((cwbar*g1 + g2*swbar)*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2*swbar*(2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/8,
     gc575 -> -1/2,
     gc576 -> -((cwbar*g1 - g2*swbar)*(cwbar*(cHWB*g2*vev^2 + g1*(1 + 2*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(1 + 2*cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/4,
     gc577 -> -1/4,
     gc578 -> -((cwbar*g1 - g2*swbar)*vev*(4*cHWB*cwbar*g2*vev^2 - 4*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc579 -> -vev/8,
     gc580 -> (g2*(-2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc581 -> (g2*(2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 + g2*swbar*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) - cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc582 -> -1/8,
     gc583 -> -(g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc584 -> -(g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc585 -> -1/8,
     gc586 -> -(g2*vev*(cwbar*(cHWB*g2*vev^2 + g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 + cHD*vev^2 + 4*cHW*vev^2)))*xiBG)/8,
     gc587 -> -vev/4,
     gc588 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc589 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc590 -> (g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc591 -> (g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 - 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc592 -> 1/8,
     gc593 -> -(g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc594 -> -(g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc595 -> -1/8,
     gc596 -> -(g2*vev*(cwbar*(cHWB*g2*vev^2 + g1*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 + cHD*vev^2 + 4*cHW*vev^2)))*xiBG)/8,
     gc597 -> -vev/4,
     gc598 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc599 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc600 -> ((cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + 2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2) - g2^2*(1 + 2*cHW*vev^2)))*xiBG)/8,
     gc601 -> 1/4,
     gc602 -> ((cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(-2 - 2*cHB*vev^2 + cHD*vev^2 - 2*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc603 -> ((cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(-2 - 2*cHB*vev^2 + cHD*vev^2 - 2*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 - g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc604 -> 1/4,
     gc605 -> ((cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)) + 2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2) - g2^2*(1 + 2*cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc606 -> 1/4,
     gc607 -> (vev*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + cHD*vev^2 + 8*cHW*vev^2)))*xiBG)/16,
     gc608 -> vev/8,
     gc609 -> (g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc610 -> (g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + g2*swbar*(-4 + cHD*vev^2 - 8*cHW*vev^2) + cwbar*g1*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc611 -> 1/8,
     gc612 -> -(g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc613 -> -(g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc614 -> -1/8,
     gc615 -> (g2*vev*(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHW*vev^2) - 2*g2*swbar*(1 + 2*cHW*vev^2))*xiBG)/8,
     gc616 -> -vev/4,
     gc617 -> (g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG)/8,
     gc618 -> -1/4,
     gc619 -> -(g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2)*xiBG)/4,
     gc620 -> -1/2,
     gc621 -> (g2^2*(2 + 2*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc622 -> -(g2^2*(2 + 2*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc623 -> -(g2^2*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc624 -> -1/4,
     gc625 -> (g2^2*vev*(-4 + cHD*vev^2 - 8*cHW*vev^2)*xiBG)/16,
     gc626 -> -(g2^2*vev*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG)/16,
     gc627 -> -vev/8,
     gc630 -> 4*cHW*g2*swbar*vev,
     gc631 -> -4*cHW*g2*swbar*vev,
     gc632 -> -(cHD*g2^2*vev^2*xiBG)/4,
     gc633 -> -(cHD*g2^2*vev^2*xiBG),
     gc634 -> (g2*(-2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(-4 - 4*cHB*vev^2 + cHD*vev^2 - 4*cHW*vev^2) + cwbar*g2*(4 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc635 -> -(g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc636 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc637 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 - 4*cHbox*vev^2 + cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc638 -> -1/8,
     gc639 -> 1/8,
     gc640 -> (g2*vev*(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHW*vev^2) - 2*cwbar*g2*(1 + 2*cHW*vev^2))*xiBG)/8,
     gc641 -> vev/4,
     gc642 -> g2*(swbar - (cHWB*cwbar*vev^2)/2 + cHW*swbar*vev^2),
     gc643 -> (g2*(2*cHWB*cwbar*g2*vev^2 + 2*cHWB*g1*swbar*vev^2 + g2*swbar*(-4 + cHD*vev^2 - 8*cHW*vev^2) + cwbar*g1*(-4 - 4*cHB*vev^2 + cHD*vev^2 - 4*cHW*vev^2))*xiBG)/16,
     gc644 -> -(g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + g2*swbar*(-4 + cHD*vev^2 - 8*cHW*vev^2) + cwbar*g1*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc645 -> -1/8,
     gc646 -> -(g2*(2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2) - g2*swbar*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc647 -> -(g2*(-2*cHWB*cwbar*g2*vev^2 - 2*cHWB*g1*swbar*vev^2 + cwbar*g1*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2) + g2*swbar*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc648 -> -1/8,
     gc649 -> (g2*vev*(cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + cHW*vev^2) - 2*g2*swbar*(1 + 2*cHW*vev^2))*xiBG)/8,
     gc650 -> -vev/4,
     gc651 -> -(cHD*g2^2*vev^2*xiBG)/4,
     gc652 -> -(cHD*g2^2*vev^2*xiBG),
     gc653 -> (g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)*xiBG)/8,
     gc654 -> -1/4,
     gc655 -> -(g2^2*(2 + cHD*vev^2 + 4*cHW*vev^2)*xiBG)/4,
     gc656 -> -1/2,
     gc657 -> -(g2^2*(2 + 2*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc658 -> (g2^2*(2 + 2*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc659 -> -(g2^2*(2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2)*xiBG)/8,
     gc660 -> -1/4,
     gc661 -> (g2^2*vev*(4 - cHD*vev^2 + 8*cHW*vev^2)*xiBG)/16,
     gc662 -> -(g2^2*vev*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 8*cHW*vev^2)*xiBG)/16,
     gc663 -> -vev/8,
     gc666 -> -4*cHW*g2*swbar*vev,
     gc667 -> 4*cHW*g2*swbar*vev,
     gc668 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 + cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc669 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 - cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 - cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc670 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc671 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 - 4*cHbox*vev^2 + cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc672 -> 1/8,
     gc673 -> 1/8,
     gc674 -> (g2*vev*(cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + cHW*vev^2) - 2*cwbar*g2*(1 + 2*cHW*vev^2))*xiBG)/8,
     gc675 -> vev/4,
     gc676 -> (g2*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)))/2,
     gc677 -> ((cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + cHW*vev^2)) + 2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2) - g2^2*(1 + 2*cHW*vev^2)))*xiBG)/8,
     gc678 -> 1/4,
     gc679 -> ((cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(-2 - 2*cHB*vev^2 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc680 -> ((cwbar*swbar*(g1^2*(2 + 4*cHB*vev^2 + cHD*vev^2) + g2^2*(-2 + cHD*vev^2 - 4*cHW*vev^2)) + cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + g1*g2*(-2 - 2*cHB*vev^2 + cHD*vev^2 - 2*cHW*vev^2)) + swbar^2*(-(cHWB*g1^2*vev^2) - cHWB*g2^2*vev^2 + g1*g2*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc681 -> 1/4,
     gc682 -> ((cwbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)) - swbar^2*(cHWB*g1^2*vev^2 + cHWB*g2^2*vev^2 + 2*g1*g2*(1 + cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2 + cHW*vev^2)) + 2*cwbar*swbar*(g1^2*(1 + 2*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2) - g2^2*(1 + 2*cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2)))*xiBG)/8,
     gc683 -> 1/4,
     gc684 -> (vev*(cwbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2)) - swbar^2*(2*cHWB*g1^2*vev^2 + 2*cHWB*g2^2*vev^2 + g1*g2*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2)) + cwbar*swbar*(g1^2*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2) - g2^2*(4 + 4*cHbox*vev^2 + cHD*vev^2 + 8*cHW*vev^2)))*xiBG)/16,
     gc685 -> vev/8,
     gc686 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc687 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc688 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - cwbar*g2*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc689 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc690 -> 1/8,
     gc691 -> 1/8,
     gc692 -> (g2*vev*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG)/8,
     gc693 -> vev/4,
     gc694 -> -2*cHWB*g2*swbar^2*vev,
     gc695 -> 2*cHWB*g2*swbar^2*vev,
     gc696 -> -(g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc697 -> -(g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + cwbar*g2*(-4 + 3*cHD*vev^2 - 8*cHW*vev^2) + g1*swbar*(4 + 4*cHB*vev^2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG)/16,
     gc698 -> (g2*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2 + 4*cHW*vev^2) - cwbar*g2*(4 + 4*cHbox*vev^2 - 3*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc699 -> (g2*(2*cHWB*cwbar*g1*vev^2 + 2*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 4*cHB*vev^2 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 4*cHW*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + 5*cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc700 -> -1/8,
     gc701 -> 1/8,
     gc702 -> (g2*vev*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2 + 2*cHW*vev^2) + cwbar*g2*(2 + cHD*vev^2 + 4*cHW*vev^2))*xiBG)/8,
     gc703 -> vev/4,
     gc704 -> 2*cHWB*g2*swbar^2*vev,
     gc705 -> -2*cHWB*g2*swbar^2*vev,
     gc706 -> -((cwbar*g2 + g1*swbar)*(cwbar*(g2 + cHWB*g1*vev^2 + 2*cHW*g2*vev^2) + swbar*(g1 + 2*cHB*g1*vev^2 + cHWB*g2*vev^2))*xiBG)/4,
     gc707 -> -1/4,
     gc708 -> ((cwbar*g2 - g1*swbar)*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(-2 + cHD*vev^2 - 4*cHW*vev^2))*xiBG)/8,
     gc709 -> ((cwbar*g2 - g1*swbar)*(2*cHWB*cwbar*g1*vev^2 - 2*cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 4*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(-2 + cHD*vev^2 - 4*cHW*vev^2))*xiBG)/8,
     gc710 -> -1/2,
     gc711 -> -((cwbar*g2 + g1*swbar)*(cHWB*cwbar*g1*vev^2 + cHWB*g2*swbar*vev^2 + g1*swbar*(1 + 2*cHB*vev^2 + 2*cHbox*vev^2 + cHD*vev^2) + cwbar*g2*(1 + 2*cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2))*xiBG)/4,
     gc712 -> -1/4,
     gc713 -> -((cwbar*g2 + g1*swbar)*vev*(4*cHWB*cwbar*g1*vev^2 + 4*cHWB*g2*swbar*vev^2 + g1*swbar*(4 + 8*cHB*vev^2 + 4*cHbox*vev^2 + cHD*vev^2) + cwbar*g2*(4 + 4*cHbox*vev^2 + cHD*vev^2 + 8*cHW*vev^2))*xiBG)/16,
     gc714 -> -vev/8,
     gc715 -> (g2*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)))/2,
     gc716 -> (g2*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)))/2,
     gc717 -> -4*cHG,
     gc718 -> -4*cHG,
     gc719 -> -4*cHG,
     gc720 -> -4*cHG*vev,
     gc721 -> -1,
     gc722 -> -xiGBG^(-1),
     gc723 -> -1,
     gc724 -> -1,
     gc725 -> g3 + cHG*g3*vev^2,
     gc726 -> -4*cHG*g3*vev,
     gc727 -> -4*cHG*g3*vev,
     gc728 -> -4*cHG*g3*vev,
     gc729 -> -4*cHG*g3*vev,
     gc730 -> (4*cHG*g3*vev)/xiGBG,
     gc731 -> g3,
     gc732 -> -g3,
     gc733 -> g3/xiGBG,
     gc734 -> 4*cHG*g3*vev,
     gc735 -> 4*cHG*g3*vev,
     gc736 -> -g3,
     gc737 -> -(g3*(1 + cHG*vev^2)),
     gc738 -> 4*cHG*g3*vev,
     gc741 -> -4*cHG*g3*vev,
     gc742 -> -4*cHG*g3*vev,
     gc743 -> g3,
     gc744 -> 1/(2*vev),
     gc745 -> 1/(2*vev),
     gc746 -> (MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3])/(4*vev),
     gc747 -> (MTAbar*(-4 + cHD*vev^2) + Sqrt[2]*vev^3*Conjugate[ceH3x3])/(4*vev),
     gc748 -> (MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 3*Sqrt[2]*vev^3*Conjugate[ceH3x3])/(4*vev),
     gc749 -> (MTAbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 3*Sqrt[2]*vev^3*Conjugate[ceH3x3])/(4*vev),
     gc750 -> MBbar*(-vev^(-1) + (cHD*vev)/4),
     gc751 -> MBbar*(-vev^(-1) + (cHD*vev)/4),
     gc752 -> (MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cdH3x3])/(4*vev),
     gc753 -> (MBbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cdH3x3])/(4*vev),
     gc754 -> MTbar*(vev^(-1) - (cHD*vev)/4),
     gc755 -> MTbar*(vev^(-1) - (cHD*vev)/4),
     gc756 -> (MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cuH3x3])/(4*vev),
     gc757 -> (MTbar*(-4 - 4*cHbox*vev^2 + cHD*vev^2) + 2*Sqrt[2]*vev^3*Conjugate[cuH3x3])/(4*vev),
     gc758 -> -((Sqrt[2]*MBbar*Conjugate[CKM3x3])/vev),
     gc759 -> -((Sqrt[2]*MBbar*Conjugate[CKM3x3])/vev),
     gc760 -> (Sqrt[2]*CKM3x3*MTbar)/vev,
     gc761 -> (Sqrt[2]*CKM3x3*MTbar)/vev,
     gc766 -> vev/Sqrt[2],
     gc767 -> vev/Sqrt[2],
     gc768 -> vev/Sqrt[2],
     gc769 -> -(1/Sqrt[2]),
     gc770 -> 1/Sqrt[2],
     gc771 -> -(1/Sqrt[2]),
     gc772 -> -(1/Sqrt[2]),
     gc773 -> 1/Sqrt[2],
     gc774 -> 1/Sqrt[2],
     gc775 -> (3*vev)/Sqrt[2],
     gc776 -> 1/Sqrt[2],
     gc777 -> 1/Sqrt[2],
     gc778 -> (3*vev)/Sqrt[2],
     gc779 -> (3*vev)/Sqrt[2],
     gc780 -> vev/Sqrt[2],
     gc781 -> vev/Sqrt[2],
     gc782 -> vev/Sqrt[2],
     gc783 -> -(1/Sqrt[2]),
     gc784 -> 1/Sqrt[2],
     gc785 -> -(1/Sqrt[2]),
     gc786 -> -(1/Sqrt[2]),
     gc787 -> 1/Sqrt[2],
     gc788 -> 1/Sqrt[2],
     gc789 -> (3*vev)/Sqrt[2],
     gc790 -> 1/Sqrt[2],
     gc791 -> 1/Sqrt[2],
     gc792 -> (3*vev)/Sqrt[2],
     gc793 -> (3*vev)/Sqrt[2],
     gc794 -> vev/Sqrt[2],
     gc795 -> vev/Sqrt[2],
     gc796 -> vev/Sqrt[2],
     gc797 -> -(1/Sqrt[2]),
     gc798 -> 1/Sqrt[2],
     gc799 -> -(1/Sqrt[2]),
     gc800 -> -(1/Sqrt[2]),
     gc801 -> 1/Sqrt[2],
     gc802 -> 1/Sqrt[2],
     gc803 -> (3*vev)/Sqrt[2],
     gc804 -> 1/Sqrt[2],
     gc805 -> 1/Sqrt[2],
     gc806 -> (3*vev)/Sqrt[2],
     gc807 -> (3*vev)/Sqrt[2],
     gc808 -> -(1/Sqrt[2]),
     gc809 -> -(1/Sqrt[2]),
     gc810 -> -(1/Sqrt[2]),
     gc811 -> -(1/Sqrt[2]),
     gc812 -> -(CKM1x3*vev*Conjugate[cuH1x3]),
     gc813 -> -(CKM1x3*vev*Conjugate[cuH1x3]),
     gc814 -> -(CKM1x3*vev*Conjugate[cuH1x3]),
     gc815 -> -(CKM1x3*vev*Conjugate[cuH1x3]),
     gc816 -> -(CKM2x3*vev*Conjugate[cuH2x3]),
     gc817 -> -(CKM2x3*vev*Conjugate[cuH2x3]),
     gc818 -> -(CKM2x3*vev*Conjugate[cuH2x3]),
     gc819 -> -(CKM2x3*vev*Conjugate[cuH2x3]),
     gc820 -> 1/Sqrt[2],
     gc821 -> 1/Sqrt[2],
     gc822 -> 1/Sqrt[2],
     gc823 -> 1/Sqrt[2],
     gc824 -> 1/6,
     gc825 -> 1/2,
     gc826 -> -1/2,
     gc830 -> -1,
     gc831 -> -1,
     gc832 -> -1,
     gc833 -> -1,
     gc834 -> -(cuH1x3*vev*Conjugate[CKM1x3]),
     gc835 -> -(cuH1x3*vev*Conjugate[CKM1x3]),
     gc836 -> -(cuH1x3*vev*Conjugate[CKM1x3]),
     gc837 -> -(cuH1x3*vev*Conjugate[CKM1x3]),
     gc838 -> -(cuH2x3*vev*Conjugate[CKM2x3]),
     gc839 -> -(cuH2x3*vev*Conjugate[CKM2x3]),
     gc840 -> -(cuH2x3*vev*Conjugate[CKM2x3]),
     gc841 -> -(cuH2x3*vev*Conjugate[CKM2x3]),
     gc842 -> 1/2,
     gc843 -> g2/8,
     gc844 -> (cHD*g2*vev)/2,
     gc845 -> (cHD*g2*vev)/2,
     gc846 -> (cHD*g2*vev)/2,
     gc847 -> -(cHD*g2*vev)/2,
     gc848 -> -(cHD*g2*vev)/2,
     gc849 -> -(cHD*g2*vev)/2,
     gc850 -> g2/8,
     gc851 -> (cHD*g2*vev)/2,
     gc852 -> (cHD*g2*vev)/2,
     gc853 -> -(cHD*g2*vev)/2,
     gc854 -> -(cHD*g2*vev)/2,
     gc855 -> -(cHD*g2*vev)/2,
     gc856 -> (cHD*g2*vev)/2,
     gc857 -> (cHD*g2*vev)/2,
     gc858 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc859 -> -(cHD*g2*vev)/2,
     gc860 -> (cHD*g2*vev)/2,
     gc861 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc862 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc863 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc864 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc865 -> (2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc866 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc867 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc868 -> 2*g2*vev,
     gc869 -> 2*g2*vev,
     gc870 -> 2*g2*vev,
     gc871 -> (2*g2*vev)/xiBG,
     gc872 -> g2*swbar,
     gc873 -> g2*swbar,
     gc874 -> (g2*swbar)/xiBG,
     gc875 -> 2*g2*vev,
     gc876 -> (2*g2*vev)/xiBG,
     gc877 -> 2*g2*vev,
     gc878 -> 2*g2*vev,
     gc879 -> g2*swbar,
     gc880 -> (g2*swbar)/xiBG,
     gc881 -> g2*swbar,
     gc882 -> -2*cHWB*g2*vev,
     gc883 -> -2*cHWB*g2*vev,
     gc884 -> -2*cHWB*g2*vev,
     gc885 -> (-2*cHWB*g2*vev)/xiBG,
     gc886 -> -g2/2,
     gc887 -> -g2/2,
     gc888 -> -g2/2,
     gc889 -> -g2/(2*xiBG),
     gc890 -> -2*cHWB*g2*vev,
     gc891 -> (2*cHWB*g2*vev)/xiBG,
     gc892 -> -2*cHWB*g2*vev,
     gc893 -> -2*cHWB*g2*vev,
     gc894 -> -g2/2,
     gc895 -> -g2/(2*xiBG),
     gc896 -> -g2/(2*xiBG),
     gc897 -> -g2/2,
     gc898 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc899 -> 2*g2*(cHWB*cwbar - 2*cHW*swbar)*vev,
     gc900 -> 2*cHWB*cwbar^2*g2*vev,
     gc902 -> 4*cHW*g2*swbar*vev,
     gc904 -> 4*cHW*cwbar*g2*vev,
     gc905 -> -2*cHWB*g2*swbar^2*vev,
     gc906 -> -2*g2*(2*cHW*cwbar + cHWB*swbar)*vev,
     gc907 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc908 -> (g2*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)))/2,
     gc909 -> (g2*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)))/2,
     gc910 -> -(g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc911 -> (g2*(-(cHWB*swbar*vev^2) + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc912 -> cHD*g2^2*vev^2,
     gc913 -> cHD*g2^2*vev^2,
     gc914 -> cHD*g2^2*vev^2,
     gc915 -> g2/8,
     gc916 -> -(cHD*g2*vev)/2,
     gc917 -> -(cHD*g2*vev)/2,
     gc918 -> -(cHD*g2*vev)/2,
     gc919 -> -(cHD*g2*vev)/2,
     gc920 -> -(cHD*g2*vev)/2,
     gc921 -> -(cHD*g2*vev)/2,
     gc922 -> g2/8,
     gc923 -> -(cHD*g2*vev)/2,
     gc924 -> -(cHD*g2*vev)/2,
     gc925 -> -(cHD*g2*vev)/2,
     gc926 -> -(cHD*g2*vev)/2,
     gc927 -> -(cHD*g2*vev)/2,
     gc928 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc929 -> (cHD*g2*vev)/2,
     gc930 -> -(cHD*g2*vev)/2,
     gc931 -> (cHD*g2*vev)/2,
     gc932 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc933 -> (cHD*g2*vev)/2,
     gc934 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc935 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc936 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc937 -> (-2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc938 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc939 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc940 -> -2*g2*vev,
     gc941 -> (-2*g2*vev)/xiBG,
     gc942 -> -2*g2*vev,
     gc943 -> -2*g2*vev,
     gc944 -> g2*swbar,
     gc945 -> (g2*swbar)/xiBG,
     gc946 -> g2*swbar,
     gc947 -> 2*cHWB*g2*vev,
     gc948 -> 2*cHWB*g2*vev,
     gc949 -> 2*cHWB*g2*vev,
     gc950 -> (2*cHWB*g2*vev)/xiBG,
     gc951 -> -g2/2,
     gc952 -> -g2/(2*xiBG),
     gc953 -> 2*cHWB*g2*vev,
     gc954 -> (-2*cHWB*g2*vev)/xiBG,
     gc955 -> 2*cHWB*g2*vev,
     gc956 -> 2*cHWB*g2*vev,
     gc957 -> -g2/(2*xiBG),
     gc958 -> -g2/2,
     gc959 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc960 -> -2*g2*(cHWB*cwbar - 2*cHW*swbar)*vev,
     gc961 -> -2*cHWB*cwbar^2*g2*vev,
     gc963 -> -4*cHW*g2*swbar*vev,
     gc965 -> -4*cHW*cwbar*g2*vev,
     gc966 -> 2*cHWB*g2*swbar^2*vev,
     gc967 -> 2*g2*(2*cHW*cwbar + cHWB*swbar)*vev,
     gc968 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc969 -> -(g2*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)))/2,
     gc970 -> (g2*(-(cHWB*cwbar*vev^2) + 2*swbar*(1 + cHW*vev^2)))/2,
     gc971 -> (g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc972 -> (g2*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)))/2,
     gc973 -> -g2,
     gc974 -> g2,
     gc975 -> -g2,
     gc976 -> -(g2/xiBG),
     gc977 -> 2*g2*vev,
     gc978 -> 2*g2*vev,
     gc979 -> 2*g2*vev,
     gc980 -> (-2*g2*vev)/xiBG,
     gc981 -> cHD*g2^2*vev^2,
     gc982 -> cHD*g2^2*vev^2,
     gc983 -> cHD*g2^2*vev^2,
     gc984 -> g2/8,
     gc985 -> g2/8,
     gc986 -> (cHD*g2*vev)/2,
     gc987 -> (cHD*g2*vev)/2,
     gc988 -> (cHD*g2*vev)/2,
     gc989 -> (cHD*g2*vev)/2,
     gc990 -> -(cHD*g2*vev)/2,
     gc991 -> -(cHD*g2*vev)/2,
     gc992 -> -(cHD*g2*vev)/2,
     gc993 -> -(cHD*g2*vev)/2,
     gc994 -> g2/8,
     gc995 -> g2/8,
     gc996 -> (cHD*g2*vev)/2,
     gc997 -> (cHD*g2*vev)/2,
     gc998 -> -(cHD*g2*vev)/2,
     gc999 -> -(cHD*g2*vev)/2,
     gc1000 -> -(cHD*g2*vev)/2,
     gc1001 -> -(cHD*g2*vev)/2,
     gc1002 -> (cHD*g2*vev)/2,
     gc1003 -> (cHD*g2*vev)/2,
     gc1004 -> (cHD*g2*vev)/2,
     gc1005 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1006 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1007 -> -(cHD*g2*vev)/2,
     gc1008 -> (cHD*g2*vev)/2,
     gc1009 -> (cHD*g2*vev)/2,
     gc1010 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1011 -> -(g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1012 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1013 -> (-2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1014 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1015 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1016 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1017 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1018 -> 2*g2*vev,
     gc1019 -> 2*g2*vev,
     gc1020 -> 2*g2*vev,
     gc1021 -> 2*g2*vev,
     gc1022 -> (g2*swbar)/xiBG,
     gc1023 -> g2*swbar,
     gc1024 -> g2*swbar,
     gc1025 -> -2*cHWB*g2*vev,
     gc1026 -> (2*cHWB*g2*vev)/xiBG,
     gc1027 -> -2*cHWB*g2*vev,
     gc1028 -> -2*cHWB*g2*vev,
     gc1029 -> -g2/(2*xiBG),
     gc1030 -> -g2/2,
     gc1031 -> -2*cHWB*g2*vev,
     gc1032 -> -2*cHWB*g2*vev,
     gc1033 -> -2*cHWB*g2*vev,
     gc1034 -> -2*cHWB*g2*vev,
     gc1035 -> -g2/2,
     gc1036 -> -g2/2,
     gc1037 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1040 -> -2*g2*(cHWB*cwbar - 2*cHW*swbar)*vev,
     gc1041 -> -2*cHWB*cwbar^2*g2*vev,
     gc1042 -> -(g2*(cHWB*cwbar*vev^2 + 2*swbar*(1 + cHW*vev^2)))/2,
     gc1044 -> -4*cHW*g2*swbar*vev,
     gc1046 -> -4*cHW*cwbar*g2*vev,
     gc1047 -> g2*(swbar - (cHWB*cwbar*vev^2)/2 + cHW*swbar*vev^2),
     gc1048 -> (cHWB*g2*swbar*vev^2)/2 + cwbar*(g2 + cHW*g2*vev^2),
     gc1049 -> 2*cHWB*g2*swbar^2*vev,
     gc1052 -> 2*g2*(2*cHW*cwbar + cHWB*swbar)*vev,
     gc1053 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1054 -> (g2*(cHWB*swbar*vev^2 - 2*cwbar*(1 + cHW*vev^2)))/2,
     gc1055 -> cHD*g2^2*vev^2,
     gc1056 -> cHD*g2^2*vev^2,
     gc1057 -> cHD*g2^2*vev^2,
     gc1059 -> -(g2^2*(1 + cHbox*vev^2 + 2*cHW*vev^2))/2,
     gc1060 -> (g2^2*(1 + cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2))/2,
     gc1061 -> (g2^2*vev*(4 + cHD*vev^2 + 8*cHW*vev^2))/8,
     gc1062 -> (2*g2*vev)/xiBG,
     gc1068 -> -(g2/xiBG),
     gc1069 -> g2,
     gc1070 -> -2*g2*vev,
     gc1071 -> -2*g2*vev,
     gc1072 -> -2*g2*vev,
     gc1073 -> cHD*g2^2*vev^2,
     gc1074 -> cHD*g2^2*vev^2,
     gc1075 -> cHD*g2^2*vev^2,
     gc1077 -> g2/8,
     gc1078 -> g2/8,
     gc1079 -> -(cHD*g2*vev)/2,
     gc1080 -> -(cHD*g2*vev)/2,
     gc1081 -> -(cHD*g2*vev)/2,
     gc1082 -> -(cHD*g2*vev)/2,
     gc1083 -> -(cHD*g2*vev)/2,
     gc1084 -> -(cHD*g2*vev)/2,
     gc1085 -> -(cHD*g2*vev)/2,
     gc1086 -> -(cHD*g2*vev)/2,
     gc1087 -> g2/8,
     gc1088 -> g2/8,
     gc1089 -> -(cHD*g2*vev)/2,
     gc1090 -> -(cHD*g2*vev)/2,
     gc1091 -> -(cHD*g2*vev)/2,
     gc1092 -> -(cHD*g2*vev)/2,
     gc1093 -> -(cHD*g2*vev)/2,
     gc1094 -> -(cHD*g2*vev)/2,
     gc1095 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1096 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1097 -> (cHD*g2*vev)/2,
     gc1098 -> -(cHD*g2*vev)/2,
     gc1099 -> (cHD*g2*vev)/2,
     gc1100 -> (cHD*g2*vev)/2,
     gc1101 -> -(cHD*g2*vev)/2,
     gc1102 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1103 -> (g2*(4 + 4*cHbox*vev^2 - cHD*vev^2 + 4*cHW*vev^2))/8,
     gc1104 -> (cHD*g2*vev)/2,
     gc1105 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1106 -> (2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1107 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1108 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1109 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1110 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1111 -> 2*cHWB*g2*vev,
     gc1112 -> (-2*cHWB*g2*vev)/xiBG,
     gc1113 -> 2*cHWB*g2*vev,
     gc1114 -> 2*cHWB*g2*vev,
     gc1115 -> 2*cHWB*g2*vev,
     gc1116 -> 2*cHWB*g2*vev,
     gc1117 -> 2*cHWB*g2*vev,
     gc1118 -> 2*cHWB*g2*vev,
     gc1119 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1122 -> 2*g2*(cHWB*cwbar - 2*cHW*swbar)*vev,
     gc1123 -> 2*cHWB*cwbar^2*g2*vev,
     gc1124 -> g2*(swbar + (cHWB*cwbar*vev^2)/2 + cHW*swbar*vev^2),
     gc1126 -> 4*cHW*g2*swbar*vev,
     gc1128 -> 4*cHW*cwbar*g2*vev,
     gc1129 -> (g2*(cHWB*cwbar*vev^2 - 2*swbar*(1 + cHW*vev^2)))/2,
     gc1130 -> -(g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc1131 -> -2*cHWB*g2*swbar^2*vev,
     gc1134 -> -2*g2*(2*cHW*cwbar + cHWB*swbar)*vev,
     gc1135 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1136 -> -(cHWB*g2*swbar*vev^2)/2 + cwbar*(g2 + cHW*g2*vev^2),
     gc1137 -> (g2^2*(1 + cHbox*vev^2 + 2*cHW*vev^2))/2,
     gc1138 -> -(g2^2*(1 + cHbox*vev^2 + cHD*vev^2 + 2*cHW*vev^2))/2,
     gc1139 -> -(g2^2*vev*(4 + cHD*vev^2 + 8*cHW*vev^2))/8,
     gc1140 -> (-2*g2*vev)/xiBG,
     gc1146 -> -(g2/xiBG),
     gc1147 -> -g2,
     gc1148 -> 2*g2*vev,
     gc1149 -> 2*g2*vev,
     gc1150 -> 2*g2*vev,
     gc1151 -> cHD*g2^2*vev^2,
     gc1152 -> cHD*g2^2*vev^2,
     gc1153 -> cHD*g2^2*vev^2,
     gc1161 -> -g2,
     gc1162 -> 2*g2*vev,
     gc1163 -> 2*g2*vev,
     gc1164 -> 2*g2*vev,
     gc1165 -> 2*g2*vev,
     gc1166 -> cHD*g2^2*vev^2,
     gc1167 -> cHD*g2^2*vev^2,
     gc1168 -> cHD*g2^2*vev^2,
     gc1170 -> 1/4,
     gc1171 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1172 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1173 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1174 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1175 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1176 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1177 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1178 -> 1/4,
     gc1179 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1180 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1181 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1182 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1183 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1184 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1185 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1186 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc1187 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1188 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1189 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1190 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1191 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc1192 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1193 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1194 -> 2*cHWB*cwbar^2*g2*vev,
     gc1195 -> -2*cHWB*cwbar^2*g2*vev,
     gc1197 -> 4*cHW*cwbar*g2*vev,
     gc1199 -> -4*cHW*cwbar*g2*vev,
     gc1200 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1201 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1202 -> -(g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc1203 -> (g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc1204 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1205 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1206 -> cwbar*g2,
     gc1207 -> cwbar*g2,
     gc1208 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1209 -> (-2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1210 -> cwbar*g2,
     gc1211 -> (cwbar*g2)/xiBG,
     gc1212 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1213 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1214 -> cwbar*g2,
     gc1215 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1216 -> (2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1217 -> (cwbar*g2)/xiBG,
     gc1218 -> (2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1221 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1222 -> (cwbar*g2)/xiBG,
     gc1223 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1224 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1225 -> cwbar*g2,
     gc1226 -> (-2*cHWB*cwbar*g2*swbar*vev)/xiBG,
     gc1229 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1230 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1231 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1232 -> 1/4,
     gc1233 -> 1/4,
     gc1234 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1235 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1236 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1237 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1238 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1239 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1240 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1241 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1242 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1243 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1244 -> 1/4,
     gc1245 -> 1/4,
     gc1246 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1247 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1248 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1249 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1250 -> (cHD*(cwbar*g2 - g1*swbar)*vev)/2,
     gc1251 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1252 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1253 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1254 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc1255 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc1256 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1257 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1258 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1259 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1260 -> (cHWB*cwbar*g1*vev^2 - cHWB*g2*swbar*vev^2 + g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) + cwbar*g2*(-2 + cHD*vev^2 - 2*cHW*vev^2))/4,
     gc1261 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1262 -> (cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1263 -> (cHWB*g2*swbar*vev^2 - g1*swbar*(2 + 2*cHB*vev^2 + cHD*vev^2) - cwbar*(cHWB*g1*vev^2 + g2*(-2 + cHD*vev^2 - 2*cHW*vev^2)))/4,
     gc1264 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1265 -> -(cHD*(cwbar*g2 + g1*swbar)*vev)/2,
     gc1266 -> -2*cHWB*cwbar^2*g2*vev,
     gc1267 -> 2*cHWB*cwbar^2*g2*vev,
     gc1270 -> -4*cHW*cwbar*g2*vev,
     gc1271 -> (cHWB*g2*swbar*vev^2)/2 + cwbar*(g2 + cHW*g2*vev^2),
     gc1274 -> 4*cHW*cwbar*g2*vev,
     gc1275 -> -(g2*(cHWB*swbar*vev^2 + 2*cwbar*(1 + cHW*vev^2)))/2,
     gc1276 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1277 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1280 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1281 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1282 -> (cwbar*g2)/xiBG,
     gc1283 -> cwbar*g2,
     gc1286 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1287 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1288 -> cwbar*g2,
     gc1293 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1294 -> 2*cHWB*cwbar*g2*swbar*vev,
     gc1295 -> cwbar*g2,
     gc1300 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1301 -> -2*cHWB*cwbar*g2*swbar*vev,
     gc1306 -> (cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1307 -> (cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1308 -> (cwbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 - cHl13x3*vev^2 + cHl33x3*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 - 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2 + 2*cHW*vev^2)))/4,
     gc1309 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) + 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1310 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) + 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1311 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) + 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2))/4,
     gc1312 -> (cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1313 -> (cHWB*cwbar*g2*vev^2 - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) - 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1314 -> (cwbar*(cHWB*g2*vev^2 + 2*g1*(1 + cHB*vev^2 - cHl13x3*vev^2 + cHl33x3*vev^2)) - swbar*(cHWB*g1*vev^2 + g2*(2 - 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2 + 2*cHW*vev^2)))/4,
     gc1315 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) + 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1316 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2) + 2*g2*swbar*(1 + cHW*vev^2))/4,
     gc1317 -> (-(cHWB*cwbar*g2*vev^2) - cHWB*g1*swbar*vev^2 + 2*cwbar*g1*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) + 2*g2*swbar*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2))/4,
     gc1318 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1319 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) - g2*swbar*(6 - 6*cHq13x3*vev^2 + 6*cHq33x3*vev^2 + 6*cHW*vev^2))/12,
     gc1320 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1321 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2))/12,
     gc1322 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1323 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1324 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1325 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) - g2*swbar*(6 - 6*cHq13x3*vev^2 + 6*cHq33x3*vev^2 + 6*cHW*vev^2))/12,
     gc1326 -> (3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) - 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1327 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*g2*swbar*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2))/12,
     gc1328 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1329 -> (-3*cHWB*cwbar*g2*vev^2 + cHWB*g1*swbar*vev^2 - 2*cwbar*g1*(1 + cHB*vev^2) + 6*g2*swbar*(1 + cHW*vev^2))/12,
     gc1330 -> -g3 - cHG*g3*vev^2,
     gc1331 -> -g3 - cHG*g3*vev^2,
     gc1332 -> -g3 - cHG*g3*vev^2,
     gc1333 -> -g3 - cHG*g3*vev^2,
     gc1334 -> -g3 - cHG*g3*vev^2,
     gc1335 -> -g3 - cHG*g3*vev^2,
     gc1336 -> -g3 - cHG*g3*vev^2,
     gc1337 -> -g3 - cHG*g3*vev^2,
     gc1338 -> -g3 - cHG*g3*vev^2,
     gc1339 -> -g3 - cHG*g3*vev^2,
     gc1340 -> -g3 - cHG*g3*vev^2,
     gc1341 -> -g3 - cHG*g3*vev^2,
     gc1342 -> -((CKM2x3*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1343 -> -((CKM2x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1344 -> -((CKM2x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1345 -> -((g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2))/Sqrt[2]),
     gc1346 -> -((CKM3x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1347 -> -((CKM3x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1348 -> -((CKM1x3*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1349 -> -((CKM1x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1350 -> -((CKM1x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1351 -> -((CKM2x3*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1352 -> -((CKM2x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1353 -> -((CKM2x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1354 -> -((g2*(CKM3x3 + cHq33x3*vev^2 + cHW*CKM3x3*vev^2))/Sqrt[2]),
     gc1355 -> -((CKM3x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1356 -> -((CKM3x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1357 -> -((CKM1x3*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1358 -> -((CKM1x1*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1359 -> -((CKM1x2*g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1360 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x3])/Sqrt[2]),
     gc1361 -> -((g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3]))/Sqrt[2]),
     gc1362 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x3])/Sqrt[2]),
     gc1363 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x1])/Sqrt[2]),
     gc1364 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM3x1])/Sqrt[2]),
     gc1365 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x1])/Sqrt[2]),
     gc1366 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x2])/Sqrt[2]),
     gc1367 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM3x2])/Sqrt[2]),
     gc1368 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x2])/Sqrt[2]),
     gc1369 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x3])/Sqrt[2]),
     gc1370 -> -((g2*(cHq33x3*vev^2 + Conjugate[CKM3x3] + cHW*vev^2*Conjugate[CKM3x3]))/Sqrt[2]),
     gc1371 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x3])/Sqrt[2]),
     gc1372 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x1])/Sqrt[2]),
     gc1373 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM3x1])/Sqrt[2]),
     gc1374 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x1])/Sqrt[2]),
     gc1375 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM2x2])/Sqrt[2]),
     gc1376 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM3x2])/Sqrt[2]),
     gc1377 -> -((g2*(1 + cHW*vev^2)*Conjugate[CKM1x2])/Sqrt[2]),
     gc1378 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1379 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1380 -> -((g2*(1 + cHl33x3*vev^2 + cHW*vev^2))/Sqrt[2]),
     gc1381 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1382 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1383 -> -((g2*(1 + cHl33x3*vev^2 + cHW*vev^2))/Sqrt[2]),
     gc1384 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1385 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1386 -> -((g2*(1 + cHl33x3*vev^2 + cHW*vev^2))/Sqrt[2]),
     gc1387 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1388 -> -((g2*(1 + cHW*vev^2))/Sqrt[2]),
     gc1389 -> -((g2*(1 + cHl33x3*vev^2 + cHW*vev^2))/Sqrt[2]),
     gc1390 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1391 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2))/12,
     gc1392 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1393 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1394 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 - 3*cHq33x3*vev^2) + 6*cwbar*g2*(-1 + cHq13x3*vev^2 - cHq33x3*vev^2 - cHW*vev^2))/12,
     gc1395 -> (cHWB*cwbar*g1*vev^2 - 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) - 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1396 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2))/12,
     gc1397 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1398 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1399 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2 + 3*cHq13x3*vev^2 + 3*cHq33x3*vev^2) + 6*cwbar*g2*(1 + cHq13x3*vev^2 + cHq33x3*vev^2 + cHW*vev^2))/12,
     gc1400 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1401 -> (cHWB*cwbar*g1*vev^2 + 3*cHWB*g2*swbar*vev^2 + 2*g1*swbar*(1 + cHB*vev^2) + 6*cwbar*g2*(1 + cHW*vev^2))/12,
     gc1402 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1403 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1404 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 + cHl33x3*vev^2) - cwbar*g2*(2 - 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2 + 2*cHW*vev^2))/4,
     gc1405 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1406 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) - 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1407 -> (-(cHWB*cwbar*g1*vev^2) - cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 + cHl33x3*vev^2) - cwbar*g2*(2 - 2*cHl13x3*vev^2 + 2*cHl33x3*vev^2 + 2*cHW*vev^2))/4,
     gc1408 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) + 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1409 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) + 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1410 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2))/4,
     gc1411 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) + 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1412 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2) + 2*cwbar*g2*(1 + cHW*vev^2))/4,
     gc1413 -> (-(cHWB*cwbar*g1*vev^2) + cHWB*g2*swbar*vev^2 - 2*g1*swbar*(1 + cHB*vev^2 - cHl13x3*vev^2 - cHl33x3*vev^2) + 2*cwbar*g2*(1 + cHl13x3*vev^2 + cHl33x3*vev^2 + cHW*vev^2))/4,
     gc1414 -> -((cHl13x3 - cHl33x3)*(cwbar*g1 - g2*swbar)*vev),
     gc1415 -> -((cHl13x3 - cHl33x3)*(cwbar*g1 - g2*swbar)*vev),
     gc1416 -> -((cHl13x3 - cHl33x3)*(cwbar*g1 - g2*swbar)*vev),
     gc1417 -> -((cHl13x3 - cHl33x3)*(cwbar*g1 - g2*swbar)*vev),
     gc1418 -> -1,
     gc1419 -> -1,
     gc1421 -> -1,
     gc1422 -> -1,
     gc1424 -> -cHl13x3 - cHl33x3,
     gc1425 -> -cHl13x3 - cHl33x3,
     gc1426 -> cHl13x3 + cHl33x3,
     gc1427 -> -cHl13x3 - cHl33x3,
     gc1428 -> -(cHl13x3*g2*vev),
     gc1429 -> -(cHl13x3*g2*vev),
     gc1430 -> -(cHl13x3*g2*vev),
     gc1431 -> -(cHl13x3*g2*vev),
     gc1432 -> -(cHl13x3*g2*vev),
     gc1433 -> -(cHl13x3*g2*vev),
     gc1434 -> -(cHl13x3*g2*vev),
     gc1435 -> -(cHl13x3*g2*vev),
     gc1436 -> (cHl13x3 - cHl33x3)*(cwbar*g2 + g1*swbar)*vev,
     gc1437 -> (cHl13x3 - cHl33x3)*(cwbar*g2 + g1*swbar)*vev,
     gc1438 -> (cHl13x3 - cHl33x3)*(cwbar*g2 + g1*swbar)*vev,
     gc1439 -> (cHl13x3 - cHl33x3)*(cwbar*g2 + g1*swbar)*vev,
     gc1440 -> -(1/Sqrt[2]),
     gc1441 -> -(1/Sqrt[2]),
     gc1442 -> -(1/Sqrt[2]),
     gc1443 -> -(1/Sqrt[2]),
     gc1452 -> -(1/Sqrt[2]),
     gc1453 -> -(1/Sqrt[2]),
     gc1454 -> -(1/Sqrt[2]),
     gc1455 -> -(1/Sqrt[2]),
     gc1456 -> 1/Sqrt[2],
     gc1457 -> 1/Sqrt[2],
     gc1458 -> 1/Sqrt[2],
     gc1459 -> 1/Sqrt[2],
     gc1460 -> -1,
     gc1461 -> -1,
     gc1462 -> -1,
     gc1463 -> -1,
     gc1464 -> -1,
     gc1465 -> -1,
     gc1466 -> -1,
     gc1467 -> -1,
     gc1468 -> 1/Sqrt[2],
     gc1469 -> 1/Sqrt[2],
     gc1470 -> 1/Sqrt[2],
     gc1471 -> 1/Sqrt[2],
     gc1472 -> -(1/Sqrt[2]),
     gc1473 -> -(1/Sqrt[2]),
     gc1474 -> -(1/Sqrt[2]),
     gc1475 -> -(1/Sqrt[2]),
     gc1484 -> -(1/Sqrt[2]),
     gc1485 -> -(1/Sqrt[2]),
     gc1486 -> -(1/Sqrt[2]),
     gc1487 -> -(1/Sqrt[2]),
     gc1492 -> Sqrt[2]*cHl33x3,
     gc1493 -> Sqrt[2]*cHl33x3,
     gc1494 -> Sqrt[2]*cHl33x3,
     gc1495 -> Sqrt[2]*cHl33x3,
     gc1508 -> Sqrt[2]*cHl33x3,
     gc1509 -> Sqrt[2]*cHl33x3,
     gc1510 -> Sqrt[2]*cHl33x3,
     gc1511 -> Sqrt[2]*cHl33x3,
     gc1520 -> 1/Sqrt[2],
     gc1521 -> 1/Sqrt[2],
     gc1522 -> 1/Sqrt[2],
     gc1523 -> 1/Sqrt[2],
     gc1524 -> 1/Sqrt[2],
     gc1525 -> 1/Sqrt[2],
     gc1526 -> 1/Sqrt[2],
     gc1527 -> 1/Sqrt[2],
     gc1528 -> 1/Sqrt[2],
     gc1529 -> 1/Sqrt[2],
     gc1530 -> 1/Sqrt[2],
     gc1531 -> 1/Sqrt[2],
     gc1532 -> 1/Sqrt[2],
     gc1533 -> 1/Sqrt[2],
     gc1534 -> 1/Sqrt[2],
     gc1535 -> 1/Sqrt[2],
     gc1536 -> 1/Sqrt[2],
     gc1537 -> 1/Sqrt[2],
     gc1538 -> 1/Sqrt[2],
     gc1539 -> 1/Sqrt[2],
     gc1540 -> 1/Sqrt[2],
     gc1541 -> 1/Sqrt[2],
     gc1542 -> 1/Sqrt[2],
     gc1543 -> 1/Sqrt[2],
     gc1544 -> 1/Sqrt[2],
     gc1545 -> 1/Sqrt[2],
     gc1546 -> 1/Sqrt[2],
     gc1547 -> 1/Sqrt[2],
     gc1548 -> 1/Sqrt[2],
     gc1549 -> 1/Sqrt[2],
     gc1550 -> 1/Sqrt[2],
     gc1551 -> 1/Sqrt[2],
     gc1552 -> 2*cll3x3x3x3,
     gc1553 -> 1/6,
     gc1558 -> 1/6,
     gc1559 -> 1/Sqrt[2],
     gc1560 -> 1/Sqrt[2],
     gc1561 -> 1/Sqrt[2],
     gc1562 -> 1/Sqrt[2],
     gc1563 -> -(1/Sqrt[2]),
     gc1564 -> -(1/Sqrt[2]),
     gc1565 -> -(1/Sqrt[2]),
     gc1566 -> -(1/Sqrt[2]),
     gc1567 -> 1/Sqrt[2],
     gc1568 -> 1/Sqrt[2],
     gc1569 -> 1/Sqrt[2],
     gc1570 -> 1/Sqrt[2],
     gc1571 -> 1/Sqrt[2],
     gc1572 -> 1/Sqrt[2],
     gc1573 -> 1/Sqrt[2],
     gc1574 -> 1/Sqrt[2],
     gc1575 -> 1/Sqrt[2],
     gc1576 -> 1/Sqrt[2],
     gc1577 -> 1/Sqrt[2],
     gc1578 -> 1/Sqrt[2],
     gc1579 -> -(1/Sqrt[2]),
     gc1580 -> -(1/Sqrt[2]),
     gc1581 -> -(1/Sqrt[2]),
     gc1582 -> -(1/Sqrt[2]),
     gc1583 -> 1/Sqrt[2],
     gc1584 -> 1/Sqrt[2],
     gc1585 -> 1/Sqrt[2],
     gc1586 -> 1/Sqrt[2],
     gc1587 -> 1/Sqrt[2],
     gc1588 -> 1/Sqrt[2],
     gc1589 -> 1/Sqrt[2],
     gc1590 -> 1/Sqrt[2],
     gc1591 -> 1/Sqrt[2],
     gc1592 -> 1/Sqrt[2],
     gc1593 -> 1/Sqrt[2],
     gc1594 -> 1/Sqrt[2],
     gc1595 -> 1/Sqrt[2],
     gc1596 -> 1/Sqrt[2],
     gc1597 -> 1/Sqrt[2],
     gc1598 -> 1/Sqrt[2],
     gc1599 -> -((g3*vev)/Sqrt[2]),
     gc1600 -> -((g3*vev)/Sqrt[2]),
     gc1601 -> -((g3*vev)/Sqrt[2]),
     gc1606 -> -1,
     gc1607 -> -1,
     gc1608 -> -1,
     gc1609 -> -1,
     gc1610 -> -(1/Sqrt[2]),
     gc1611 -> -(1/Sqrt[2]),
     gc1612 -> 1/Sqrt[2],
     gc1613 -> 1/Sqrt[2],
     gc1614 -> -(1/Sqrt[2]),
     gc1615 -> -(1/Sqrt[2]),
     gc1616 -> 1/Sqrt[2],
     gc1617 -> 1/Sqrt[2],
     gc1618 -> -((g3*vev)/Sqrt[2]),
     gc1619 -> -((g3*vev)/Sqrt[2]),
     gc1620 -> -((g3*vev)/Sqrt[2]),
     gc1621 -> -((g2*vev)/Sqrt[2]),
     gc1622 -> (g2*vev)/Sqrt[2],
     gc1623 -> -((g2*vev)/Sqrt[2]),
     gc1624 -> -((g2*vev)/Sqrt[2]),
     gc1625 -> (g2*vev)/Sqrt[2],
     gc1626 -> -((g2*vev)/Sqrt[2]),
     gc1627 -> (g2*vev)/Sqrt[2],
     gc1628 -> (g2*vev)/Sqrt[2],
     gc1629 -> -((g2*vev)/Sqrt[2]),
     gc1630 -> (g2*vev)/Sqrt[2],
     gc1631 -> -((g2*vev)/Sqrt[2]),
     gc1632 -> -((g2*vev)/Sqrt[2]),
     gc1633 -> Conjugate[ceW3x3],
     gc1634 -> Conjugate[ceW3x3],
     gc1635 -> Conjugate[ceW3x3],
     gc1636 -> Conjugate[ceW3x3],
     gc1637 -> -(g2*swbar*vev*Conjugate[ceW3x3]),
     gc1638 -> -(g2*swbar*vev*Conjugate[ceW3x3]),
     gc1639 -> -(g2*swbar*vev*Conjugate[ceW3x3]),
     gc1640 -> -(g2*swbar*vev*Conjugate[ceW3x3]),
     gc1641 -> cwbar*g2*vev*Conjugate[ceW3x3],
     gc1642 -> cwbar*g2*vev*Conjugate[ceW3x3],
     gc1643 -> cwbar*g2*vev*Conjugate[ceW3x3],
     gc1644 -> cwbar*g2*vev*Conjugate[ceW3x3],
     gc1645 -> g2*swbar*vev,
     gc1646 -> g2*swbar*vev,
     gc1647 -> g2*swbar*vev,
     gc1648 -> g2*swbar*vev,
     gc1649 -> -(cwbar*g2*vev),
     gc1650 -> -(cwbar*g2*vev),
     gc1651 -> -(cwbar*g2*vev),
     gc1652 -> -(cwbar*g2*vev),
     gc1653 -> -(g2*swbar*vev),
     gc1654 -> -(g2*swbar*vev),
     gc1655 -> -(g2*swbar*vev),
     gc1656 -> -(g2*swbar*vev),
     gc1657 -> cwbar*g2*vev,
     gc1658 -> cwbar*g2*vev,
     gc1659 -> cwbar*g2*vev,
     gc1660 -> cwbar*g2*vev,
     gc1661 -> -ceW3x3,
     gc1662 -> -ceW3x3,
     gc1663 -> -ceW3x3,
     gc1664 -> -ceW3x3,
     gc1665 -> ceW3x3*g2*swbar*vev,
     gc1666 -> ceW3x3*g2*swbar*vev,
     gc1667 -> ceW3x3*g2*swbar*vev,
     gc1668 -> ceW3x3*g2*swbar*vev,
     gc1669 -> -(ceW3x3*cwbar*g2*vev),
     gc1670 -> -(ceW3x3*cwbar*g2*vev),
     gc1671 -> -(ceW3x3*cwbar*g2*vev),
     gc1672 -> -(ceW3x3*cwbar*g2*vev)};

